# NLPModels

| **Documentation** | **CI** | **Coverage** | **Release** | **DOI** |
|:-----------------:|:------:|:------------:|:-----------:|:-------:|
| [![docs-stable][docs-stable-img]][docs-stable-url] [![docs-dev][docs-dev-img]][docs-dev-url] | [![build-gh][build-gh-img]][build-gh-url] [![build-cirrus][build-cirrus-img]][build-cirrus-url] | [![codecov][codecov-img]][codecov-url] | [![release][release-img]][release-url] | [![doi][doi-img]][doi-url] |

[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://JuliaSmoothOptimizers.github.io/NLPModels.jl/stable
[docs-dev-img]: https://img.shields.io/badge/docs-dev-purple.svg
[docs-dev-url]: https://JuliaSmoothOptimizers.github.io/NLPModels.jl/dev
[build-gh-img]: https://github.com/JuliaSmoothOptimizers/NLPModels.jl/workflows/CI/badge.svg?branch=main
[build-gh-url]: https://github.com/JuliaSmoothOptimizers/NLPModels.jl/actions
[build-cirrus-img]: https://img.shields.io/cirrus/github/JuliaSmoothOptimizers/NLPModels.jl?logo=Cirrus%20CI
[build-cirrus-url]: https://cirrus-ci.com/github/JuliaSmoothOptimizers/NLPModels.jl
[codecov-img]: https://codecov.io/gh/JuliaSmoothOptimizers/NLPModels.jl/branch/main/graph/badge.svg
[codecov-url]: https://codecov.io/gh/JuliaSmoothOptimizers/NLPModels.jl
[release-img]: https://img.shields.io/github/v/release/JuliaSmoothOptimizers/NLPModels.jl.svg?style=flat-square
[release-url]: https://github.com/JuliaSmoothOptimizers/NLPModels.jl/releases
[doi-img]: https://zenodo.org/badge/DOI/10.5281/zenodo.2558627.svg
[doi-url]: https://doi.org/10.5281/zenodo.2558627

This package provides general guidelines to represent non-linear programming (NLP)
problems in Julia and a standardized API to evaluate the functions and
their derivatives. The main objective is to be able to rely on that API when
designing optimization solvers in Julia.

## How to Cite

If you use NLPModels.jl in your work, please cite using the format given in [CITATION.cff](https://github.com/JuliaSmoothOptimizers/NLPModels.jl/blob/main/CITATION.cff).

## Optimization Problems

Optimization problems are represented by an instance of (a subtype of) `AbstractNLPModel`.
Such instances are composed of
* an instance of `NLPModelMeta`, which provides information about the problem, including the number of variables, constraints, bounds on the variables, etc.
* other data specific to the provenance of the problem.

See the
[documentation](https://JuliaSmoothOptimizers.github.io/NLPModels.jl/dev) for
details on the models and the API.

## Installation

```julia
pkg> add NLPModels
```

## Models

This package provides no models, although it allows the definition of manually written models.

Check the list of packages that define models in [this page of the docs](https://JuliaSmoothOptimizers.github.io/NLPModels.jl/dev/models)

## Main Methods

If `model` is an instance of an appropriate subtype of `AbstractNLPModel`, the following methods are normally defined:

* `obj(model, x)`: evaluate *f(x)*, the objective at `x`
* `cons(model x)`: evaluate *c(x)*, the vector of general constraints at `x`

The following methods are defined if first-order derivatives are available:

* `grad(model, x)`: evaluate *∇f(x)*, the objective gradient at `x`
* `jac(model, x)`: evaluate *J(x)*, the Jacobian of *c* at `x` as a sparse matrix

If Jacobian-vector products can be computed more efficiently than by evaluating the Jacobian explicitly, the following methods may be implemented:

* `jprod(model, x, v)`: evaluate the result of the matrix-vector product *J(x)⋅v*
* `jtprod(model, x, u)`: evaluate the result of the matrix-vector product *J(x)ᵀ⋅u*

The following method is defined if second-order derivatives are available:

* `hess(model, x, y)`: evaluate *∇²L(x,y)*, the Hessian of the Lagrangian at `x` and `y` as a sparse matrix

If Hessian-vector products can be computed more efficiently than by evaluating the Hessian explicitly, the following method may be implemented:

* `hprod(model, x, v, y)`: evaluate the result of the matrix-vector product *∇²L(x,y)⋅v*

Several in-place variants of the methods above may also be implemented.

The complete list of methods that an interface may implement can be found in the documentation.

## Attributes

`NLPModelMeta` objects have the following attributes (with `S <: AbstractVector`):

Attribute          | Type          | Notes
-------------------|---------------|------------------------------------
`nvar`             | `Int`         | number of variables
`x0  `             | `S`           | initial guess
`lvar`             | `S`           | vector of lower bounds
`uvar`             | `S`           | vector of upper bounds
`ifix`             | `Vector{Int}` | indices of fixed variables
`ilow`             | `Vector{Int}` | indices of variables with lower bound only
`iupp`             | `Vector{Int}` | indices of variables with upper bound only
`irng`             | `Vector{Int}` | indices of variables with lower and upper bound (range)
`ifree`            | `Vector{Int}` | indices of free variables
`iinf`             | `Vector{Int}` | indices of visibly infeasible bounds
`ncon`             | `Int`         | total number of general constraints
`nlin `            | `Int`         | number of linear constraints
`nnln`             | `Int`         | number of nonlinear general constraints
`y0  `             | `S`           | initial Lagrange multipliers
`lcon`             | `S`           | vector of constraint lower bounds
`ucon`             | `S`           | vector of constraint upper bounds
`lin `             | `Vector{Int}` | indices of linear constraints
`nln`              | `Vector{Int}` | indices of nonlinear constraints
`jfix`             | `Vector{Int}` | indices of equality constraints
`jlow`             | `Vector{Int}` | indices of constraints of the form c(x) ≥ cl
`jupp`             | `Vector{Int}` | indices of constraints of the form c(x) ≤ cu
`jrng`             | `Vector{Int}` | indices of constraints of the form cl ≤ c(x) ≤ cu
`jfree`            | `Vector{Int}` | indices of "free" constraints (there shouldn't be any)
`jinf`             | `Vector{Int}` | indices of the visibly infeasible constraints
`nnzo`             | `Int`         | number of nonzeros in the gradient
`nnzj`             | `Int`         | number of nonzeros in the Jacobian
`lin_nnzj`         | `Int`         | number of nonzeros in the linear constraints Jacobian
`nln_nnzj`         | `Int`         | number of nonzeros in the nonlinear constraints Jacobian
`nnzh`             | `Int`         | number of nonzeros in the lower triangular part of the Hessian of the Lagrangian
`minimize`         | `Bool`        | true if `optimize == minimize`
`islp`             | `Bool`        | true if the problem is a linear program
`name`             | `String`      | problem name
`variable_bounds_analysis` | `Bool` | true if the partition of variables into fixed, lower-bounded, upper-bounded, range-bounded, free, and trivially infeasible sets is computed
`constraint_bounds_analysis`| `Bool` | true if the partition of constraints into equality, lower-bounded, upper-bounded, range-bounded, free, and trivially infeasible sets is computed
`sparse_jacobian`  | `Bool`        | true if the Jacobian of the constraints is sparse
`sparse_hessian`   | `Bool`        | true if the Hessian of the Lagrangian is sparse
`grad_available`   | `Bool`        | true if the gradient of the objective is available
`jac_available`    | `Bool`        | true if the Jacobian of the constraints is available
`hess_available`   | `Bool`        | true if the Hessian of the Lagrangian is available
`jprod_available`  | `Bool`        | true if the Jacobian-vector product `J * v` is available
`jtprod_available` | `Bool`        | true if the transpose Jacobian-vector product `J' * v` is available
`hprod_available`  | `Bool`        | true if the Hessian-vector product of the Lagrangian `H * v` is available

# Bug reports and discussions

If you think you found a bug, feel free to open an [issue](https://github.com/JuliaSmoothOptimizers/NLPModels.jl/issues).
Focused suggestions and requests can also be opened as issues. Before opening a pull request, start an issue or a discussion on the topic, please.

If you want to ask a question not suited for a bug report, feel free to start a discussion [here](https://github.com/JuliaSmoothOptimizers/Organization/discussions). This forum is for general discussion about this repository and the [JuliaSmoothOptimizers](https://github.com/JuliaSmoothOptimizers), so questions about any of our packages are welcome.

export NLSCounters

"""
    NLSCounters

Struct for storing the number of functions evaluations for nonlinear least-squares models.
NLSCounters also stores a `Counters` instance named `counters`.

---

    NLSCounters()

Creates an empty NLSCounters struct.
"""
mutable struct NLSCounters
  counters::Counters
  neval_residual::Int
  neval_jac_residual::Int
  neval_jprod_residual::Int
  neval_jtprod_residual::Int
  neval_hess_residual::Int
  neval_jhess_residual::Int
  neval_hprod_residual::Int

  function NLSCounters()
    return new(Counters(), 0, 0, 0, 0, 0, 0, 0)
  end
end

function Base.getproperty(c::NLSCounters, f::Symbol)
  if f in fieldnames(Counters)
    getfield(c.counters, f)
  else
    getfield(c, f)
  end
end

function Base.setproperty!(c::NLSCounters, f::Symbol, x)
  if f in fieldnames(Counters)
    setfield!(c.counters, f, x)
  else
    setfield!(c, f, x)
  end
end

function sum_counters(c::NLSCounters)
  s = sum_counters(c.counters)
  for field in fieldnames(NLSCounters)
    field == :counters && continue
    s += getfield(c, field)
  end
  return s
end
sum_counters(nls::AbstractNLSModel) = sum_counters(get_counters(nls))

for counter in fieldnames(NLSCounters)
  counter == :counters && continue
  @eval begin
    """
        $($counter)(nlp)

    Get the number of `$(split("$($counter)", "_")[2])` evaluations.
    """
    $counter(nls::AbstractNLSModel) = get_counters(nls).$counter
    export $counter
  end
end

for counter in fieldnames(Counters)
  @eval begin
    $counter(nls::AbstractNLSModel) = get_counters(nls).counters.$counter
    export $counter
  end
end

"""
    increment!(nls, s)

Increment counter `s` of problem `nls`.
"""
@inline function increment!(nls::AbstractNLSModel, s::Symbol)
  increment!(nls, Val(s))
end

for fun in fieldnames(NLSCounters)
  fun == :counters && continue
  @eval increment!(nls::AbstractNLSModel, ::Val{$(Meta.quot(fun))}) = get_counters(nls).$fun += 1
end

for fun in fieldnames(Counters)
  @eval $NLPModels.increment!(nls::AbstractNLSModel, ::Val{$(Meta.quot(fun))}) =
    get_counters(nls).counters.$fun += 1
end

function LinearOperators.reset!(nls::AbstractNLSModel)
  reset!(get_counters(nls))
  return nls
end

function LinearOperators.reset!(nls_counters::NLSCounters)
  for f in fieldnames(NLSCounters)
    f == :counters && continue
    setfield!(nls_counters, f, 0)
  end
  reset!(nls_counters.counters)
  return nls_counters
end

export Counters, get_counters, sum_counters, increment!, decrement!, reset!

"""
    Counters

Struct for storing the number of function evaluations.

---

    Counters()

Creates an empty Counters struct.
"""
mutable struct Counters
  neval_obj::Int  # Number of objective evaluations.
  neval_grad::Int  # Number of objective gradient evaluations.
  neval_cons::Int  # Number of constraint vector evaluations.
  neval_cons_lin::Int  # Number of linear constraint vector evaluations.
  neval_cons_nln::Int  # Number of nonlinear constraint vector evaluations.
  neval_jcon::Int  # Number of individual constraint evaluations.
  neval_jgrad::Int  # Number of individual constraint gradient evaluations.
  neval_jac::Int  # Number of constraint Jacobian evaluations.
  neval_jac_lin::Int  # Number of linear constraints Jacobian evaluations.
  neval_jac_nln::Int  # Number of nonlinear constraints Jacobian evaluations.
  neval_jprod::Int  # Number of Jacobian-vector products.
  neval_jprod_lin::Int  # Number of linear constraints Jacobian-vector products.
  neval_jprod_nln::Int  # Number of nonlinear constraints Jacobian-vector products.
  neval_jtprod::Int  # Number of transposed Jacobian-vector products.
  neval_jtprod_lin::Int  # Number of transposed linear constraints Jacobian-vector products.
  neval_jtprod_nln::Int  # Number of transposed nonlinear constraints Jacobian-vector products.
  neval_hess::Int  # Number of Lagrangian/objective Hessian evaluations.
  neval_hprod::Int  # Number of Lagrangian/objective Hessian-vector products.
  neval_jhess::Int  # Number of individual Lagrangian Hessian evaluations.
  neval_jhprod::Int  # Number of individual constraint Hessian-vector products.

  function Counters()
    return new(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
  end
end

# simple default API for retrieving counters

# For backward compatibility.
# In the future, forcing this method to raise an error if not implemented
# would be more robust.
"""
        get_counters(nlp)

Return the `Counters` struct associated with `nlp`.
By default, this is `nlp.counters`, but it can be overridden in concrete models.
"""
get_counters(nlp::AbstractNLPModel) = nlp.counters

for counter in fieldnames(Counters)
  @eval begin
    """
        $($counter)(nlp)

    Get the number of `$(split("$($counter)", "_")[2])` evaluations.
    """
    $counter(nlp::AbstractNLPModel) = get_counters(nlp).$counter
    export $counter
  end
end

"""
    increment!(nlp, s)

Increment counter `s` of problem `nlp`.
"""
@inline function increment!(nlp::AbstractNLPModel, s::Symbol)
  increment!(nlp, Val(s))
end

for fun in fieldnames(Counters)
  @eval increment!(nlp::AbstractNLPModel, ::Val{$(Meta.quot(fun))}) = get_counters(nlp).$fun += 1
end

"""
    decrement!(nlp, s)

Decrement counter `s` of problem `nlp`.
"""
function decrement!(nlp::AbstractNLPModel, s::Symbol)
  counters = get_counters(nlp)
  setproperty!(counters, s, getproperty(counters, s) - 1)
end

"""
    sum_counters(counters)

Sum all counters of `counters` except `cons`, `jac`, `jprod` and `jtprod`.
"""
function sum_counters(c::Counters)
  sum = 0
  for x in fieldnames(Counters)
    if !(x in (:neval_cons, :neval_jac, :neval_jprod, :neval_jtprod))
      sum += getproperty(c, x)
    end
  end
  return sum
end
"""
    sum_counters(nlp)

Sum all counters of problem `nlp` except `cons`, `jac`, `jprod` and `jtprod`.
"""
sum_counters(nlp::AbstractNLPModel) = sum_counters(get_counters(nlp))

"""
    reset!(counters)

Reset evaluation counters
"""
function LinearOperators.reset!(counters::Counters)
  for f in fieldnames(Counters)
    setfield!(counters, f, 0)
  end
  return counters
end

"""
    reset!(nlp)

Reset evaluation count and model data (if appropriate) in `nlp`.
"""
function LinearOperators.reset!(nlp::AbstractNLPModel)
  reset!(get_counters(nlp))
  reset_data!(nlp)
  return nlp
end

export AbstractBatchNLPModelMeta, BatchNLPModelMeta

"""
    AbstractBatchNLPModelMeta

Abstract base type for metadata related to batched nonlinear optimization models.
"""
abstract type AbstractBatchNLPModelMeta{T, S} end

"""
    BatchNLPModelMeta <: AbstractBatchNLPModelMeta

A composite type that represents the main features of a batch of
nonlinear optimization problems sharing the same structure.

Each batch contains `nbatch` independent NLP models of the form:

    optimize    objᵢ(x)
    subject to  lvarᵢ ≤    x     ≤ uvarᵢ
                lconᵢ ≤ consᵢ(x) ≤ uconᵢ

for i = 1, ..., nbatch.

Each model variable vector `x` has dimension `nvar`, and constraint vector
`consᵢ(x)` has dimension `ncon`.

All batch data are stored in matrices of size:

- `(nvar, nbatch)` for variables and bounds (`x0`, `lvar`, `uvar`)
- `(ncon, nbatch)` for constraints and multipliers (`y0`, `lcon`, `ucon`)

---

    BatchNLPModelMeta(nbatch::Int, nvar::Int; kwargs...)

Create a `BatchNLPModelMeta` with `nbatch` models, each having `nvar` variables.
The following keyword arguments are accepted:
- `x0`: initial guess
- `lvar`: matrix of lower bounds
- `uvar`: matrix of upper bounds
- `ncon`: number of general constraints
- `y0`: initial Lagrange multipliers
- `lcon`: matrix of constraint lower bounds
- `ucon`: matrix of constraint upper bounds
- `nnzj`: number of elements needed to store the nonzeros in the sparse Jacobian
- `nnzh`: number of elements needed to store the nonzeros in the sparse Hessian
- `minimize`: true if optimize == minimize
- `islp`: true if the problems are linear programs
- `name`: problem name for the batch
- `sparse_jacobian`: indicates whether the Jacobian of the constraints is sparse
- `sparse_hessian`: indicates whether the Hessian of the Lagrangian is sparse
- `grad_available`: indicates whether the gradient of the objective is available
- `jac_available`: indicates whether the Jacobian of the constraints is available
- `hess_available`: indicates whether the Hessian of the Lagrangian is available
- `jprod_available`: indicates whether the Jacobian-vector product `J * v` is available
- `jtprod_available`: indicates whether the transpose Jacobian-vector product `J' * v` is available
- `hprod_available`: indicates whether the Hessian-vector product of the Lagrangian `H * v` is available
"""
struct BatchNLPModelMeta{T, S} <: AbstractBatchNLPModelMeta{T, S}
  nbatch::Int
  nvar::Int
  x0::S
  lvar::S
  uvar::S
  ncon::Int
  y0::S
  lcon::S
  ucon::S
  nnzj::Int
  nnzh::Int
  minimize::Bool
  islp::Bool
  name::String
  sparse_jacobian::Bool
  sparse_hessian::Bool
  grad_available::Bool
  jac_available::Bool
  hess_available::Bool
  jprod_available::Bool
  jtprod_available::Bool
  hprod_available::Bool
end

for field in fieldnames(BatchNLPModelMeta)
  meth = Symbol("get_", field)
  @eval begin
    $meth(meta::AbstractBatchNLPModelMeta) = getproperty(meta, $(QuoteNode(field)))
  end
  @eval $meth(bnlp::AbstractBatchNLPModel) = $meth(bnlp.meta)
  @eval export $meth
end

function BatchNLPModelMeta{T, S}(
  nbatch::Int,
  nvar::Int;
  x0::S = fill!(S(undef, nvar, nbatch), zero(T)),
  lvar::S = fill!(S(undef, nvar, nbatch), T(-Inf)),
  uvar::S = fill!(S(undef, nvar, nbatch), T(Inf)),
  ncon::Int = 0,
  y0::S = fill!(S(undef, ncon, nbatch), zero(T)),
  lcon::S = fill!(S(undef, ncon, nbatch), T(-Inf)),
  ucon::S = fill!(S(undef, ncon, nbatch), T(Inf)),
  nnzj::Int = nvar * ncon,
  nnzh::Int = nvar * (nvar + 1) ÷ 2,
  minimize::Bool = true,
  islp::Bool = false,
  name::String = "Batch NLP",
  sparse_jacobian::Bool = true,
  sparse_hessian::Bool = true,
  grad_available::Bool = true,
  jac_available::Bool = (ncon > 0),
  hess_available::Bool = true,
  jprod_available::Bool = (ncon > 0),
  jtprod_available::Bool = (ncon > 0),
  hprod_available::Bool = true,
) where {T, S}
  if (nbatch < 1) || (nvar < 1) || (ncon < 0) || (nnzj < 0) || (nnzh < 0)
    error("Nonsensical dimensions")
  end

  BatchNLPModelMeta{T, S}(
    nbatch,
    nvar,
    x0,
    lvar,
    uvar,
    ncon,
    y0,
    lcon,
    ucon,
    nnzj,
    nnzh,
    minimize,
    islp,
    name,
    sparse_jacobian,
    sparse_hessian,
    grad_available,
    jac_available,
    hess_available,
    jprod_available,
    jtprod_available,
    hprod_available,
  )
end

export residual, residual!, jac_residual, jac_structure_residual, jac_structure_residual!
export jac_coord_residual!, jac_coord_residual, jprod_residual, jprod_residual!
export jtprod_residual, jtprod_residual!, jac_op_residual, jac_op_residual!
export hess_residual, hess_structure_residual, hess_structure_residual!
export hess_coord_residual!,
  hess_coord_residual, jth_hess_residual, jth_hess_residual_coord, jth_hess_residual_coord!
export hprod_residual, hprod_residual!, hess_op_residual, hess_op_residual!

"""
    Fx = residual(nls, x)

Computes ``F(x)``, the residual at x.
"""
function residual(nls::AbstractNLSModel{T, S}, x::AbstractVector) where {T, S}
  @lencheck nls.meta.nvar x
  Fx = S(undef, nls_meta(nls).nequ)
  residual!(nls, x, Fx)
end

"""
    Fx = residual!(nls, x, Fx)

Computes ``F(x)``, the residual at x.
"""
function residual! end

"""
    Jx = jac_residual(nls, x)

Computes ``J(x)``, the Jacobian of the residual at x.
This function is only available if `nls_meta(nls).jac_residual_available` is set to `true`.
"""
function jac_residual(nls::AbstractNLSModel, x::AbstractVector)
  @lencheck nls.meta.nvar x
  rows, cols = jac_structure_residual(nls)
  vals = jac_coord_residual(nls, x)
  sparse(rows, cols, vals, nls.nls_meta.nequ, nls.meta.nvar)
end

"""
    (rows,cols) = jac_structure_residual!(nls, rows, cols)

Returns the structure of the constraint's Jacobian in sparse coordinate format in place.
This function is only available if `nls_meta(nls).jac_residual_available` is set to `true`.
"""
function jac_structure_residual! end

"""
    (rows,cols) = jac_structure_residual(nls)

Returns the structure of the constraint's Jacobian in sparse coordinate format.
This function is only available if `nls_meta(nls).jac_residual_available` is set to `true`.
"""
function jac_structure_residual(nls::AbstractNLSModel)
  rows = Vector{Int}(undef, nls.nls_meta.nnzj)
  cols = Vector{Int}(undef, nls.nls_meta.nnzj)
  jac_structure_residual!(nls, rows, cols)
end

"""
    vals = jac_coord_residual!(nls, x, vals)

Computes the Jacobian of the residual at `x` in sparse coordinate format, rewriting
`vals`. `rows` and `cols` are not rewritten.
This function is only available if `nls_meta(nls).jac_residual_available` is set to `true`.
"""
function jac_coord_residual! end

"""
    (rows,cols,vals) = jac_coord_residual(nls, x)

Computes the Jacobian of the residual at `x` in sparse coordinate format.
This function is only available if `nls_meta(nls).jac_residual_available` is set to `true`.
"""
function jac_coord_residual(nls::AbstractNLSModel{T, S}, x::AbstractVector) where {T, S}
  @lencheck nls.meta.nvar x
  vals = S(undef, nls.nls_meta.nnzj)
  jac_coord_residual!(nls, x, vals)
end

"""
    Jv = jprod_residual(nls, x, v)

Computes the product of the Jacobian of the residual at x and a vector, i.e.,  ``J(x)v``.
This function is only available if `nls_meta(nls).jprod_residual_available` is set to `true`.
"""
function jprod_residual(
  nls::AbstractNLSModel{T, S},
  x::AbstractVector,
  v::AbstractVector,
) where {T, S}
  @lencheck nls.meta.nvar x v
  Jv = S(undef, nls_meta(nls).nequ)
  jprod_residual!(nls, x, v, Jv)
end

"""
    Jv = jprod_residual!(nls, x, v, Jv)

Computes the product of the Jacobian of the residual at x and a vector, i.e., ``J(x)v``, storing it in `Jv`.
This function is only available if `nls_meta(nls).jprod_residual_available` is set to `true`.
"""
function jprod_residual! end

"""
    Jv = jprod_residual!(nls, rows, cols, vals, v, Jv)

Computes the product of the Jacobian of the residual given by `(rows, cols, vals)`
and a vector, i.e., ``J(x)v``, storing it in `Jv`.
This function is only available if `nls_meta(nls).jprod_residual_available` is set to `true`.
"""
function jprod_residual!(
  nls::AbstractNLSModel,
  rows::AbstractVector{<:Integer},
  cols::AbstractVector{<:Integer},
  vals::AbstractVector,
  v::AbstractVector,
  Jv::AbstractVector,
)
  @lencheck nls.nls_meta.nnzj rows cols vals
  @lencheck nls.meta.nvar v
  @lencheck nls.nls_meta.nequ Jv
  increment!(nls, :neval_jprod_residual)
  coo_prod!(rows, cols, vals, v, Jv)
end

"""
    Jtv = jtprod_residual(nls, x, v)

Computes the product of the transpose of the Jacobian of the residual at x and a vector, i.e., ``J(x)^Tv``.
This function is only available if `nls_meta(nls).jtprod_residual_available` is set to `true`.
"""
function jtprod_residual(
  nls::AbstractNLSModel{T, S},
  x::AbstractVector,
  v::AbstractVector,
) where {T, S}
  @lencheck nls.meta.nvar x
  @lencheck nls.nls_meta.nequ v
  Jtv = S(undef, nls_meta(nls).nvar)
  jtprod_residual!(nls, x, v, Jtv)
end

"""
    Jtv = jtprod_residual!(nls, x, v, Jtv)

Computes the product of the transpose of the Jacobian of the residual at x and a vector, i.e., ``J(x)^Tv``, storing it in `Jtv`.
This function is only available if `nls_meta(nls).jtprod_residual_available` is set to `true`.
"""
function jtprod_residual! end

"""
    Jtv = jtprod_residual!(nls, rows, cols, vals, v, Jtv)

Computes the product of the transpose of the Jacobian of the residual given by `(rows, cols, vals)`
and a vector, i.e., ``J(x)^Tv``, storing it in `Jv`.
This function is only available if `nls_meta(nls).jtprod_residual_available` is set to `true`.
"""
function jtprod_residual!(
  nls::AbstractNLSModel,
  rows::AbstractVector{<:Integer},
  cols::AbstractVector{<:Integer},
  vals::AbstractVector,
  v::AbstractVector,
  Jtv::AbstractVector,
)
  @lencheck nls.nls_meta.nnzj rows cols vals
  @lencheck nls.nls_meta.nequ v
  @lencheck nls.meta.nvar Jtv
  increment!(nls, :neval_jtprod_residual)
  coo_prod!(cols, rows, vals, v, Jtv)
end

"""
    Jx = jac_op_residual(nls, x)

Computes ``J(x)``, the Jacobian of the residual at x, in linear operator form.
This function is only available if both `nls_meta(nls).jprod_residual_available` and `nls_meta(nls).jtprod_residual_available` are set to `true`.
"""
function jac_op_residual(nls::AbstractNLSModel{T, S}, x::AbstractVector) where {T, S}
  @lencheck nls.meta.nvar x
  Jv = S(undef, nls_meta(nls).nequ)
  Jtv = S(undef, nls.meta.nvar)
  return jac_op_residual!(nls, x, Jv, Jtv)
end

"""
    Jx = jac_op_residual!(nls, x, Jv, Jtv)

Computes ``J(x)``, the Jacobian of the residual at x, in linear operator form. The
vectors `Jv` and `Jtv` are used as preallocated storage for the operations.
This function is only available if both `nls_meta(nls).jprod_residual_available` and `nls_meta(nls).jtprod_residual_available` are set to `true`.
"""
function jac_op_residual!(
  nls::AbstractNLSModel{T, S},
  x::AbstractVector,
  Jv::AbstractVector,
  Jtv::AbstractVector,
) where {T, S}
  @lencheck nls.meta.nvar x Jtv
  @lencheck nls.nls_meta.nequ Jv
  prod! = @closure (res, v, α, β) -> begin
    jprod_residual!(nls, x, v, Jv)
    if β == 0
      res .= α .* Jv
    else
      res .= α .* Jv .+ β .* res
    end
    return res
  end
  ctprod! = @closure (res, v, α, β) -> begin
    jtprod_residual!(nls, x, v, Jtv)
    if β == 0
      res .= α .* Jtv
    else
      res .= α .* Jtv .+ β .* res
    end
    return res
  end
  return LinearOperator{T, S}(
    nls_meta(nls).nequ,
    nls_meta(nls).nvar,
    false,
    false,
    prod!,
    ctprod!,
    ctprod!,
  )
end

"""
    Jx = jac_op_residual!(nls, rows, cols, vals, Jv, Jtv)

Computes ``J(x)``, the Jacobian of the residual given by `(rows, cols, vals)`, in linear operator form. The
vectors `Jv` and `Jtv` are used as preallocated storage for the operations.
This function is only available if both `nls_meta(nls).jprod_residual_available` and `nls_meta(nls).jtprod_residual_available` are set to `true`.
"""
function jac_op_residual!(
  nls::AbstractNLSModel{T, S},
  rows::AbstractVector{<:Integer},
  cols::AbstractVector{<:Integer},
  vals::AbstractVector,
  Jv::AbstractVector,
  Jtv::AbstractVector,
) where {T, S}
  @lencheck nls.nls_meta.nnzj rows cols vals
  @lencheck nls.nls_meta.nequ Jv
  @lencheck nls.meta.nvar Jtv
  prod! = @closure (res, v, α, β) -> begin
    jprod_residual!(nls, rows, cols, vals, v, Jv)
    if β == 0
      res .= α .* Jv
    else
      res .= α .* Jv .+ β .* res
    end
    return res
  end
  ctprod! = @closure (res, v, α, β) -> begin
    jtprod_residual!(nls, rows, cols, vals, v, Jtv)
    if β == 0
      res .= α .* Jtv
    else
      res .= α .* Jtv .+ β .* res
    end
    return res
  end
  return LinearOperator{T, S}(
    nls_meta(nls).nequ,
    nls_meta(nls).nvar,
    false,
    false,
    prod!,
    ctprod!,
    ctprod!,
  )
end

"""
    H = hess_residual(nls, x, v)

Computes the linear combination of the Hessians of the residuals at `x` with coefficients `v`.
A `Symmetric` object wrapping the lower triangle is returned.
This function is only available if `nls_meta(nls).hess_residual_available` is set to `true`.
"""
function hess_residual(nls::AbstractNLSModel, x::AbstractVector, v::AbstractVector)
  @lencheck nls.meta.nvar x
  @lencheck nls.nls_meta.nequ v
  rows, cols = hess_structure_residual(nls)
  vals = hess_coord_residual(nls, x, v)
  Symmetric(sparse(rows, cols, vals, nls.meta.nvar, nls.meta.nvar), :L)
end

"""
    (rows,cols) = hess_structure_residual(nls)

Returns the structure of the residual Hessian.
This function is only available if `nls_meta(nls).hess_residual_available` is set to `true`.
"""
function hess_structure_residual(nls::AbstractNLSModel)
  rows = Vector{Int}(undef, nls.nls_meta.nnzh)
  cols = Vector{Int}(undef, nls.nls_meta.nnzh)
  hess_structure_residual!(nls, rows, cols)
end

"""
    hess_structure_residual!(nls, rows, cols)

Returns the structure of the residual Hessian in place.
This function is only available if `nls_meta(nls).hess_residual_available` is set to `true`.
"""
function hess_structure_residual! end

"""
    vals = hess_coord_residual!(nls, x, v, vals)

Computes the linear combination of the Hessians of the residuals at `x` with coefficients
`v` in sparse coordinate format, rewriting `vals`.
This function is only available if `nls_meta(nls).hess_residual_available` is set to `true`.
"""
function hess_coord_residual! end

"""
    vals = hess_coord_residual(nls, x, v)

Computes the linear combination of the Hessians of the residuals at `x` with coefficients
`v` in sparse coordinate format.
This function is only available if `nls_meta(nls).hess_residual_available` is set to `true`.
"""
function hess_coord_residual(
  nls::AbstractNLSModel{T, S},
  x::AbstractVector,
  v::AbstractVector,
) where {T, S}
  @lencheck nls.meta.nvar x
  @lencheck nls.nls_meta.nequ v
  vals = S(undef, nls.nls_meta.nnzh)
  hess_coord_residual!(nls, x, v, vals)
end

"""
    Hj = jth_hess_residual(nls, x, j)

Computes the Hessian of the j-th residual at x.
"""
function jth_hess_residual(nls::AbstractNLSModel{T, S}, x::AbstractVector, j::Int) where {T, S}
  @lencheck nls.meta.nvar x
  @rangecheck 1 nls.nls_meta.nequ j
  rows, cols = hess_structure_residual(nls)
  vals = jth_hess_residual_coord(nls, x, j)
  return Symmetric(sparse(rows, cols, vals, nls.meta.nvar, nls.meta.nvar), :L)
end

"""
    vals = jth_hess_residual_coord(nls, x, j)

Evaluate the Hessian of j-th residual at `x` in sparse coordinate format.
Only the lower triangle is returned.
"""
function jth_hess_residual_coord(
  nls::AbstractNLSModel{T, S},
  x::AbstractVector,
  j::Int,
) where {T, S}
  @lencheck nls.meta.nvar x
  @rangecheck 1 nls.nls_meta.nequ j
  vals = S(undef, nls.nls_meta.nnzh)
  return jth_hess_residual_coord!(nls, x, j, vals)
end

"""
    vals = jth_hess_residual_coord!(nls, x, j, vals)

Evaluate the Hessian of j-th residual at `x` in sparse coordinate format, with `vals` of
length `nls.nls_meta.nnzh`, in place. Only the lower triangle is returned.
"""
function jth_hess_residual_coord!(
  nls::AbstractNLSModel{T, S},
  x::AbstractVector,
  j::Int,
  vals::AbstractVector,
) where {T, S}
  @lencheck nls.meta.nvar x
  @rangecheck 1 nls.nls_meta.nequ j
  @lencheck nls.nls_meta.nnzh vals
  increment!(nls, :neval_jhess_residual)
  decrement!(nls, :neval_hess_residual)
  v = [i == j ? one(T) : zero(T) for i = 1:(nls.nls_meta.nequ)]
  return hess_coord_residual!(nls, x, v, vals)
end

"""
    Hiv = hprod_residual(nls, x, i, v)

Computes the product of the Hessian of the i-th residual at x, times the vector v.
This function is only available if `nls_meta(nls).hprod_residual_available` is set to `true`.
"""
function hprod_residual(
  nls::AbstractNLSModel{T, S},
  x::AbstractVector,
  i::Int,
  v::AbstractVector,
) where {T, S}
  @lencheck nls.meta.nvar x v
  @rangecheck 1 nls.nls_meta.nequ i
  Hv = S(undef, nls.meta.nvar)
  hprod_residual!(nls, x, i, v, Hv)
end

"""
    Hiv = hprod_residual!(nls, x, i, v, Hiv)

Computes the product of the Hessian of the i-th residual at x, times the vector v, and stores it in vector Hiv.
This function is only available if `nls_meta(nls).hprod_residual_available` is set to `true`.
"""
function hprod_residual! end

"""
    Hop = hess_op_residual(nls, x, i)

Computes the Hessian of the i-th residual at x, in linear operator form.
"""
function hess_op_residual(nls::AbstractNLSModel{T, S}, x::AbstractVector, i::Int) where {T, S}
  @lencheck nls.meta.nvar x
  @rangecheck 1 nls.nls_meta.nequ i
  Hiv = S(undef, nls.meta.nvar)
  return hess_op_residual!(nls, x, i, Hiv)
end

"""
    Hop = hess_op_residual!(nls, x, i, Hiv)

Computes the Hessian of the i-th residual at x, in linear operator form. The vector `Hiv` is used as preallocated storage for the operation.
This function is only available if `nls_meta(nls).hprod_residual_available` is set to `true`.
"""
function hess_op_residual!(
  nls::AbstractNLSModel{T, S},
  x::AbstractVector,
  i::Int,
  Hiv::AbstractVector,
) where {T, S}
  @lencheck nls.meta.nvar x Hiv
  @rangecheck 1 nls.nls_meta.nequ i
  prod! = @closure (res, v, α, β) -> begin
    hprod_residual!(nls, x, i, v, Hiv)
    if β == 0
      res .= α .* Hiv
    else
      res .= α .* Hiv .+ β .* res
    end
    return res
  end
  return LinearOperator{T, S}(
    nls_meta(nls).nvar,
    nls_meta(nls).nvar,
    true,
    true,
    prod!,
    prod!,
    prod!,
  )
end

"""
    f = obj(nls, x)
    f = obj(nls, x, Fx; recompute::Bool=true)

Evaluate `f(x)`, the objective function of `nls::AbstractNLSModel`. `Fx` is overwritten with the value of the residual `F(x)`.
If `recompute` is `true`, then `Fx` is updated with the residual at `x`.
"""
function obj(nls::AbstractNLSModel, x::AbstractVector, Fx::AbstractVector; recompute::Bool = true)
  @lencheck nls.meta.nvar x
  increment!(nls, :neval_obj)
  recompute && residual!(nls, x, Fx)
  return dot(Fx, Fx) / 2
end

function obj(nls::AbstractNLSModel{T, S}, x::AbstractVector) where {T, S}
  @lencheck nls.meta.nvar x
  Fx = S(undef, nls.nls_meta.nequ)
  return obj(nls, x, Fx)
end

"""
    f, c = objcons!(nls, x, c)
    f, c = objcons!(nls, x, c, Fx; recompute::Bool=true)

In-place evaluation of constraints and objective for AbstractNLSModel.
`Fx` is overwritten with the value of the residual `F(x)`.
If `recompute` is `true`, then `Fx` is updated with the residual at `x`.
"""
function objcons!(nls::AbstractNLSModel{T, S}, x::AbstractVector, c::AbstractVector) where {T, S}
  @lencheck nls.meta.nvar x
  @lencheck nls.meta.ncon c
  Fx = S(undef, nls.nls_meta.nequ)
  return objcons!(nls, x, c, Fx)
end

function objcons!(
  nls::AbstractNLSModel,
  x::AbstractVector,
  c::AbstractVector,
  Fx::AbstractVector;
  recompute::Bool = true,
)
  cons!(nls, x, c)
  return obj(nls, x, Fx; recompute = recompute), c
end

"""
    g = grad!(nls, x, g)
    g = grad!(nls, x, g, Fx; recompute::Bool=true)

Evaluate `∇f(x)`, the gradient of the objective function of `nls::AbstractNLSModel` at `x` in place. `Fx` is overwritten with the value of the residual `F(x)`.
If `recompute` is `true`, then `Fx` is updated with the residual at `x`.
This function is only available if `nls_meta(nls).jtprod_residual_available` is set to `true`.
"""
function grad!(
  nls::AbstractNLSModel,
  x::AbstractVector,
  g::AbstractVector,
  Fx::AbstractVector;
  recompute::Bool = true,
)
  @lencheck nls.meta.nvar x g
  increment!(nls, :neval_grad)
  recompute && residual!(nls, x, Fx)
  return jtprod_residual!(nls, x, Fx, g)
end

function grad!(nls::AbstractNLSModel{T, S}, x::AbstractVector, g::AbstractVector) where {T, S}
  @lencheck nls.meta.nvar x g
  increment!(nls, :neval_grad)
  Fx = S(undef, nls.nls_meta.nequ)
  return grad!(nls, x, g, Fx)
end

"""
    f, g = objgrad!(nls, x, g)
    f, g = objgrad!(nls, x, g, Fx; recompute::Bool=true)

Evaluate f(x) and ∇f(x) of `nls::AbstractNLSModel` at `x`. `Fx` is overwritten with the value of the residual `F(x)`.
If `recompute` is `true`, then `Fx` is updated with the residual at `x`.
This function is only available if `nls_meta(nls).jtprod_residual_available` is set to `true`.
"""
function objgrad!(
  nls::AbstractNLSModel,
  x::AbstractVector,
  g::AbstractVector,
  Fx::AbstractVector;
  recompute::Bool = true,
)
  @lencheck nls.meta.nvar x g
  increment!(nls, :neval_obj)
  increment!(nls, :neval_grad)
  recompute && residual!(nls, x, Fx)
  jtprod_residual!(nls, x, Fx, g)
  return dot(Fx, Fx) / 2, g
end

function objgrad!(nls::AbstractNLSModel{T, S}, x::AbstractVector, g::AbstractVector) where {T, S}
  @lencheck nls.meta.nvar x g
  increment!(nls, :neval_obj)
  increment!(nls, :neval_grad)
  Fx = S(undef, nls.nls_meta.nequ)
  return objgrad!(nls, x, g, Fx)
end

mutable struct SuperNLPModel{T, S} <: AbstractNLPModel{T, S}
  model
end

@testset "Testing @lencheck and @rangecheck" begin
  x = zeros(2)
  @lencheck 2 x
  @test_throws DimensionError @lencheck 1 x
  @test_throws DimensionError @lencheck 3 x

  @rangecheck 1 3 2
  @test_throws ErrorException @rangecheck 1 3 0
  @test_throws ErrorException @rangecheck 1 3 4

  io = IOBuffer()
  showerror(io, DimensionError(:A, 1, 2))
  @test String(take!(io)) == "DimensionError: Input A should have length 1 not 2"
end

@testset "Increase coverage of default_NLPcounters" begin
  @default_counters SuperNLPModel model (neval_hprod,)
  nlp = SuperNLPModel{Float64, Vector{Float64}}(SimpleNLPModel())
  increment!(nlp, :neval_obj)
  @test neval_obj(nlp.model) == 1
  @test get_counters(nlp) == get_counters(nlp.model)
  @test neval_hprod(nlp) == 0  # because counters are forwarded, even though neval_hprod has not been forwarded
end

@testset "NLS API test on a simple model" begin
  F(x) = [1 - x[1]; 10 * (x[2] - x[1]^2)]
  JF(x) = [-1.0 0.0; -20*x[1] 10]
  HF(x, w) = w[2] * [-20.0 0; 0 0]

  nls = SimpleNLSModel()
  @test eltype(nls) == Float64
  n = nls.meta.nvar
  m = nls.meta.ncon
  ne = nls_meta(nls).nequ

  x = randn(n)
  v = randn(n)
  w = randn(ne)
  Jv = zeros(ne)
  Jtw = zeros(n)
  Hv = zeros(n)

  @test residual(nls, x) ≈ F(x)
  @test jac_residual(nls, x) ≈ JF(x)
  @test hess_residual(nls, x, w) ≈ HF(x, w)
  @test jprod_residual(nls, x, v) ≈ JF(x) * v
  @test jtprod_residual(nls, x, w) ≈ JF(x)' * w
  @test jprod_residual!(nls, jac_structure_residual(nls)..., jac_coord_residual(nls, x), v, Jv) ≈
        JF(x) * v
  @test jtprod_residual!(nls, jac_structure_residual(nls)..., jac_coord_residual(nls, x), w, Jtw) ≈
        JF(x)' * w
  Jop = jac_op_residual(nls, x)
  @test Jop * v ≈ JF(x) * v
  @test Jop' * w ≈ JF(x)' * w
  Jop = jac_op_residual!(nls, x, Jv, Jtw)
  @test Jop * v ≈ JF(x) * v
  @test Jop' * w ≈ JF(x)' * w
  res = JF(x) * v - w
  @test mul!(w, Jop, v, 1.0, -1.0) ≈ res
  res = JF(x)' * w - v
  @test mul!(v, Jop', w, 1.0, -1.0) ≈ res
  Jop = jac_op_residual!(nls, jac_structure_residual(nls)..., jac_coord_residual(nls, x), Jv, Jtw)
  @test Jop * v ≈ JF(x) * v
  @test Jop' * w ≈ JF(x)' * w
  res = JF(x) * v - w
  @test mul!(w, Jop, v, 1.0, -1.0) ≈ res
  res = JF(x)' * w - v
  @test mul!(v, Jop', w, 1.0, -1.0) ≈ res
  I, J, V = findnz(sparse(HF(x, w)))
  @test hess_structure_residual(nls) == (I, J)
  @test hess_coord_residual(nls, x, w) ≈ V
  for j = 1:ne
    eⱼ = [i == j ? 1.0 : 0.0 for i = 1:ne]
    @test jth_hess_residual(nls, x, j) ≈ HF(x, eⱼ)
    @test hprod_residual(nls, x, j, v) ≈ HF(x, eⱼ) * v
    Hop = hess_op_residual(nls, x, j)
    @test Hop * v ≈ HF(x, eⱼ) * v
    Hop = hess_op_residual!(nls, x, j, Hv)
    @test Hop * v ≈ HF(x, eⱼ) * v
    z = ones(nls.meta.nvar)
    res = HF(x, eⱼ) * v - z
    @test mul!(z, Hop, v, 1.0, -1.0) ≈ res
  end
end

@testset "NLP API test on a simple NLS model" begin
  F(x) = [1 - x[1]; 10 * (x[2] - x[1]^2)]
  JF(x) = [-1.0 0.0; -20*x[1] 10]
  HF(x, w) = w[2] * [-20.0 0; 0 0]
  f(x) = norm(F(x))^2 / 2
  ∇f(x) = JF(x)' * F(x)
  H(x) = JF(x)' * JF(x) + HF(x, F(x))
  c(x) = [x[1] + x[2]^2; x[1]^2 + x[2]; x[1]^2 + x[2]^2 - 1]
  J(x) = [1 2x[2]; 2x[1] 1; 2x[1] 2x[2]]
  H(x, y) = H(x) + diagm(0 => [2y[2] + 2y[3]; 2y[1] + 2y[3]])

  nls = SimpleNLSModel()
  n = nls.meta.nvar
  m = nls.meta.ncon

  x = randn(n)
  y = randn(m)
  v = randn(n)
  w = randn(m)
  Jv = zeros(m)
  Jtw = zeros(n)
  Hv = zeros(n)
  Hvals = zeros(nls.meta.nnzh)

  fx, gx = objgrad!(nls, x, v)
  @test obj(nls, x) ≈ norm(F(x))^2 / 2 ≈ fx ≈ f(x)
  @test obj(nls, x, F(x), recompute = false) ≈ norm(F(x))^2 / 2 ≈ fx ≈ f(x)
  @test grad(nls, x) ≈ JF(x)' * F(x) ≈ gx ≈ ∇f(x)
  @test grad!(nls, x, gx, F(x), recompute = false) ≈ JF(x)' * F(x) ≈ gx ≈ ∇f(x)
  @test hess(nls, x) ≈ tril(H(x))
  @test hprod(nls, x, v) ≈ H(x) * v
  @test cons(nls, x) ≈ c(x)
  @test jac(nls, x) ≈ J(x)
  @test jprod(nls, x, v) ≈ J(x) * v
  @test jtprod(nls, x, w) ≈ J(x)' * w
  @test hess(nls, x, y) ≈ tril(H(x, y))
  @test hprod(nls, x, y, v) ≈ H(x, y) * v
  fx, cx = objcons(nls, x)
  @test fx ≈ f(x)
  @test cx ≈ c(x)
  fx, _ = objcons!(nls, x, cx)
  @test fx ≈ f(x)
  @test cx ≈ c(x)
  fx, gx = objgrad(nls, x)
  @test fx ≈ f(x)
  @test gx ≈ ∇f(x)
  fx, _ = objgrad!(nls, x, gx)
  @test fx ≈ f(x)
  @test gx ≈ ∇f(x)
  fx, _ = objgrad!(nls, x, gx, F(x), recompute = false)
  @test fx ≈ f(x)
  @test gx ≈ ∇f(x)
  @test jprod!(nls, jac_structure(nls)..., jac_coord(nls, x), v, Jv) ≈ J(x) * v
  @test jtprod!(nls, jac_structure(nls)..., jac_coord(nls, x), w, Jtw) ≈ J(x)' * w
  Jop = jac_op!(nls, x, Jv, Jtw)
  @test Jop * v ≈ J(x) * v
  @test Jop' * w ≈ J(x)' * w
  Jop = jac_op!(nls, jac_structure(nls)..., jac_coord(nls, x), Jv, Jtw)
  @test Jop * v ≈ J(x) * v
  @test Jop' * w ≈ J(x)' * w
  ghjv = zeros(m)
  for j = 1:m
    eⱼ = [i == j ? 1.0 : 0.0 for i = 1:m]
    Cⱼ(x) = H(x, eⱼ) - H(x)
    ghjv[j] = dot(gx, Cⱼ(x) * v)
  end
  @test ghjvprod(nls, x, gx, v) ≈ ghjv
  @test hess_coord!(nls, x, Hvals) == hess_coord!(nls, x, y * 0, Hvals)
  @test hprod!(nls, hess_structure(nls)..., hess_coord(nls, x), v, Hv) ≈ H(x) * v
  Hop = hess_op(nls, x)
  @test Hop * v ≈ H(x) * v
  Hop = hess_op!(nls, x, Hv)
  @test Hop * v ≈ H(x) * v
  Hop = hess_op!(nls, hess_structure(nls)..., hess_coord(nls, x), Hv)
  @test Hop * v ≈ H(x) * v
  Hop = hess_op(nls, x, y)
  @test Hop * v ≈ H(x, y) * v
  Hop = hess_op!(nls, x, y, Hv)
  @test Hop * v ≈ H(x, y) * v
  Hop = hess_op!(nls, hess_structure(nls)..., hess_coord(nls, x, y), Hv)
  @test Hop * v ≈ H(x, y) * v
end

@testset "test vector types Float32" begin
  nls = SimpleNLSModel(Float32)
  @test Float32 ==
        eltype(nls.meta.x0) ==
        eltype(nls.meta.lvar) ==
        eltype(nls.meta.uvar) ==
        eltype(nls.meta.y0) ==
        eltype(nls.meta.lcon) ==
        eltype(nls.meta.ucon)
end

@testset "Basic Counters check" begin
  nlp = SimpleNLPModel()

  for counter in fieldnames(Counters)
    @eval @test $counter($nlp) == 0
  end

  obj(nlp, nlp.meta.x0)
  grad(nlp, nlp.meta.x0)
  @test sum_counters(nlp) == 2

  for counter in fieldnames(Counters)
    increment!(nlp, counter)
  end
  # sum all counters of problem `nlp` except 
  # `cons`, `jac`, `jprod` and `jtprod` = 20-4+2
  @test sum_counters(nlp) == 18

  reset!(nlp)
  @test sum_counters(nlp) == 0
end

if VERSION ≥ VersionNumber(1, 7, 3)
  @testset "Allocations for NLP counters" begin
    nlp = SimpleNLPModel()

    increment!(nlp, :neval_obj)
    alloc_mem = @allocated increment!(nlp, :neval_obj)
    @test alloc_mem == 0
  end
end

export show_header

"""
    show_header(io, nlp)

Show a header for the specific `nlp` type.
Should be imported and defined for every model implementing the NLPModels API.
"""
show_header(io::IO, nlp::AbstractNLPModel) = println(io, typeof(nlp))

function Base.show(io::IO, nlp::AbstractNLPModel)
  show_header(io, nlp)
  show(io, nlp.meta)
  show(io, get_counters(nlp))
end

"""
    histline(s, v, maxv)

Return a string of the form

    ______NAME______: ████⋅⋅⋅⋅⋅⋅⋅⋅⋅⋅⋅⋅⋅⋅⋅⋅ 5

where:
- `______NAME______` is `s` with padding to the left and length 16.
- And the symbols █ and ⋅ fill 20 characters in the proportion of `v / maxv` to █ and the rest to ⋅.
- The number `5` is v.
"""
function histline(s, v, maxv)
  @assert 0 ≤ v ≤ maxv
  λ = maxv == 0 ? 0 : ceil(Int, 20 * v / maxv)
  return @sprintf("%16s: %s %-6s", s, "█"^λ * "⋅"^(20 - λ), v)
end

"""
    sparsityline(s, v, maxv)

Return a string of the form

    ______NAME______: ( 80.00% sparsity)   5

where:
- `______NAME______` is `s` with padding to the left and length 16.
- The sparsity value is given by `v / maxv`.
- The number `5` is v.
"""
function sparsityline(s, v, maxv)
  if maxv == 0
    @sprintf("%16s: (------%% sparsity)   %-6s", s, " ")
  else
    @sprintf("%16s: (%6.2f%% sparsity)   %-6s", s, 100 * (1 - v / maxv), v)
  end
end

"""
    lines_of_hist(S, V)

Return a vector of `histline(s, v, maxv)`s using pairs of `s` in `S` and `v` in `V`. `maxv` is given by the maximum of `V`.
"""
function lines_of_hist(S, V)
  maxv = maximum(V)
  lines = histline.(S, V, maxv)
  return lines
end

"""
    lines_of_description(meta)

Describe `meta` for the `show` function.
"""
function lines_of_description(m::M) where {M <: AbstractNLPModelMeta}
  V = [
    length(get_ifree(m)),
    length(get_ilow(m)),
    length(get_iupp(m)),
    length(get_irng(m)),
    length(get_ifix(m)),
    length(get_iinf(m)),
  ]
  V = [sum(V); V]
  S = ["All variables", "free", "lower", "upper", "low/upp", "fixed", "infeas"]
  varlines = lines_of_hist(S, V)
  push!(varlines, sparsityline("nnzh", get_nnzh(m), get_nvar(m) * (get_nvar(m) + 1) / 2))

  V = [
    length(get_jfree(m)),
    length(get_jlow(m)),
    length(get_jupp(m)),
    length(get_jrng(m)),
    length(get_jfix(m)),
    length(get_jinf(m)),
  ]
  V = [sum(V); V]
  S = ["All constraints", "free", "lower", "upper", "low/upp", "fixed", "infeas"]
  conlines = lines_of_hist(S, V)

  append!(
    conlines,
    [
      histline("linear", get_nlin(m), get_ncon(m)),
      histline("nonlinear", get_nnln(m), get_ncon(m)),
      sparsityline("nnzj", get_nnzj(m), get_nvar(m) * get_ncon(m)),
    ],
  )

  if :lin_nnzj in fieldnames(M)
    push!(conlines, sparsityline("lin_nnzj", get_lin_nnzj(m), get_nlin(m) * get_nvar(m)))
  end
  if :nln_nnzj in fieldnames(M)
    push!(conlines, sparsityline("nln_nnzj", get_nln_nnzj(m), get_nnln(m) * get_nvar(m)))
  end

  append!(varlines, repeat([" "^length(varlines[1])], length(conlines) - length(varlines)))
  lines = varlines .* conlines

  return lines
end

function Base.show(io::IO, m::AbstractNLPModelMeta)
  println(io, "  Problem name: $(get_name(m))")
  lines = lines_of_description(m)
  println(io, join(lines, "\n") * "\n")
end

"""
    show_counters(io, counters, fields)

Show the `fields` of the struct `counters`.
"""
function show_counters(io::IO, c, F)
  V = (getproperty(c, f) for f in F)
  S = (string(f)[7:end] for f in F)
  lines = lines_of_hist(S, V)
  n = length(lines)
  for i = 1:3:length(lines)
    idx = i:min(n, i + 2)
    println(io, join(lines[idx], ""))
  end
end

function Base.show(io::IO, c::Counters)
  println(io, "  Counters:")
  F = fieldnames(Counters)
  show_counters(io, c, F)
end

@testset "Problem type functions" begin
  @testset "Analysis = $bool" for bool in (false, true)
    foo_list = [
      has_bounds,
      bound_constrained,
      unconstrained,
      linearly_constrained,
      equality_constrained,
      inequality_constrained,
      has_equalities,
      has_inequalities,
    ]
    meta_list = [
      NLPModelMeta(2, variable_bounds_analysis = bool, constraint_bounds_analysis = bool),
      NLPModelMeta(
        2,
        lvar = zeros(2),
        uvar = ones(2),
        variable_bounds_analysis = bool,
        constraint_bounds_analysis = bool,
      ),
      NLPModelMeta(
        2,
        ncon = 1,
        lcon = [0.0],
        ucon = [0.0],
        variable_bounds_analysis = bool,
        constraint_bounds_analysis = bool,
      ),
      NLPModelMeta(
        2,
        ncon = 1,
        lcon = [0.0],
        ucon = [1.0],
        variable_bounds_analysis = bool,
        constraint_bounds_analysis = bool,
      ),
      NLPModelMeta(
        2,
        ncon = 1,
        lcon = [0.0],
        ucon = [Inf],
        variable_bounds_analysis = bool,
        constraint_bounds_analysis = bool,
      ),
      NLPModelMeta(
        2,
        ncon = 1,
        lcon = [-Inf],
        ucon = [0.0],
        variable_bounds_analysis = bool,
        constraint_bounds_analysis = bool,
      ),
      NLPModelMeta(
        2,
        ncon = 1,
        lcon = [0.0],
        ucon = [1.0],
        lin = [1],
        variable_bounds_analysis = bool,
        constraint_bounds_analysis = bool,
      ),
      NLPModelMeta(
        2,
        ncon = 2,
        lcon = [0.0, 0.0],
        ucon = [1.0, 1.0],
        lin = [1],
        variable_bounds_analysis = bool,
        constraint_bounds_analysis = bool,
      ),
      NLPModelMeta(
        2,
        ncon = 2,
        lcon = [0.0, 0.0],
        ucon = [1.0, 0.0],
        lin = [1],
        variable_bounds_analysis = bool,
        constraint_bounds_analysis = bool,
      ),
      NLPModelMeta(
        2,
        lvar = zeros(2),
        uvar = ones(2),
        ncon = 1,
        lcon = [0.0],
        ucon = [0.0],
        variable_bounds_analysis = bool,
        constraint_bounds_analysis = bool,
      ),
      NLPModelMeta(
        2,
        lvar = zeros(2),
        uvar = ones(2),
        ncon = 1,
        lcon = [0.0],
        ucon = [1.0],
        variable_bounds_analysis = bool,
        constraint_bounds_analysis = bool,
      ),
      NLPModelMeta(
        2,
        lvar = zeros(2),
        uvar = ones(2),
        ncon = 1,
        lcon = [0.0],
        ucon = [Inf],
        variable_bounds_analysis = bool,
        constraint_bounds_analysis = bool,
      ),
      NLPModelMeta(
        2,
        lvar = zeros(2),
        uvar = ones(2),
        ncon = 1,
        lcon = [-Inf],
        ucon = [0.0],
        variable_bounds_analysis = bool,
        constraint_bounds_analysis = bool,
      ),
      NLPModelMeta(
        2,
        lvar = zeros(2),
        uvar = ones(2),
        ncon = 1,
        lcon = [0.0],
        ucon = [1.0],
        lin = [1],
        variable_bounds_analysis = bool,
        constraint_bounds_analysis = bool,
      ),
      NLPModelMeta(
        2,
        lvar = zeros(2),
        uvar = ones(2),
        ncon = 2,
        lcon = [0.0, 0.0],
        ucon = [1.0, 1.0],
        lin = [1],
        variable_bounds_analysis = bool,
        constraint_bounds_analysis = bool,
      ),
      NLPModelMeta(
        2,
        lvar = zeros(2),
        uvar = ones(2),
        ncon = 2,
        lcon = [0.0, 0.0],
        ucon = [1.0, 0.0],
        lin = [1],
        variable_bounds_analysis = bool,
        constraint_bounds_analysis = bool,
      ),
    ]
    results = Bool[
      0 1 0 0 0 0 0 0 0 1 1 1 1 1 1 1
      0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0
      1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
      0 0 0 0 0 0 1 0 0 0 0 0 0 1 0 0
      0 0 1 0 0 0 0 0 0 1 0 0 0 0 0 0
      0 0 0 1 1 1 1 1 0 0 1 1 1 1 1 0
      0 0 1 0 0 0 0 0 1 1 0 0 0 0 0 1
      0 0 0 1 1 1 1 1 1 0 1 1 1 1 1 1
    ]
    for (i, f) in enumerate(foo_list), (j, meta) in enumerate(meta_list)
      @test f(meta) == results[i, j]
      @test f(DummyModel(meta)) == results[i, j]
    end
    for f in fieldnames(NLPModelMeta), (j, meta) in enumerate(meta_list)
      @test eval(Meta.parse("get_" * string(f)))(meta) == getproperty(meta, f)
      @test eval(Meta.parse("get_" * string(f)))(DummyModel(meta)) == getproperty(meta, f)
    end
  end
end

using LinearAlgebra, LinearOperators, NLPModels, SparseArrays, Test

include("nlp/simple-model.jl")
include("nlp/dummy-model.jl")

include("nlp/api.jl")
include("nlp/batch_api.jl")
include("nlp/counters.jl")
include("nlp/meta.jl")
include("nlp/show.jl")
include("nlp/tools.jl")
include("nlp/utils.jl")

include("nls/simple-model.jl")
include("nls/api.jl")
include("nls/counters.jl")
include("nls/show.jl")
include("nls/tools.jl")
include("nls/utils.jl")

function Base.show(io::IO, nls::AbstractNLSModel)
  show_header(io, nls)
  show(io, nls.meta, nls.nls_meta)
  show(io, get_counters(nls))
end

"""
    lines_of_description(nls_meta)

Describe `nls_meta` for the `show` function.
"""
function lines_of_description(nm::NLSMeta)
  V = [nm.nequ, nm.nlin, nm.nnln]
  S = ["All residuals", "linear", "nonlinear"]
  lines = lines_of_hist(S, V)
  push!(
    lines,
    sparsityline("nnzj", nm.nnzj, nm.nvar * nm.nequ),
    sparsityline("nnzh", nm.nnzh, nm.nvar * (nm.nvar + 1) / 2),
  )

  return lines
end

function Base.show(io::IO, nm::NLSMeta)
  lines = lines_of_description(nm)
  println(io, join(lines, "\n") * "\n")
end

function Base.show(io::IO, m::AbstractNLPModelMeta, nm::NLSMeta)
  println(io, "  Problem name: $(m.name)")
  nlplines = lines_of_description(m)
  nlslines = lines_of_description(nm)
  append!(nlslines, repeat([""], length(nlplines) - length(nlslines)))
  lines = nlplines .* nlslines
  println(io, join(lines, "\n") * "\n")
end

function Base.show(io::IO, c::NLSCounters)
  println(io, "  Counters:")
  F = setdiff(fieldnames(Counters) ∪ fieldnames(NLSCounters), [:counters])
  show_counters(io, c, F)
end

using Documenter, NLPModels

makedocs(
  modules = [NLPModels],
  doctest = true,
  linkcheck = true,
  format = Documenter.HTML(
    assets = ["assets/style.css"],
    prettyurls = get(ENV, "CI", nothing) == "true",
    size_threshold_ignore = ["reference.md"],
  ),
  sitename = "NLPModels.jl",
  pages = [
    "Home" => "index.md",
    "Models" => "models.md",
    "Guidelines" => "guidelines.md",
    "Tools" => "tools.md",
    "API" => "api.md",
    "Batch API" => "batch_api.md",
    "Internals" => "internals.md",
    "Reference" => "reference.md",
  ],
)

deploydocs(
  repo = "github.com/JuliaSmoothOptimizers/NLPModels.jl.git",
  push_preview = true,
  devbranch = "main",
)

"""
    SimpleNLSModel <: AbstractNLSModel

Simple NLSModel for testing purposes.
Modified problem 20 in the Hock-Schittkowski Suite.

     min   ½‖F(x)‖²
    s.to   x₁ + x₂² ≥ 0
           x₁² + x₂ ≥ 0
           x₁² + x₂² = 1
           0 ≤ x ≤ 1,

where

    F(x) = [1 - x₁; 10 (x₂ - x₁²)]

x₀ = ones(n).

Modified SimpleNLSModel.
"""
mutable struct SimpleNLSModel{T, S} <: AbstractNLSModel{T, S}
  meta::NLPModelMeta{T, S}
  nls_meta::NLSMeta{T, S}
  counters::NLSCounters
end

function SimpleNLSModel(::Type{T}) where {T}
  meta = NLPModelMeta(
    2,
    x0 = ones(T, 2),
    name = "Simple NLS Model",
    lvar = zeros(T, 2),
    uvar = ones(T, 2),
    ncon = 3,
    lcon = [zero(T); zero(T); one(T)],
    ucon = [T(Inf); T(Inf); one(T)],
    nnzj = 6,
  )
  nls_meta = NLSMeta{T, Vector{T}}(2, 2, nnzj = 3, nnzh = 1)

  return SimpleNLSModel(meta, nls_meta, NLSCounters())
end

SimpleNLSModel() = SimpleNLSModel(Float64)

function NLPModels.residual!(nls::SimpleNLSModel, x::AbstractVector, Fx::AbstractVector)
  @lencheck 2 x Fx
  increment!(nls, :neval_residual)
  Fx .= [1 - x[1]; 10 * (x[2] - x[1]^2)]
  return Fx
end

# Jx = [-1  0; -20x₁  10]
function NLPModels.jac_structure_residual!(
  nls::SimpleNLSModel,
  rows::AbstractVector{<:Integer},
  cols::AbstractVector{<:Integer},
)
  @lencheck 3 rows cols
  rows .= [1, 2, 2]
  cols .= [1, 1, 2]
  return rows, cols
end

function NLPModels.jac_coord_residual!(nls::SimpleNLSModel, x::AbstractVector, vals::AbstractVector)
  @lencheck 2 x
  @lencheck 3 vals
  increment!(nls, :neval_jac_residual)
  vals .= [-1, -20x[1], 10]
  return vals
end

function NLPModels.jprod_residual!(
  nls::SimpleNLSModel,
  x::AbstractVector,
  v::AbstractVector,
  Jv::AbstractVector,
)
  @lencheck 2 x v Jv
  increment!(nls, :neval_jprod_residual)
  Jv .= [-v[1]; -20 * x[1] * v[1] + 10 * v[2]]
  return Jv
end

function NLPModels.jtprod_residual!(
  nls::SimpleNLSModel,
  x::AbstractVector,
  v::AbstractVector,
  Jtv::AbstractVector,
)
  @lencheck 2 x v Jtv
  increment!(nls, :neval_jtprod_residual)
  Jtv .= [-v[1] - 20 * x[1] * v[2]; 10 * v[2]]
  return Jtv
end

function NLPModels.hess_structure_residual!(
  nls::SimpleNLSModel,
  rows::AbstractVector{<:Integer},
  cols::AbstractVector{<:Integer},
)
  @lencheck 1 rows cols
  rows[1] = 1
  cols[1] = 1
  return rows, cols
end

function NLPModels.hess_coord_residual!(
  nls::SimpleNLSModel,
  x::AbstractVector,
  v::AbstractVector,
  vals::AbstractVector,
)
  @lencheck 2 x v
  @lencheck 1 vals
  increment!(nls, :neval_hess_residual)
  vals[1] = -20v[2]
  return vals
end

function NLPModels.hprod_residual!(
  nls::SimpleNLSModel,
  x::AbstractVector,
  i::Int,
  v::AbstractVector,
  Hiv::AbstractVector,
)
  @lencheck 2 x v Hiv
  increment!(nls, :neval_hprod_residual)
  if i == 2
    Hiv .= [-20v[1]; 0]
  else
    Hiv .= zero(eltype(x))
  end
  return Hiv
end

function NLPModels.cons_nln!(nls::SimpleNLSModel, x::AbstractVector, cx::AbstractVector)
  @lencheck 2 x
  @lencheck 3 cx
  increment!(nls, :neval_cons_nln)
  cx .= [x[1] + x[2]^2; x[1]^2 + x[2]; x[1]^2 + x[2]^2 - 1]
  return cx
end

function NLPModels.jac_nln_structure!(
  nls::SimpleNLSModel,
  rows::AbstractVector{<:Integer},
  cols::AbstractVector{<:Integer},
)
  @lencheck 6 rows cols
  rows .= [1, 1, 2, 2, 3, 3]
  cols .= [1, 2, 1, 2, 1, 2]
  return rows, cols
end

function NLPModels.jac_nln_coord!(nls::SimpleNLSModel, x::AbstractVector, vals::AbstractVector)
  @lencheck 2 x
  @lencheck 6 vals
  increment!(nls, :neval_jac_nln)
  vals .= [1, 2x[2], 2x[1], 1, 2x[1], 2x[2]]
  return vals
end

function NLPModels.jprod_nln!(
  nls::SimpleNLSModel,
  x::AbstractVector,
  v::AbstractVector,
  Jv::AbstractVector,
)
  @lencheck 2 x v
  @lencheck 3 Jv
  increment!(nls, :neval_jprod_nln)
  Jv .= [v[1] + 2x[2] * v[2]; 2x[1] * v[1] + v[2]; 2x[1] * v[1] + 2x[2] * v[2]]
  return Jv
end

function NLPModels.jtprod_nln!(
  nls::SimpleNLSModel,
  x::AbstractVector,
  v::AbstractVector,
  Jtv::AbstractVector,
)
  @lencheck 2 x Jtv
  @lencheck 3 v
  increment!(nls, :neval_jtprod_nln)
  Jtv .= [v[1] + 2x[1] * (v[2] + v[3]); v[2] + 2x[2] * (v[1] + v[3])]
  return Jtv
end

function NLPModels.hess(nls::SimpleNLSModel, x::AbstractVector{T}; obj_weight = 1.0) where {T}
  @lencheck 2 x
  increment!(nls, :neval_hess)
  return obj_weight * [T(1) - 200 * x[2]+600 * x[1]^2 T(0); -200*x[1] T(100)]
end

function NLPModels.hess(
  nls::SimpleNLSModel,
  x::AbstractVector{T},
  y::AbstractVector{T};
  obj_weight = 1.0,
) where {T}
  @lencheck 2 x
  @lencheck 3 y
  increment!(nls, :neval_hess)
  return [
    obj_weight*(T(1) - 200 * x[2] + 600 * x[1]^2)+2*y[2]+2*y[3] T(0)
    -obj_weight*200*x[1] obj_weight*T(100)+2*y[1]+2*y[3]
  ]
end

function NLPModels.hess_structure!(
  nls::SimpleNLSModel,
  rows::AbstractVector{Int},
  cols::AbstractVector{Int},
)
  @lencheck 3 rows cols
  n = nls.meta.nvar
  I = ((i, j) for i = 1:n, j = 1:n if i ≥ j)
  rows .= getindex.(I, 1)
  cols .= getindex.(I, 2)
  return rows, cols
end

function NLPModels.hess_coord!(
  nls::SimpleNLSModel,
  x::AbstractVector,
  vals::AbstractVector;
  obj_weight = 1.0,
)
  @lencheck 2 x
  @lencheck 3 vals
  Hx = hess(nls, x, obj_weight = obj_weight)
  k = 1
  for j = 1:2
    for i = j:2
      vals[k] = Hx[i, j]
      k += 1
    end
  end
  return vals
end

function NLPModels.hess_coord!(
  nls::SimpleNLSModel,
  x::AbstractVector,
  y::AbstractVector,
  vals::AbstractVector;
  obj_weight = 1.0,
)
  @lencheck 2 x
  @lencheck 3 y
  @lencheck 3 vals
  Hx = hess(nls, x, y, obj_weight = obj_weight)
  k = 1
  for j = 1:2
    for i = j:2
      vals[k] = Hx[i, j]
      k += 1
    end
  end
  return vals
end

function NLPModels.hprod!(
  nls::SimpleNLSModel,
  x::AbstractVector{T},
  v::AbstractVector{T},
  Hv::AbstractVector{T};
  obj_weight = one(T),
) where {T}
  @lencheck 2 x v Hv
  increment!(nls, :neval_hprod)
  Hv .= obj_weight * [T(1) - 200 * x[2]+600 * x[1]^2 -200*x[1]; -200*x[1] T(100)] * v
  return Hv
end

function NLPModels.hprod!(
  nls::SimpleNLSModel,
  x::AbstractVector{T},
  y::AbstractVector{T},
  v::AbstractVector{T},
  Hv::AbstractVector{T};
  obj_weight = one(T),
) where {T}
  @lencheck 2 x v Hv
  increment!(nls, :neval_hprod)
  Hv .=
    [
      obj_weight*(T(1) - 200 * x[2] + 600 * x[1]^2)+2*y[2]+2*y[3] -obj_weight*200*x[1]
      -obj_weight*200*x[1] obj_weight*T(100)+2*y[1]+2*y[3]
    ] * v
  return Hv
end

function NLPModels.ghjvprod!(
  nls::SimpleNLSModel,
  x::AbstractVector{T},
  g::AbstractVector{T},
  v::AbstractVector{T},
  gHv::AbstractVector{T},
) where {T}
  @lencheck nls.meta.nvar x g v
  @lencheck nls.meta.ncon gHv
  increment!(nls, :neval_hprod)
  gHv[1] = g[2] * 2v[2]
  gHv[2] = g[1] * 2v[1]
  gHv[3] = g[1] * 2v[1] + g[2] * 2v[2]
  return gHv
end

export coo_prod!, coo_sym_prod!
export @default_counters
export DimensionError, @lencheck, @rangecheck

"""
    DimensionError <: Exception
    DimensionError(name, dim_expected, dim_found)

Error for unexpected dimension.
Output: "DimensionError: Input `name` should have length `dim_expected` not `dim_found`"
"""
struct DimensionError <: Exception
  name::Union{Symbol, String}
  dim_expected::Int
  dim_found::Int
end

function Base.showerror(io::IO, e::DimensionError)
  print(
    io,
    "DimensionError: Input $(e.name) should have length $(e.dim_expected) not $(e.dim_found)",
  )
end

# https://groups.google.com/forum/?fromgroups=#!topic/julia-users/b6RbQ2amKzg
"""
    @lencheck n x y z …

Check that arrays `x`, `y`, `z`, etc. have a prescribed length `n`.
"""
macro lencheck(l, vars...)
  exprs = Expr[]
  for var in vars
    varname = string(var)
    push!(exprs, :(
      if length($(esc(var))) != $(esc(l))
        throw(DimensionError($varname, $(esc(l)), length($(esc(var)))))
      end
    ))
  end
  Expr(:block, exprs...)
end

"""
    @rangecheck ℓ u i j k …

Check that values `i`, `j`, `k`, etc. are in the range `[ℓ,u]`.
"""
macro rangecheck(lo, hi, vars...)
  exprs = Expr[]
  for var in vars
    varname = string(var)
    push!(
      exprs,
      :(
        if (
          length($(esc(var))) > 0 && (
            any(broadcast(<, $(esc(var)), $(esc(lo)))) ||
            any(broadcast(>, $(esc(var)), $(esc(hi))))
          )
        )
          error(string($varname, " elements must be between ", $(esc(lo)), " and ", $(esc(hi))))
        end
      ),
    )
  end
  Expr(:block, exprs...)
end

"""
    coo_prod!(rows, cols, vals, v, Av)

Compute the product of a matrix `A` given by `(rows, cols, vals)` and the vector `v`.
The result is stored in `Av`, which should have length equals to the number of rows of `A`.
"""
function coo_prod!(
  rows::AbstractVector{<:Integer},
  cols::AbstractVector{<:Integer},
  vals::AbstractVector,
  v::AbstractVector,
  Av::AbstractVector,
)
  fill!(Av, zero(eltype(v)))
  nnz = length(rows)
  @inbounds for k = 1:nnz
    i, j = rows[k], cols[k]
    Av[i] += vals[k] * v[j]
  end
  return Av
end

"""
    coo_sym_prod!(rows, cols, vals, v, Av)

Compute the product of a symmetric matrix `A` given by `(rows, cols, vals)` and the vector `v`.
The result is stored in `Av`, which should have length equals to the number of rows of `A`.
Only one triangle of `A` should be passed.
"""
function coo_sym_prod!(
  rows::AbstractVector{<:Integer},
  cols::AbstractVector{<:Integer},
  vals::AbstractVector,
  v::AbstractVector,
  Av::AbstractVector,
)
  fill!(Av, zero(eltype(v)))
  nnz = length(rows)
  @inbounds for k = 1:nnz
    i, j, a = rows[k], cols[k], vals[k]
    Av[i] += a * v[j]
    if i != j
      Av[j] += a * v[i]
    end
  end
  return Av
end

"""
    @default_counters Model inner [excluded]

Define functions relating counters of `Model` to counters of `Model.inner`.
Any function listed in `excluded` (which is an empty list by default), will
not be forwarded.

Examples:

    @default_counters MyModel inner (sum_counters, neval_hprod,)
    @default_counters MyModel inner (neval_hprod,)

Excluding a method from forwarding allows the user to redefine it without
overwriting an existing method. Note that a generic method will still be
defined as, e.g.,

    neval_hprod(model) = model.inner.counters.neval_hprod

because the `counters` attribute itself is forwarded by `@default_counters`.
"""
macro default_counters(Model, inner, excluded = :())

  # Normalize excluded to a set of symbols
  excluded_set = if excluded == :()
    Set{Symbol}()
  elseif excluded isa Expr && excluded.head == :tuple
    Set{Symbol}([excluded.args...])
  else
    throw(ArgumentError("`@default_counters`: third argument must be a tuple of functions"))
  end

  ex = Expr(:block)
  for foo in fieldnames(Counters) ∪ [:sum_counters]
    Symbol(foo) in excluded_set && continue
    push!(ex.args, :(NLPModels.$foo(nlp::$(esc(Model))) = $foo(nlp.$inner)))
  end
  push!(ex.args, :(NLPModels.reset!(nlp::$(esc(Model))) = begin
    reset!(nlp.$inner)
    reset_data!(nlp)
  end))
  push!(ex.args, :(NLPModels.increment!(nlp::$(esc(Model)), s::Symbol) = increment!(nlp.$inner, s)))
  push!(ex.args, :(NLPModels.decrement!(nlp::$(esc(Model)), s::Symbol) = decrement!(nlp.$inner, s)))

  push!(
    ex.args,
    :(
      Base.getproperty(nlp::$(esc(Model)), s::Symbol) =
        (s == :counters ? get_counters(nlp.$inner) : getfield(nlp, s))
    ),
  )
  ex
end

"""
    eltype(nlp::AbstractNLPModel{T, S})

Element type of `nlp.meta.x0`.
"""
Base.eltype(nlp::AbstractNLPModel{T, S}) where {T, S} = eltype(get_x0(nlp))

module NLPModels

# stdlib
using LinearAlgebra, Printf, SparseArrays
# external
using FastClosures
# JSO
using LinearOperators

export AbstractNLPModel, AbstractNLSModel

# For documentation purpose
const OBJECTIVE_HESSIAN = raw"""
```math
σ ∇²f(x),
```
with `σ = obj_weight`
"""
const LAGRANGIAN_HESSIAN = raw"""
```math
∇²L(x,y) = σ ∇²f(x) + \sum_i yᵢ ∇²cᵢ(x),
```
with `σ = obj_weight`
"""

"""
    AbstractNLPModel

Base type for an optimization model.
"""
abstract type AbstractNLPModel{T, S} end

"""
    AbstractNLSModel <: AbstractNLPModel

Base type for a nonlinear least-squares model.
"""
abstract type AbstractNLSModel{T, S} <: AbstractNLPModel{T, S} end

for f in ["counters", "utils", "api", "meta", "show", "tools"]
  include("nlp/$f.jl")
  include("nls/$f.jl")
end
include("nlp/batch_api.jl")
include("nlp/batch_meta.jl")

end # module

export has_bounds, bound_constrained, unconstrained
export linearly_constrained, equality_constrained, inequality_constrained
export has_equalities, has_inequalities

for field in fieldnames(NLPModelMeta)
  meth = Symbol("get_", field)
  @eval begin
    @doc """
        $($meth)(nlp)
        $($meth)(meta)
    Return the value $($(QuoteNode(field))) from meta or nlp.meta.
    """
    $meth(meta::AbstractNLPModelMeta) = getproperty(meta, $(QuoteNode(field)))
  end
  @eval $meth(nlp::AbstractNLPModel) = $meth(nlp.meta)
  @eval export $meth
end

"""
    has_bounds(nlp)
    has_bounds(meta)

Returns whether the problem has bounds on the variables.
"""
function has_bounds(meta::AbstractNLPModelMeta)
  if get_variable_bounds_analysis(meta)
    return length(get_ifree(meta)) < get_nvar(meta)
  else
    return !all(lv -> isinf(lv), get_lvar(meta)) || !all(uv -> isinf(uv), get_uvar(meta))
  end
end

"""
    bound_constrained(nlp)
    bound_constrained(meta)

Returns whether the problem has bounds on the variables and no other constraints.
"""
bound_constrained(meta::AbstractNLPModelMeta) = (get_ncon(meta) == 0) && has_bounds(meta)

"""
    unconstrained(nlp)
    unconstrained(meta)

Returns whether the problem in unconstrained.
"""
unconstrained(meta::AbstractNLPModelMeta) = (get_ncon(meta) == 0) && !has_bounds(meta)

"""
    linearly_constrained(nlp)
    linearly_constrained(meta)

Returns whether the problem's constraints are known to be all linear.
"""
linearly_constrained(meta::AbstractNLPModelMeta) =
  (get_ncon(meta) > 0) && (get_nlin(meta) == get_ncon(meta))

"""
    equality_constrained(nlp)
    equality_constrained(meta)

Returns whether the problem's constraints are all equalities.
Unconstrained problems return false.
"""
function equality_constrained(meta::AbstractNLPModelMeta)
  if get_constraint_bounds_analysis(meta)
    return (get_ncon(meta) > 0) && (length(get_jfix(meta)) == get_ncon(meta))
  else
    return (get_ncon(meta) > 0) && all(x -> x[1] == x[2], zip(get_lcon(meta), get_ucon(meta)))
  end
end

"""
    inequality_constrained(nlp)
    inequality_constrained(meta)

Returns whether the problem's constraints are all inequalities.
Unconstrained problems return true.
"""
function inequality_constrained(meta::AbstractNLPModelMeta)
  if get_constraint_bounds_analysis(meta)
    return (get_ncon(meta) > 0) && (length(get_jfix(meta)) == 0)
  else
    return (get_ncon(meta) > 0) && all(x -> x[1] != x[2], zip(get_lcon(meta), get_ucon(meta)))
  end
end

"""
    has_equalities(nlp)

Returns whether the problem has constraints and at least one of them is an equality.
Unconstrained problems return false.
"""
function has_equalities(meta::AbstractNLPModelMeta)
  if get_constraint_bounds_analysis(meta)
    return (get_ncon(meta) > 0) && (length(get_jfix(meta)) > 0)
  else
    return (get_ncon(meta) > 0) && !all(x -> x[1] != x[2], zip(get_lcon(meta), get_ucon(meta)))
  end
end

"""
    has_inequalities(nlp)

Returns whether the problem has constraints and at least one of them is an inequality.
Unconstrained problems return false.
"""
function has_inequalities(meta::AbstractNLPModelMeta)
  if get_constraint_bounds_analysis(meta)
    return (get_ncon(meta) > 0) && (get_ncon(meta) > length(get_jfix(meta)))
  else
    return (get_ncon(meta) > 0) && !all(x -> x[1] == x[2], zip(get_lcon(meta), get_ucon(meta)))
  end
end

for meth in [
  :has_bounds,
  :bound_constrained,
  :unconstrained,
  :linearly_constrained,
  :equality_constrained,
  :inequality_constrained,
  :has_equalities,
  :has_inequalities,
]
  @eval $meth(nlp::AbstractNLPModel) = $meth(nlp.meta)
end

@testset "A problem with zero variables doesn't make sense." begin
  @test_throws ErrorException NLPModelMeta(0)
end

@testset "Meta copier." begin
  nlp = SimpleNLPModel()

  # Check simple copy
  meta = NLPModelMeta(nlp.meta)
  for field in fieldnames(typeof(nlp.meta))
    @test getfield(nlp.meta, field) == getfield(meta, field)
  end

  modif = Dict(
    :nnzh => 1,
    :x0 => [2.0; 2.0; 0.0],
    :nvar => 3,
    :lvar => zeros(3),
    :uvar => [1.0; 1.0; 0.0],
  )
  meta = NLPModelMeta(nlp.meta; modif...)

  for field in setdiff(fieldnames(typeof(nlp.meta)), union(keys(modif), [:ifix]))
    @test getfield(nlp.meta, field) == getfield(meta, field)
  end
  for field in keys(modif)
    @test getfield(meta, field) == modif[field]
  end
  @test meta.ifix == [3]
end

mutable struct DummyModel{T, S} <: AbstractNLPModel{T, S}
  meta::NLPModelMeta{T, S}
end

@testset "Default methods throw MethodError on DummyModel since they're not defined" begin
  model = DummyModel(NLPModelMeta(1))
  @test_throws(MethodError, lagscale(model, 1.0))
  @test_throws(MethodError, obj(model, [0.0]))
  @test_throws(MethodError, varscale(model, [0.0]))
  @test_throws(MethodError, conscale(model, [0.0]))
  @test_throws(MethodError, jac_structure(model, [0], [1]))
  @test_throws(MethodError, hess_structure(model, [0], [1]))
  @test_throws(MethodError, grad!(model, [0.0], [1.0]))
  @test_throws(MethodError, cons_lin!(model, [0.0], [1.0]))
  @test_throws(MethodError, cons_nln!(model, [0.0], [1.0]))
  @test_throws(MethodError, jac_lin_coord!(model, [0.0], [1.0]))
  @test_throws(MethodError, jac_nln_coord!(model, [0.0], [1.0]))
  @test_throws(MethodError, jth_con(model, [0.0], 1))
  @test_throws(MethodError, jth_congrad(model, [0.0], 1))
  @test_throws(MethodError, jth_sparse_congrad(model, [0.0], 1))
  @test_throws(MethodError, jth_congrad!(model, [0.0], 1, [2.0]))
  @test_throws(MethodError, jprod_lin!(model, [0.0], [1.0], [2.0]))
  @test_throws(MethodError, jtprod_lin!(model, [0.0], [1.0], [2.0]))
  @test_throws(MethodError, jprod_nln!(model, [0.0], [1.0], [2.0]))
  @test_throws(MethodError, jtprod_nln!(model, [0.0], [1.0], [2.0]))
  @test_throws(MethodError, jth_hess_coord!(model, [0.0], 1))
  @test_throws(MethodError, jth_hprod!(model, [0.0], [1.0], 2, [3.0]))
  @test_throws(MethodError, ghjvprod!(model, [0.0], [1.0], [2.0], [3.0]))
  @assert isa(hess_op(model, [0.0]), LinearOperator)
  @assert isa(jac_op(model, [0.0]), LinearOperator)
  @assert isa(jac_lin_op(model, [0.0]), LinearOperator)
  @assert isa(jac_nln_op(model, [0.0]), LinearOperator)
end

"""
    SimpleNLPModel <: AbstractNLPModel

Simple model for testing purposes.
Modified problem 14 in the Hock-Schittkowski suite

     min   (x₁ - 2)² + (x₂ - 1)²
    s.to   x₁ - 2x₂ + 1 = 0
           -x₁² / 4 - x₂² + 1 ≥ 0
           0 ≤ x ≤ 1

x₀ = [2.0, 2.0].
"""
mutable struct SimpleNLPModel{T, S} <: AbstractNLPModel{T, S}
  meta::NLPModelMeta{T, S}
  counters::Counters
  p::T
end

function SimpleNLPModel(::Type{T}; p = T(4)) where {T}
  meta = NLPModelMeta(
    2,
    nnzh = 2,
    ncon = 2,
    lvar = zeros(T, 2),
    uvar = ones(T, 2),
    x0 = [T(2.0); T(2.0)],
    lcon = [zero(T); zero(T)],
    ucon = [zero(T); T(Inf)],
    name = "Simple NLP Model",
    lin = [1],
    lin_nnzj = 2,
    nln_nnzj = 2,
  )

  return SimpleNLPModel(meta, Counters(), T(p))
end

SimpleNLPModel(; p = 4.0) = SimpleNLPModel(Float64; p = p)

function NLPModels.obj(nlp::SimpleNLPModel, x::AbstractVector)
  @lencheck 2 x
  increment!(nlp, :neval_obj)
  return (x[1] - 2)^2 + (x[2] - 1)^2
end

function NLPModels.grad!(nlp::SimpleNLPModel, x::AbstractVector, gx::AbstractVector)
  @lencheck 2 x gx
  increment!(nlp, :neval_grad)
  gx .= [2 * (x[1] - 2); 2 * (x[2] - 1)]
  return gx
end

function NLPModels.hess_structure!(
  nlp::SimpleNLPModel,
  rows::AbstractVector{Int},
  cols::AbstractVector{Int},
)
  @lencheck 2 rows cols
  rows[1] = 1
  rows[2] = 2
  cols[1] = 1
  cols[2] = 2
  return rows, cols
end

function NLPModels.hess_coord!(
  nlp::SimpleNLPModel,
  x::AbstractVector{T},
  y::AbstractVector{T},
  vals::AbstractVector{T};
  obj_weight = one(T),
) where {T}
  @lencheck 2 x y vals
  increment!(nlp, :neval_hess)
  vals .= 2obj_weight
  vals[1] -= 2y[2] / nlp.p
  vals[2] -= 2y[2]
  return vals
end

function NLPModels.hprod!(
  nlp::SimpleNLPModel,
  x::AbstractVector{T},
  y::AbstractVector{T},
  v::AbstractVector{T},
  Hv::AbstractVector{T};
  obj_weight = one(T),
) where {T}
  @lencheck 2 x y v Hv
  increment!(nlp, :neval_hprod)
  Hv .= 2obj_weight * v
  Hv[1] -= (2y[2] / nlp.p) * v[1]
  Hv[2] -= 2y[2] * v[2]
  return Hv
end

function NLPModels.cons_nln!(nlp::SimpleNLPModel, x::AbstractVector, cx::AbstractVector)
  @lencheck 2 x
  @lencheck 1 cx
  increment!(nlp, :neval_cons_nln)
  cx .= [-x[1]^2 / nlp.p - x[2]^2 + 1]
  return cx
end

function NLPModels.cons_lin!(nlp::SimpleNLPModel, x::AbstractVector, cx::AbstractVector)
  @lencheck 2 x
  @lencheck 1 cx
  increment!(nlp, :neval_cons_lin)
  cx .= [x[1] - 2 * x[2] + 1]
  return cx
end

function NLPModels.jac_nln_structure!(
  nlp::SimpleNLPModel,
  rows::AbstractVector{Int},
  cols::AbstractVector{Int},
)
  @lencheck 2 rows cols
  rows .= [1, 1]
  cols .= [1, 2]
  return rows, cols
end

function NLPModels.jac_lin_structure!(
  nlp::SimpleNLPModel,
  rows::AbstractVector{Int},
  cols::AbstractVector{Int},
)
  @lencheck 2 rows cols
  rows .= [1, 1]
  cols .= [1, 2]
  return rows, cols
end

function NLPModels.jac_nln_coord!(nlp::SimpleNLPModel, x::AbstractVector, vals::AbstractVector)
  @lencheck 2 x vals
  increment!(nlp, :neval_jac_nln)
  vals .= [-2 * x[1] / nlp.p, -2 * x[2]]
  return vals
end

function NLPModels.jac_lin_coord!(nlp::SimpleNLPModel, x::AbstractVector, vals::AbstractVector)
  @lencheck 2 x vals
  increment!(nlp, :neval_jac_lin)
  vals .= [1, -2]
  return vals
end

function NLPModels.jprod_nln!(
  nlp::SimpleNLPModel,
  x::AbstractVector,
  v::AbstractVector,
  Jv::AbstractVector,
)
  @lencheck 2 x v
  @lencheck 1 Jv
  increment!(nlp, :neval_jprod_nln)
  Jv .= [-(2 * x[1] / nlp.p) * v[1] - 2 * x[2] * v[2]]
  return Jv
end

function NLPModels.jprod_lin!(
  nlp::SimpleNLPModel,
  x::AbstractVector,
  v::AbstractVector,
  Jv::AbstractVector,
)
  @lencheck 2 x v
  @lencheck 1 Jv
  increment!(nlp, :neval_jprod_lin)
  Jv .= [v[1] - 2 * v[2]]
  return Jv
end

function NLPModels.jtprod_nln!(
  nlp::SimpleNLPModel,
  x::AbstractVector,
  v::AbstractVector,
  Jtv::AbstractVector,
)
  @lencheck 2 x Jtv
  @lencheck 1 v
  increment!(nlp, :neval_jtprod_nln)
  Jtv .= [-(2 * x[1] / nlp.p) * v[1]; -2 * x[2] * v[1]]
  return Jtv
end

function NLPModels.jtprod_lin!(
  nlp::SimpleNLPModel,
  x::AbstractVector,
  v::AbstractVector,
  Jtv::AbstractVector,
)
  @lencheck 2 x Jtv
  @lencheck 1 v
  increment!(nlp, :neval_jtprod_lin)
  Jtv .= [v[1]; -2 * v[1]]
  return Jtv
end

function NLPModels.jth_hess_coord!(
  nlp::SimpleNLPModel,
  x::AbstractVector{T},
  j::Integer,
  vals::AbstractVector{T},
) where {T}
  @lencheck 2 x vals
  increment!(nlp, :neval_jhess)
  if j == 1
    vals .= 0
  elseif j == 2
    vals[1] = -2 / nlp.p
    vals[2] = -2
  end
  return vals
end

function NLPModels.jth_hprod!(
  nlp::SimpleNLPModel,
  x::AbstractVector{T},
  v::AbstractVector{T},
  j::Integer,
  Hv::AbstractVector{T},
) where {T}
  @lencheck 2 x v Hv
  increment!(nlp, :neval_jhprod)
  if j == 1
    Hv .= 0
  elseif j == 2
    Hv[1] = -(2 / nlp.p) * v[1]
    Hv[2] = -2v[2]
  end
  return Hv
end

function NLPModels.ghjvprod!(
  nlp::SimpleNLPModel,
  x::AbstractVector{T},
  g::AbstractVector{T},
  v::AbstractVector{T},
  gHv::AbstractVector{T},
) where {T}
  @lencheck nlp.meta.nvar x g v
  @lencheck nlp.meta.ncon gHv
  increment!(nlp, :neval_hprod)
  gHv .= [T(0); -(2 * g[1] / nlp.p) * v[1] - 2 * g[2] * v[2]]
  return gHv
end

mutable struct BatchSimpleNLPModel{T, M, S} <: AbstractBatchNLPModel{T, M}
  meta::BatchNLPModelMeta{T, M}
  models::Vector{SimpleNLPModel{T, S}}
end

function BatchSimpleNLPModel(ps::Vector{T}) where {T}
  return BatchSimpleNLPModel(
    BatchNLPModelMeta{T, Matrix{T}}(
      length(ps),
      2;
      nnzh = 2,
      ncon = 2,
      lvar = zeros(T, 1, 2),
      uvar = ones(T, 1, 2),
      x0 = [T(2.0) T(2.0);],
      lcon = [zero(T) zero(T);],
      ucon = [zero(T) T(Inf);],
      name = "Batch simple NLP Model",
      nnzj = 4,
    ),
    [SimpleNLPModel(; p = p) for p in ps],
  )
end

function NLPModels.obj!(bnlp::BatchSimpleNLPModel, bx, bf)
  for (i, nlp) in enumerate(bnlp.models)
    bf[i] = NLPModels.obj(nlp, view(bx, :, i))
  end
  return bf
end

function NLPModels.grad!(bnlp::BatchSimpleNLPModel, bx, bg)
  for (i, nlp) in enumerate(bnlp.models)
    NLPModels.grad!(nlp, view(bx, :, i), view(bg, :, i))
  end
  return bg
end

function NLPModels.cons!(bnlp::BatchSimpleNLPModel, bx, bc)
  for (i, nlp) in enumerate(bnlp.models)
    NLPModels.cons!(nlp, view(bx, :, i), view(bc, :, i))
  end
  return bc
end

NLPModels.jac_structure!(bnlp::BatchSimpleNLPModel, jrows, jcols) =
  NLPModels.jac_structure!(bnlp.models[1], jrows, jcols)

function NLPModels.jac_coord!(bnlp::BatchSimpleNLPModel, bx, bjvals)
  for (i, nlp) in enumerate(bnlp.models)
    NLPModels.jac_coord!(nlp, view(bx, :, i), view(bjvals, :, i))
  end
  return bjvals
end

function NLPModels.jprod!(bnlp::BatchSimpleNLPModel, bx, bv, bJv)
  for (i, nlp) in enumerate(bnlp.models)
    NLPModels.jprod!(nlp, view(bx, :, i), view(bv, :, i), view(bJv, :, i))
  end
  return bJv
end

function NLPModels.jtprod!(bnlp::BatchSimpleNLPModel, bx, bv, bJtv)
  for (i, nlp) in enumerate(bnlp.models)
    NLPModels.jtprod!(nlp, view(bx, :, i), view(bv, :, i), view(bJtv, :, i))
  end
  return bJtv
end

NLPModels.hess_structure!(bnlp::BatchSimpleNLPModel, jrows, jcols) =
  NLPModels.hess_structure!(bnlp.models[1], jrows, jcols)

function NLPModels.hess_coord!(bnlp::BatchSimpleNLPModel, bx, by, bobj_weight, bhvals)
  for (i, nlp) in enumerate(bnlp.models)
    NLPModels.hess_coord!(
      nlp,
      view(bx, :, i),
      view(by, :, i),
      view(bhvals, :, i);
      obj_weight = bobj_weight[i],
    )
  end
  return bhvals
end

function NLPModels.hprod!(bnlp::BatchSimpleNLPModel, bx, by, bv, bobj_weight, bHv)
  for (i, nlp) in enumerate(bnlp.models)
    NLPModels.hprod!(
      nlp,
      view(bx, :, i),
      view(by, :, i),
      view(bv, :, i),
      view(bHv, :, i);
      obj_weight = bobj_weight[i],
    )
  end
  return bHv
end

@testset "Batch API" begin
  bnlp = BatchSimpleNLPModel([1.0, 2.0, 3.0])
  models = [
    SimpleNLPModel(; p = 1.0)
    SimpleNLPModel(; p = 2.0)
    SimpleNLPModel(; p = 3.0)
  ]

  @test bnlp.meta.nbatch == 3

  bx = [
    1.0 3.0 5.0;
    2.0 4.0 6.0;
  ]
  by = [
    -1.0 -3.0 -5.0;
    -2.0 -4.0 -6.0;
  ]
  xs = [
    1.0 3.0 5.0;
    2.0 4.0 6.0;
  ]
  ys = [
    -1.0 -3.0 -5.0;
    -2.0 -4.0 -6.0;
  ]
  bobj_weight = [1.0, 1.0, 1.0]

  bf = obj(bnlp, bx)
  bg = grad(bnlp, bx)
  bc = cons(bnlp, bx)
  bjvals = jac_coord(bnlp, bx)
  bhvals = hess_coord(bnlp, bx, by, bobj_weight)
  bJv = jprod(bnlp, bx, bx)
  bJtv = jtprod(bnlp, bx, by)
  bHv = hprod(bnlp, bx, by, bx, bobj_weight)
  jrows, jcols = jac_structure(bnlp)
  hrows, hcols = hess_structure(bnlp)

  for i = 1:3
    @test bf[i] == obj(models[i], xs[:, i])
    @test bg[:, i] == grad(models[i], xs[:, i])
    @test bc[:, i] == cons(models[i], xs[:, i])
    @test bjvals[:, i] == jac_coord(models[i], xs[:, i])
    @test bhvals[:, i] == hess_coord(models[i], xs[:, i], ys[:, i])
    @test bJv[:, i] == jprod(models[i], xs[:, i], xs[:, i])
    @test bJtv[:, i] == jtprod(models[i], xs[:, i], ys[:, i])
    @test bHv[:, i] == hprod(models[i], xs[:, i], ys[:, i], xs[:, i])
    jrowsi, jcolsi = jac_structure(models[i])
    @test jrows == jrowsi
    @test jcols == jcolsi
    hrowsi, hcolsi = hess_structure(models[i])
    @test hrows == hrowsi
    @test hcols == hcolsi
  end
end

export NLSMeta, nls_meta

"""
    NLSMeta

Base type for metadata related to a nonlinear least-squares model.

---

    NLSMeta(nequ, nvar; kwargs...)

Create a `NLSMeta` with `nequ` equations and `nvar` variables.
The following keyword arguments are accepted:
- `x0`: initial guess
- `nnzj`: number of elements needed to store the nonzeros of the Jacobian of the residual
- `nnzh`: number of elements needed to store the nonzeros of the sum of Hessians of the residuals
- `lin`: indices of linear residuals
- `jac_residual_available`: indicates whether the sparse Jacobian of the residuals is available
- `hess_residual_available`: indicates whether the sum of the sparse Hessians of the residuals is available
- `jprod_residual_available`: indicates whether the Jacobian-vector product for the residuals is available
- `jtprod_residual_available`: indicates whether the transpose Jacobian-vector product for the residuals is available
- `hprod_residual_available`: indicates whether the Hessian-vector product for each residual is available

`NLSMeta` also contains the following attributes, which are computed from the variables above:
- `nequ`: size of the residual
- `nvar`: number of variables
- `nln`: indices of nonlinear residuals
- `nnln`: number of nonlinear general residuals
- `nlin`: number of linear residuals
"""
struct NLSMeta{T, S}
  nequ::Int
  nvar::Int
  x0::S
  nnzj::Int  # Number of elements needed to store the nonzeros of the Jacobian of the residual
  nnzh::Int  # Number of elements needed to store the nonzeros of the sum of Hessians of the residuals

  nln::Vector{Int} # List of nonlinear residuals
  nnln::Int # = length(nln)
  lin::Vector{Int} # List of linear residuals
  nlin::Int # = length(lin)

  jac_residual_available::Bool
  hess_residual_available::Bool
  jprod_residual_available::Bool
  jtprod_residual_available::Bool
  hprod_residual_available::Bool

  function NLSMeta{T, S}(
    nequ::Int,
    nvar::Int;
    x0::S = fill!(S(undef, nvar), zero(T)),
    nnzj = nequ * nvar,
    nnzh = div(nvar * (nvar + 1), 2),
    lin = Int[],
    jac_residual_available::Bool = true,
    hess_residual_available::Bool = true,
    jprod_residual_available::Bool = true,
    jtprod_residual_available::Bool = true,
    hprod_residual_available::Bool = true,
  ) where {T, S}
    nnzj = max(0, nnzj)
    nnzh = max(0, nnzh)

    nln = setdiff(1:nequ, lin)
    nlin = length(lin)
    nnln = length(nln)

    return new{T, S}(
      nequ,
      nvar,
      x0,
      nnzj,
      nnzh,
      nln,
      nnln,
      lin,
      nlin,
      jac_residual_available,
      hess_residual_available,
      jprod_residual_available,
      jtprod_residual_available,
      hprod_residual_available,
    )
  end
end

NLSMeta(nequ::Int, nvar::Int; x0::S = zeros(nvar), kwargs...) where {S} =
  NLSMeta{eltype(S), S}(nequ, nvar; x0 = x0, kwargs...)

"""
    nls_meta(nls)

Returns the `nls_meta` structure of `nls`.
Use this instead of `nls.nls_meta` to handle models that have internal models.

For basic models `nls_meta(nls)` is defined as `nls.nls_meta`, but composite models might not keep `nls_meta` themselves, so they might specialize it to something like `nls.internal.nls_meta`.
"""
nls_meta(nls::AbstractNLSModel) = nls.nls_meta

@testset "NLP API test on a simple model" begin
  f(x) = (x[1] - 2)^2 + (x[2] - 1)^2
  ∇f(x) = [2 * (x[1] - 2); 2 * (x[2] - 1)]
  H(x) = [2.0 0; 0 2.0]
  c(x) = [x[1] - 2x[2] + 1; -x[1]^2 / 4 - x[2]^2 + 1]
  J(x) = [1.0 -2.0; -0.5x[1] -2.0x[2]]
  H(x, y) = H(x) + y[2] * [-0.5 0; 0 -2.0]

  nlp = SimpleNLPModel()
  @test eltype(nlp) == Float64
  n = nlp.meta.nvar
  m = nlp.meta.ncon

  x = randn(n)
  y = randn(m)
  v = randn(n)
  w = randn(m)
  Jv = zeros(m)
  Jtw = zeros(n)
  Hv = zeros(n)
  Hvals = zeros(nlp.meta.nnzh)

  # Basic methods
  @test obj(nlp, x) ≈ f(x)
  @test grad(nlp, x) ≈ ∇f(x)
  @test hess(nlp, x) ≈ tril(H(x))
  @test hprod(nlp, x, v) ≈ H(x) * v
  @test cons(nlp, x) ≈ c(x)
  @test cons_nln(nlp, x) ≈ c(x)[2:2]
  @test cons_lin(nlp, x) == c(x)[1:1]
  @test jac(nlp, x) ≈ J(x)
  @test jac_nln(nlp, x) ≈ J(x)[2:2, :]
  @test jac_lin(nlp, x) ≈ J(x)[1:1, :]
  @test jprod(nlp, x, v) ≈ J(x) * v
  @test jprod_nln(nlp, x, v) ≈ J(x)[2:2, :] * v
  @test jprod_lin(nlp, x, v) ≈ J(x)[1:1, :] * v
  @test jtprod(nlp, x, w) ≈ J(x)' * w
  @test jtprod_nln(nlp, x, w[2:2]) ≈ J(x)[2:2, :]' * w[2:2]
  @test jtprod_lin(nlp, x, w[1:1]) ≈ J(x)[1:1, :]' * w[1:1]
  @test hess(nlp, x, y) ≈ tril(H(x, y))
  @test hprod(nlp, x, y, v) ≈ H(x, y) * v

  # Increasing coverage
  fx, cx = objcons(nlp, x)
  @test fx ≈ f(x)
  @test cx ≈ c(x)
  fx, _ = objcons!(nlp, x, cx)
  @test fx ≈ f(x)
  @test cx ≈ c(x)
  fx, gx = objgrad(nlp, x)
  @test fx ≈ f(x)
  @test gx ≈ ∇f(x)
  fx, _ = objgrad!(nlp, x, gx)
  @test fx ≈ f(x)
  @test gx ≈ ∇f(x)
  @test jprod!(nlp, jac_structure(nlp)..., jac_coord(nlp, x), v, Jv) ≈ J(x) * v
  @test jprod_nln!(nlp, jac_nln_structure(nlp)..., jac_nln_coord(nlp, x), v, Jv[2:2]) ≈
        J(x)[2:2, :] * v
  @test jprod_lin!(nlp, jac_lin_structure(nlp)..., jac_lin_coord(nlp, x), v, Jv[1:1]) ≈
        J(x)[1:1, :] * v
  @test jtprod!(nlp, jac_structure(nlp)..., jac_coord(nlp, x), w, Jtw) ≈ J(x)' * w
  @test jtprod_nln!(nlp, jac_nln_structure(nlp)..., jac_nln_coord(nlp, x), w[2:2], Jtw) ≈
        J(x)[2:2, :]' * w[2:2]
  @test jtprod_lin!(nlp, jac_lin_structure(nlp)..., jac_lin_coord(nlp, x), w[1:1], Jtw) ≈
        J(x)[1:1, :]' * w[1:1]
  Jop = jac_op!(nlp, x, Jv, Jtw)
  @test Jop * v ≈ J(x) * v
  @test Jop' * w ≈ J(x)' * w
  res = J(x) * v - w
  @test mul!(w, Jop, v, 1.0, -1.0) ≈ res
  res = J(x)' * w - v
  @test mul!(v, Jop', w, 1.0, -1.0) ≈ res
  Jop = jac_op!(nlp, jac_structure(nlp)..., jac_coord(nlp, x), Jv, Jtw)
  @test Jop * v ≈ J(x) * v
  @test Jop' * w ≈ J(x)' * w
  res = J(x) * v - w
  @test mul!(w, Jop, v, 1.0, -1.0) ≈ res
  res = J(x)' * w - v
  @test mul!(v, Jop', w, 1.0, -1.0) ≈ res
  Jop = jac_nln_op!(nlp, x, Jv[2:2], Jtw)
  @test Jop * v ≈ J(x)[2:2, :] * v
  @test Jop' * w[2:2] ≈ J(x)[2:2, :]' * w[2:2]
  res = J(x)[2:2, :] * v - w[2:2]
  @test mul!(w[2:2], Jop, v, 1.0, -1.0) ≈ res
  res = J(x)[2:2, :]' * w[2:2] - v
  @test mul!(v, Jop', w[2:2], 1.0, -1.0) ≈ res
  Jop = jac_nln_op!(nlp, jac_nln_structure(nlp)..., jac_nln_coord(nlp, x), Jv[2:2], Jtw)
  @test Jop * v ≈ J(x)[2:2, :] * v
  @test Jop' * w[2:2] ≈ J(x)[2:2, :]' * w[2:2]
  res = J(x)[2:2, :] * v - w[2:2]
  @test mul!(w[2:2], Jop, v, 1.0, -1.0) ≈ res
  res = J(x)[2:2, :]' * w[2:2] - v
  @test mul!(v, Jop', w[2:2], 1.0, -1.0) ≈ res
  Jop = jac_lin_op!(nlp, x, Jv[1:1], Jtw)
  @test Jop * v ≈ J(x)[1:1, :] * v
  @test Jop' * w[1:1] ≈ Jtw
  res = J(x)[1:1, :] * v - w[1:1]
  @test mul!(w[1:1], Jop, v, 1.0, -1.0) ≈ res
  res = J(x)[1:1, :]' * w[1:1] - v
  @test mul!(v, Jop', w[1:1], 1.0, -1.0) ≈ res
  Jop = jac_lin_op!(nlp, jac_lin_structure(nlp)..., jac_lin_coord(nlp, x), Jv[1:1], Jtw)
  @test Jop * v ≈ J(x)[1:1, :] * v
  @test Jop' * w[1:1] ≈ Jtw
  res = J(x)[1:1, :] * v - w[1:1]
  @test mul!(w[1:1], Jop, v, 1.0, -1.0) ≈ res
  res = J(x)[1:1, :]' * w[1:1] - v
  @test mul!(v, Jop', w[1:1], 1.0, -1.0) ≈ res
  for j = 1:(nlp.meta.ncon)
    eⱼ = [i == j ? 1.0 : 0.0 for i = 1:m]
    @test jth_hess(nlp, x, j) == H(x, eⱼ) - H(x)
    @test sparse(hess_structure(nlp)..., jth_hess_coord(nlp, x, j), n, n) == H(x, eⱼ) - H(x)
    @test jth_hprod(nlp, x, v, j) == (H(x, eⱼ) - H(x)) * v
  end
  ghjv = zeros(m)
  for j = 1:m
    eⱼ = [i == j ? 1.0 : 0.0 for i = 1:m]
    Cⱼ(x) = H(x, eⱼ) - H(x)
    ghjv[j] = dot(gx, Cⱼ(x) * v)
  end
  @test ghjvprod(nlp, x, gx, v) ≈ ghjv
  @test hess_coord!(nlp, x, Hvals) == hess_coord!(nlp, x, y * 0, Hvals)
  @test hprod!(nlp, hess_structure(nlp)..., hess_coord(nlp, x), v, Hv) ≈ H(x) * v
  Hop = hess_op(nlp, x)
  @test Hop * v ≈ H(x) * v
  Hop = hess_op!(nlp, x, Hv)
  @test Hop * v ≈ H(x) * v
  z = ones(nlp.meta.nvar)
  res = H(x) * v - z
  @test mul!(z, Hop, v, 1.0, -1.0) ≈ res
  Hop = hess_op!(nlp, hess_structure(nlp)..., hess_coord(nlp, x), Hv)
  @test Hop * v ≈ H(x) * v
  res = H(x) * v - z
  @test mul!(z, Hop, v, 1.0, -1.0) ≈ res
  Hop = hess_op(nlp, x, y)
  @test Hop * v ≈ H(x, y) * v
  Hop = hess_op!(nlp, x, y, Hv)
  @test Hop * v ≈ H(x, y) * v
  res = H(x, y) * v - z
  @test mul!(z, Hop, v, 1.0, -1.0) ≈ res
  Hop = hess_op!(nlp, hess_structure(nlp)..., hess_coord(nlp, x, y), Hv)
  @test Hop * v ≈ H(x, y) * v
end

@testset "test vector types Float32" begin
  nlp = SimpleNLPModel(Float32)
  @test Float32 ==
        eltype(nlp.meta.x0) ==
        eltype(nlp.meta.lvar) ==
        eltype(nlp.meta.uvar) ==
        eltype(nlp.meta.y0) ==
        eltype(nlp.meta.lcon) ==
        eltype(nlp.meta.ucon)
end

@testset "Increase coverage of NLSCounters" begin
  nls = SimpleNLSModel()

  obj(nls, nls.meta.x0)
  residual(nls, nls.meta.x0)
  jac_residual(nls, nls.meta.x0)

  @test neval_obj(nls) == 1
  @test neval_residual(nls) == 2
  @test neval_jac_residual(nls) == 1
  @test sum_counters(nls) == 4

  for counter in fieldnames(Counters)
    increment!(nls, counter)
  end

  for counter in fieldnames(NLSCounters)
    counter == :counters && continue
    increment!(nls, counter)
  end

  # sum all counters of problem `nlp` except 
  # `cons`, `jac`, `jprod` and `jtprod` = 20+7-4+4
  @test sum_counters(nls) == 27

  reset!(nls)
  @test sum_counters(nls) == 0
end

if VERSION ≥ VersionNumber(1, 7, 3)
  @testset "Allocations for NLS counters" begin
    nls = SimpleNLSModel()

    increment!(nls, :neval_obj)
    alloc_mem = @allocated increment!(nls, :neval_obj)
    @test alloc_mem == 0

    increment!(nls, :neval_residual)
    alloc_mem2 = @allocated increment!(nls, :neval_residual)
    @test alloc_mem2 == 0
  end
end

export AbstractNLPModelMeta, NLPModelMeta, reset_data!

"""
    AbstractNLPModelMeta

Base type for metadata related to an optimization model.
"""
abstract type AbstractNLPModelMeta{T, S} end

"""
    NLPModelMeta <: AbstractNLPModelMeta

A composite type that represents the main features of the optimization problem

    optimize    obj(x)
    subject to  lvar ≤    x    ≤ uvar
                lcon ≤ cons(x) ≤ ucon

where `x`        is an `nvar`-dimensional vector,
      `obj`      is the real-valued objective function,
      `cons`     is the vector-valued constraint function,
      `optimize` is either "minimize" or "maximize".

Here, `lvar`, `uvar`, `lcon` and `ucon` are vectors.
Some of their components may be infinite to indicate that the corresponding bound or general constraint is not present.

---

    NLPModelMeta(nvar::Integer; kwargs...)
    NLPModelMeta(meta::AbstractNLPModelMeta; kwargs...)

Create an `NLPModelMeta` with `nvar` variables.
Alternatively, create an `NLPModelMeta` copy from another `AbstractNLPModelMeta`.
The following keyword arguments are accepted:
- `x0`: initial guess
- `lvar`: vector of lower bounds
- `uvar`: vector of upper bounds
- `nlvb`: number of nonlinear variables in both objectives and constraints
- `nlvo`: number of nonlinear variables in objectives (includes nlvb)
- `nlvc`: number of nonlinear variables in constraints (includes nlvb)
- `ncon`: number of general constraints
- `y0`: initial Lagrange multipliers
- `lcon`: vector of constraint lower bounds
- `ucon`: vector of constraint upper bounds
- `nnzo`: number of nonzeros in the gradient
- `nnzj`: number of elements needed to store the nonzeros in the Jacobian
- `lin_nnzj`: number of elements needed to store the nonzeros in the Jacobian of linear constraints
- `nln_nnzj`: number of elements needed to store the nonzeros in the Jacobian of nonlinear constraints
- `nnzh`: number of elements needed to store the nonzeros in the Hessian of the Lagrangian
- `lin`: indices of linear constraints
- `minimize`: true if optimize == minimize
- `islp`: true if the problem is a linear program
- `name`: problem name
- `variable_bounds_analysis`: whether to compute the partition of variables into fixed, lower-bounded, upper-bounded, range-bounded, free, and trivially infeasible sets
- `constraint_bounds_analysis`: whether to compute the partition of constraints into equality, lower-bounded, upper-bounded, range-bounded, free, and trivially infeasible sets
- `sparse_jacobian`: indicates whether the Jacobian of the constraints is sparse
- `sparse_hessian`: indicates whether the Hessian of the Lagrangian is sparse
- `grad_available`: indicates whether the gradient of the objective is available
- `jac_available`: indicates whether the Jacobian of the constraints is available
- `hess_available`: indicates whether the Hessian of the Lagrangian is available
- `jprod_available`: indicates whether the Jacobian-vector product `J * v` is available
- `jtprod_available`: indicates whether the transpose Jacobian-vector product `J' * v` is available
- `hprod_available`: indicates whether the Hessian-vector product of the Lagrangian `H * v` is available

`NLPModelMeta` also contains the following attributes, which are computed from the variables above:
- `nvar`: number of variables
- `ifix`: indices of fixed variables
- `ilow`: indices of variables with lower bound only
- `iupp`: indices of variables with upper bound only
- `irng`: indices of variables with lower and upper bound (range)
- `ifree`: indices of free variables
- `iinf`: indices of visibly infeasible bounds
- `jfix`: indices of equality constraints
- `jlow`: indices of constraints of the form c(x) ≥ cl
- `jupp`: indices of constraints of the form c(x) ≤ cu
- `jrng`: indices of constraints of the form cl ≤ c(x) ≤ cu
- `jfree`: indices of "free" constraints (there shouldn't be any)
- `jinf`: indices of the visibly infeasible constraints
- `nlin`: number of linear constraints
- `nnln`: number of nonlinear general constraints
- `nln`: indices of nonlinear constraints

The attributes `ifix`, `ilow`, `iupp`, `irng`, `ifree`, and `iinf` are not computed if `variable_bounds_analysis` is set to `false`.
The attributes `jfix`, `jlow`, `jupp`, `jrng`, `jfree`, and `jinf` are not computed if `constraint_bounds_analysis` is set to `false`.
"""
struct NLPModelMeta{T, S} <: AbstractNLPModelMeta{T, S}
  nvar::Int
  x0::S
  lvar::S
  uvar::S

  ifix::Vector{Int}
  ilow::Vector{Int}
  iupp::Vector{Int}
  irng::Vector{Int}
  ifree::Vector{Int}
  iinf::Vector{Int}

  nlvb::Int
  nlvo::Int
  nlvc::Int

  ncon::Int
  y0::S
  lcon::S
  ucon::S

  jfix::Vector{Int}
  jlow::Vector{Int}
  jupp::Vector{Int}
  jrng::Vector{Int}
  jfree::Vector{Int}
  jinf::Vector{Int}

  nnzo::Int
  nnzj::Int
  lin_nnzj::Int
  nln_nnzj::Int
  nnzh::Int

  nlin::Int
  nnln::Int

  lin::Vector{Int}
  nln::Vector{Int}

  minimize::Bool
  islp::Bool
  name::String

  variable_bounds_analysis::Bool
  constraint_bounds_analysis::Bool

  sparse_jacobian::Bool
  sparse_hessian::Bool

  grad_available::Bool
  jac_available::Bool
  hess_available::Bool
  jprod_available::Bool
  jtprod_available::Bool
  hprod_available::Bool
end

function NLPModelMeta{T, S}(
  nvar::Int;
  x0::S = fill!(S(undef, nvar), zero(T)),
  lvar::S = fill!(S(undef, nvar), T(-Inf)),
  uvar::S = fill!(S(undef, nvar), T(Inf)),
  nlvb = nvar,
  nlvo = nvar,
  nlvc = nvar,
  ncon = 0,
  y0::S = fill!(S(undef, ncon), zero(T)),
  lcon::S = fill!(S(undef, ncon), T(-Inf)),
  ucon::S = fill!(S(undef, ncon), T(Inf)),
  nnzo = nvar,
  nnzj = nvar * ncon,
  lin_nnzj = 0,
  nln_nnzj = nnzj - lin_nnzj,
  nnzh = nvar * (nvar + 1) ÷ 2,
  lin = Int[],
  minimize::Bool = true,
  islp::Bool = false,
  name = "Generic",
  variable_bounds_analysis::Bool = true,
  constraint_bounds_analysis::Bool = true,
  sparse_jacobian::Bool = true,
  sparse_hessian::Bool = true,
  grad_available::Bool = true,
  jac_available::Bool = (ncon > 0),
  hess_available::Bool = true,
  jprod_available::Bool = (ncon > 0),
  jtprod_available::Bool = (ncon > 0),
  hprod_available::Bool = true,
) where {T, S}
  if (nvar < 1) || (ncon < 0) || (nnzj < 0) || (nnzh < 0)
    error("Nonsensical dimensions")
  end

  @lencheck nvar x0 lvar uvar
  @lencheck ncon y0 lcon ucon
  @rangecheck 1 ncon lin
  @assert nnzj == lin_nnzj + nln_nnzj

  if variable_bounds_analysis
    ifix = findall(lvar .== uvar)
    ilow = findall((lvar .> T(-Inf)) .& (uvar .== T(Inf)))
    iupp = findall((lvar .== T(-Inf)) .& (uvar .< T(Inf)))
    irng = findall((lvar .> T(-Inf)) .& (uvar .< T(Inf)) .& (lvar .< uvar))
    ifree = findall((lvar .== T(-Inf)) .& (uvar .== T(Inf)))
    iinf = findall(lvar .> uvar)
  else
    ifix = Int[]
    ilow = Int[]
    iupp = Int[]
    irng = Int[]
    ifree = Int[]
    iinf = Int[]
  end

  if (ncon > 0) && constraint_bounds_analysis
    jfix = findall(lcon .== ucon)
    jlow = findall((lcon .> T(-Inf)) .& (ucon .== T(Inf)))
    jupp = findall((lcon .== T(-Inf)) .& (ucon .< T(Inf)))
    jrng = findall((lcon .> T(-Inf)) .& (ucon .< T(Inf)) .& (lcon .< ucon))
    jfree = findall((lcon .== T(-Inf)) .& (ucon .== T(Inf)))
    jinf = findall(lcon .> ucon)
  else
    jfix = Int[]
    jlow = Int[]
    jupp = Int[]
    jrng = Int[]
    jfree = Int[]
    jinf = Int[]
  end

  nln = setdiff(1:ncon, lin)
  nlin = length(lin)
  nnln = length(nln)

  NLPModelMeta{T, S}(
    nvar,
    x0,
    lvar,
    uvar,
    ifix,
    ilow,
    iupp,
    irng,
    ifree,
    iinf,
    nlvb,
    nlvo,
    nlvc,
    ncon,
    y0,
    lcon,
    ucon,
    jfix,
    jlow,
    jupp,
    jrng,
    jfree,
    jinf,
    nnzo,
    nnzj,
    lin_nnzj,
    nln_nnzj,
    nnzh,
    nlin,
    nnln,
    lin,
    nln,
    minimize,
    islp,
    name,
    variable_bounds_analysis,
    constraint_bounds_analysis,
    sparse_jacobian,
    sparse_hessian,
    grad_available,
    jac_available,
    hess_available,
    jprod_available,
    jtprod_available,
    hprod_available,
  )
end

NLPModelMeta(nvar::Int; x0::S = zeros(nvar), kwargs...) where {S} =
  NLPModelMeta{eltype(S), S}(nvar, x0 = x0; kwargs...)

function NLPModelMeta(
  meta::AbstractNLPModelMeta{T, S};
  nvar::Int = get_nvar(meta),
  x0::S = get_x0(meta),
  lvar::S = get_lvar(meta),
  uvar::S = get_uvar(meta),
  nlvb = get_nlvb(meta),
  nlvo = get_nlvo(meta),
  nlvc = get_nlvc(meta),
  ncon = get_ncon(meta),
  y0::S = get_y0(meta),
  lcon::S = get_lcon(meta),
  ucon::S = get_ucon(meta),
  nnzo = get_nnzo(meta),
  nnzj = get_nnzj(meta),
  lin_nnzj = get_lin_nnzj(meta),
  nln_nnzj = get_nln_nnzj(meta),
  nnzh = get_nnzh(meta),
  lin = get_lin(meta),
  minimize::Bool = get_minimize(meta),
  islp::Bool = get_islp(meta),
  name = get_name(meta),
  variable_bounds_analysis::Bool = get_variable_bounds_analysis(meta),
  constraint_bounds_analysis::Bool = get_constraint_bounds_analysis(meta),
  sparse_jacobian::Bool = get_sparse_jacobian(meta),
  sparse_hessian::Bool = get_sparse_hessian(meta),
  grad_available::Bool = get_grad_available(meta),
  jac_available::Bool = get_jac_available(meta),
  hess_available::Bool = get_hess_available(meta),
  jprod_available::Bool = get_jprod_available(meta),
  jtprod_available::Bool = get_jtprod_available(meta),
  hprod_available::Bool = get_hprod_available(meta),
) where {T, S}
  NLPModelMeta{T, S}(
    nvar,
    x0 = x0,
    lvar = lvar,
    uvar = uvar,
    nlvb = nlvb,
    nlvo = nlvo,
    nlvc = nlvc,
    ncon = ncon,
    y0 = y0,
    lcon = lcon,
    ucon = ucon,
    nnzo = nnzo,
    nnzj = nnzj,
    lin_nnzj = lin_nnzj,
    nln_nnzj = nln_nnzj,
    nnzh = nnzh,
    lin = lin,
    minimize = minimize,
    islp = islp,
    name = name,
    variable_bounds_analysis = variable_bounds_analysis,
    constraint_bounds_analysis = constraint_bounds_analysis,
    sparse_jacobian = sparse_jacobian,
    sparse_hessian = sparse_hessian,
    grad_available = grad_available,
    jac_available = jac_available,
    hess_available = hess_available,
    jprod_available = jprod_available,
    jtprod_available = jtprod_available,
    hprod_available = hprod_available,
  )
end

"""
    reset_data!(nlp)

Reset model data if appropriate.
This method should be overloaded if a subtype of `AbstractNLPModel`
contains data that should be reset, such as a quasi-Newton linear
operator.
"""
function reset_data!(nlp::AbstractNLPModel)
  return nlp
end

mutable struct SuperNLSModel{T, S} <: AbstractNLSModel{T, S}
  model
end

@testset "Increase coverage of default_nlscounters" begin
  @default_nlscounters SuperNLSModel model
  nls = SuperNLSModel{Float64, Vector{Float64}}(SimpleNLSModel())
  increment!(nls, :neval_residual)
  @test neval_residual(nls.model) == 1
end

for field in fieldnames(NLSMeta)
  meth = Symbol("get_", field)
  @eval begin
    @doc """
        $($meth)(nls)
        $($meth)(nls_meta)
    Return the value $($(QuoteNode(field))) from nls\\_meta or nls.nls\\_meta.
    """
    $meth(nls_meta::NLSMeta) = getproperty(nls_meta, $(QuoteNode(field)))
  end
  @eval $meth(nls::AbstractNLSModel) = $meth(nls.nls_meta)
  @eval export $meth
end

export @default_nlscounters

"""
    @default_nlscounters Model inner

Define functions relating NLS counters of `Model` to NLS counters of `Model.inner`.
"""
macro default_nlscounters(Model, inner)
  ex = Expr(:block)
  for foo in fieldnames(NLSCounters) ∪ [:sum_counters, :reset!]
    foo == :counters && continue
    push!(ex.args, :(NLPModels.$foo(nlp::$(esc(Model))) = $foo(nlp.$inner)))
  end
  push!(ex.args, :(NLPModels.increment!(nlp::$(esc(Model)), s::Symbol) = increment!(nlp.$inner, s)))
  push!(ex.args, :(NLPModels.decrement!(nlp::$(esc(Model)), s::Symbol) = decrement!(nlp.$inner, s)))
  ex
end

mutable struct DummyNLSModel{T, S} <: AbstractNLSModel{T, S}
  nls_meta::NLSMeta{T, S}
end

@testset "Problem type functions" begin
  foo_list = [:nequ, :nvar, :x0, :nnzj, :nnzh, :nln, :nnln, :lin, :nlin]
  meta_list = [
    NLSMeta(2, 2),
    NLSMeta(2, 2, x0 = zeros(2)),
    NLSMeta(2, 3, lin = [1; 3]),
    NLSMeta(2, 3, lin = [2]),
    NLSMeta(1, 4, nnzh = 3, nnzj = 2),
  ]
  for f in fieldnames(NLSMeta), (j, meta) in enumerate(meta_list)
    nls = DummyNLSModel(meta)
    @test eval(Meta.parse("get_" * string(f)))(meta) == getproperty(meta, f)
    @test eval(Meta.parse("get_" * string(f)))(nls) == getproperty(meta, f)
  end
end

export AbstractBatchNLPModel
export obj!

"""
    AbstractBatchNLPModel

Abstract base type for batched nonlinear optimization models.

Each model in the batch has the same number of variables and constraints,
and the sparsity patterns of the Jacobian and the Hessian of the Lagrangian are identical across the batch.
"""
abstract type AbstractBatchNLPModel{T, S} end

function obj(bnlp::AbstractBatchNLPModel{T, S}, bx::AbstractMatrix) where {T, S}
  bf = S(undef, 1, bnlp.meta.nbatch) |> vec
  obj!(bnlp, bx, bf)
  return bf
end

"""
    bf = obj!(bnlp, bx)
"""
function obj! end

function grad(bnlp::AbstractBatchNLPModel{T, S}, bx::AbstractMatrix) where {T, S}
  bg = S(undef, bnlp.meta.nvar, bnlp.meta.nbatch)
  grad!(bnlp, bx, bg)
  return bg
end

function cons(bnlp::AbstractBatchNLPModel{T, S}, bx::AbstractMatrix) where {T, S}
  bc = S(undef, bnlp.meta.ncon, bnlp.meta.nbatch)
  cons!(bnlp, bx, bc)
  return bc
end

function jac_structure(bnlp::AbstractBatchNLPModel)
  jrows = Vector{Int}(undef, bnlp.meta.nnzj)
  jcols = Vector{Int}(undef, bnlp.meta.nnzj)
  jac_structure!(bnlp, jrows, jcols)
  return (jrows, jcols)
end

function jac_coord(bnlp::AbstractBatchNLPModel{T, S}, bx::AbstractMatrix) where {T, S}
  bjvals = S(undef, bnlp.meta.nnzj, bnlp.meta.nbatch)
  jac_coord!(bnlp, bx, bjvals)
  return bjvals
end

function jprod(
  bnlp::AbstractBatchNLPModel{T, S},
  bx::AbstractMatrix,
  bv::AbstractMatrix,
) where {T, S}
  bJv = S(undef, bnlp.meta.ncon, bnlp.meta.nbatch)
  jprod!(bnlp, bx, bv, bJv)
  return bJv
end

function jtprod(
  bnlp::AbstractBatchNLPModel{T, S},
  bx::AbstractMatrix,
  bv::AbstractMatrix,
) where {T, S}
  bJtv = S(undef, bnlp.meta.nvar, bnlp.meta.nbatch)
  jtprod!(bnlp, bx, bv, bJtv)
  return bJtv
end

function hess_structure(bnlp::AbstractBatchNLPModel)
  hrows = Vector{Int}(undef, bnlp.meta.nnzh)
  hcols = Vector{Int}(undef, bnlp.meta.nnzh)
  hess_structure!(bnlp, hrows, hcols)
  return hrows, hcols
end

function hess_coord(
  bnlp::AbstractBatchNLPModel{T, S},
  bx::AbstractMatrix,
  by::AbstractMatrix,
  bobj_weight::AbstractVector,
) where {T, S}
  bhvals = S(undef, bnlp.meta.nnzh, bnlp.meta.nbatch)
  hess_coord!(bnlp, bx, by, bobj_weight, bhvals)
  return bhvals
end

function hprod(
  bnlp::AbstractBatchNLPModel{T, S},
  bx::AbstractMatrix,
  by::AbstractMatrix,
  bv::AbstractMatrix,
  bobj_weight::AbstractVector,
) where {T, S}
  bHv = S(undef, bnlp.meta.nvar, bnlp.meta.nbatch)
  hprod!(bnlp, bx, by, bv, bobj_weight, bHv)
  return bHv
end

export obj, grad, grad!, objgrad, objgrad!, objcons, objcons!
export cons, cons!, cons_lin, cons_lin!, cons_nln, cons_nln!
export jth_con, jth_congrad, jth_congrad!, jth_sparse_congrad
export jac_structure!, jac_structure, jac_coord!, jac_coord
export jac, jprod, jprod!, jtprod, jtprod!, jac_op, jac_op!
export jac_lin_structure!, jac_lin_structure, jac_lin_coord!, jac_lin_coord
export jac_lin, jprod_lin, jprod_lin!, jtprod_lin, jtprod_lin!, jac_lin_op, jac_lin_op!
export jac_nln_structure!, jac_nln_structure, jac_nln_coord!, jac_nln_coord
export jac_nln, jprod_nln, jprod_nln!, jtprod_nln, jtprod_nln!, jac_nln_op, jac_nln_op!
export jth_hess_coord, jth_hess_coord!, jth_hess
export jth_hprod, jth_hprod!, ghjvprod, ghjvprod!
export hess_structure!, hess_structure, hess_coord!, hess_coord
export hess, hprod, hprod!, hess_op, hess_op!
export varscale, lagscale, conscale
export jac_dense!, hess_dense!

"""
    f = obj(nlp, x)

Evaluate ``f(x)``, the objective function of `nlp` at `x`.
"""
function obj end

"""
    g = grad(nlp, x)

Evaluate ``∇f(x)``, the gradient of the objective function at `x`.
This function is only available if `nlp.meta.grad_available` is set to `true`.
"""
function grad(nlp::AbstractNLPModel{T, S}, x::AbstractVector) where {T, S}
  @lencheck get_nvar(nlp.meta) x
  g = S(undef, get_nvar(nlp.meta))
  return grad!(nlp, x, g)
end

"""
    g = grad!(nlp, x, g)

Evaluate ``∇f(x)``, the gradient of the objective function at `x` in place.
This function is only available if `nlp.meta.grad_available` is set to `true`.
"""
function grad! end

"""
    c = cons(nlp, x)

Evaluate ``c(x)``, the constraints at `x`.
"""
function cons(nlp::AbstractNLPModel{T, S}, x::AbstractVector) where {T, S}
  @lencheck get_nvar(nlp.meta) x
  c = S(undef, get_ncon(nlp.meta))
  return cons!(nlp, x, c)
end

"""
    c = cons!(nlp, x, c)

Evaluate ``c(x)``, the constraints at `x` in place.
"""
function cons!(nlp::AbstractNLPModel, x::AbstractVector, cx::AbstractVector)
  @lencheck get_nvar(nlp.meta) x
  @lencheck get_ncon(nlp.meta) cx
  increment!(nlp, :neval_cons)
  if get_nlin(nlp.meta) > 0
    if get_nnln(nlp.meta) == 0
      cons_lin!(nlp, x, cx)
    else
      cons_lin!(nlp, x, view(cx, get_lin(nlp.meta)))
    end
  end
  if get_nnln(nlp.meta) > 0
    if get_nlin(nlp.meta) == 0
      cons_nln!(nlp, x, cx)
    else
      cons_nln!(nlp, x, view(cx, get_nln(nlp.meta)))
    end
  end
  return cx
end

"""
    c = cons_lin(nlp, x)

Evaluate the linear constraints at `x`.
"""
function cons_lin(nlp::AbstractNLPModel{T, S}, x::AbstractVector) where {T, S}
  @lencheck get_nvar(nlp.meta) x
  c = S(undef, get_nlin(nlp.meta))
  return cons_lin!(nlp, x, c)
end

"""
    c = cons_lin!(nlp, x, c)

Evaluate the linear constraints at `x` in place.
"""
function cons_lin! end

"""
    c = cons_nln(nlp, x)

Evaluate the nonlinear constraints at `x`.
"""
function cons_nln(nlp::AbstractNLPModel{T, S}, x::AbstractVector) where {T, S}
  @lencheck get_nvar(nlp.meta) x
  c = S(undef, get_nnln(nlp.meta))
  return cons_nln!(nlp, x, c)
end

"""
    c = cons_nln!(nlp, x, c)

Evaluate the nonlinear constraints at `x` in place.
"""
function cons_nln! end

function jth_con end

function jth_congrad(nlp::AbstractNLPModel{T, S}, x::AbstractVector, j::Integer) where {T, S}
  @lencheck get_nvar(nlp.meta) x
  g = S(undef, get_nvar(nlp.meta))
  return jth_congrad!(nlp, x, j, g)
end

function jth_congrad! end

function jth_sparse_congrad end

"""
    f, c = objcons(nlp, x)

Evaluate ``f(x)`` and ``c(x)`` at `x`.
"""
function objcons(nlp::AbstractNLPModel{T, S}, x::AbstractVector) where {T, S}
  @lencheck get_nvar(nlp.meta) x
  c = S(undef, get_ncon(nlp.meta))
  return objcons!(nlp, x, c)
end

"""
    f, c = objcons!(nlp, x, c)

Evaluate ``f(x)`` and ``c(x)`` at `x`. `c` is overwritten with the value of ``c(x)``.
"""
function objcons!(nlp::AbstractNLPModel, x::AbstractVector, c::AbstractVector)
  @lencheck get_nvar(nlp.meta) x
  @lencheck get_ncon(nlp.meta) c
  f = obj(nlp, x)
  cons!(nlp, x, c)
  return f, c
end

"""
    f, g = objgrad(nlp, x)

Evaluate ``f(x)`` and ``∇f(x)`` at `x`.
This function is only available if `nlp.meta.grad_available` is set to `true`.
"""
function objgrad(nlp::AbstractNLPModel{T, S}, x::AbstractVector) where {T, S}
  @lencheck get_nvar(nlp.meta) x
  g = S(undef, get_nvar(nlp.meta))
  return objgrad!(nlp, x, g)
end

"""
    f, g = objgrad!(nlp, x, g)

Evaluate ``f(x)`` and ``∇f(x)`` at `x`. `g` is overwritten with the value of ``∇f(x)``.
This function is only available if `nlp.meta.grad_available` is set to `true`.
"""
function objgrad!(nlp::AbstractNLPModel, x::AbstractVector, g::AbstractVector)
  @lencheck get_nvar(nlp.meta) x g
  f = obj(nlp, x)
  grad!(nlp, x, g)
  return f, g
end

"""
    (rows,cols) = jac_structure(nlp.meta)

Return the structure of the constraints Jacobian in sparse coordinate format.
This function is only available when both `nlp.meta.jac_available` and `nlp.meta.sparse_jacobian` are set to `true`.
"""
function jac_structure(nlp::AbstractNLPModel)
  rows = Vector{Int}(undef, get_nnzj(nlp.meta))
  cols = Vector{Int}(undef, get_nnzj(nlp.meta))
  jac_structure!(nlp, rows, cols)
end

"""
    jac_structure!(nlp, rows, cols)

Return the structure of the constraints Jacobian in sparse coordinate format in place.
This function is only available when both `nlp.meta.jac_available` and `nlp.meta.sparse_jacobian` are set to `true`.
"""
function jac_structure!(
  nlp::AbstractNLPModel,
  rows::AbstractVector{T},
  cols::AbstractVector{T},
) where {T}
  @lencheck get_nnzj(nlp.meta) rows cols
  lin_ind = 1:(get_lin_nnzj(nlp.meta))
  if get_nlin(nlp.meta) > 0
    if get_nnln(nlp.meta) == 0
      jac_lin_structure!(nlp, rows, cols)
    else
      jac_lin_structure!(nlp, view(rows, lin_ind), view(cols, lin_ind))
      for i in lin_ind
        rows[i] += count(x < get_lin(nlp.meta)[rows[i]] for x in get_nln(nlp.meta))
      end
    end
  end
  if get_nnln(nlp.meta) > 0
    if get_nlin(nlp.meta) == 0
      jac_nln_structure!(nlp, rows, cols)
    else
      nln_ind = (get_lin_nnzj(nlp.meta) + 1):(get_lin_nnzj(nlp.meta) + get_nln_nnzj(nlp.meta))
      jac_nln_structure!(nlp, view(rows, nln_ind), view(cols, nln_ind))
      for i in nln_ind
        rows[i] += count(x < get_nln(nlp.meta)[rows[i]] for x in get_lin(nlp.meta))
      end
    end
  end
  return rows, cols
end

"""
    (rows,cols) = jac_lin_structure(nlp.meta)

Return the structure of the linear constraints Jacobian in sparse coordinate format.
This function is only available when both `nlp.meta.jac_available` and `nlp.meta.sparse_jacobian` are set to `true`.
"""
function jac_lin_structure(nlp::AbstractNLPModel)
  rows = Vector{Int}(undef, get_lin_nnzj(nlp.meta))
  cols = Vector{Int}(undef, get_lin_nnzj(nlp.meta))
  jac_lin_structure!(nlp, rows, cols)
end

"""
    jac_lin_structure!(nlp, rows, cols)

Return the structure of the linear constraints Jacobian in sparse coordinate format in place.
This function is only available when both `nlp.meta.jac_available` and `nlp.meta.sparse_jacobian` are set to `true`.
"""
function jac_lin_structure! end

"""
    (rows,cols) = jac_nln_structure(nlp.meta)

Return the structure of the nonlinear constraints Jacobian in sparse coordinate format.
This function is only available when both `nlp.meta.jac_available` and `nlp.meta.sparse_jacobian` are set to `true`.
"""
function jac_nln_structure(nlp::AbstractNLPModel)
  rows = Vector{Int}(undef, get_nln_nnzj(nlp.meta))
  cols = Vector{Int}(undef, get_nln_nnzj(nlp.meta))
  jac_nln_structure!(nlp, rows, cols)
end

"""
    jac_nln_structure!(nlp, rows, cols)

Return the structure of the nonlinear constraints Jacobian in sparse coordinate format in place.
This function is only available when both `nlp.meta.jac_available` and `nlp.meta.sparse_jacobian` are set to `true`.
"""
function jac_nln_structure! end

"""
    vals = jac_coord!(nlp, x, vals)

Evaluate ``J(x)``, the constraints Jacobian at `x` in sparse coordinate format, overwriting `vals`.
This function is only available when both `nlp.meta.jac_available` and `nlp.meta.sparse_jacobian` are set to `true`.
"""
function jac_coord!(nlp::AbstractNLPModel, x::AbstractVector, vals::AbstractVector)
  @lencheck get_nvar(nlp.meta) x
  @lencheck get_nnzj(nlp.meta) vals
  increment!(nlp, :neval_jac)
  if get_nlin(nlp.meta) > 0
    if get_nnln(nlp.meta) == 0
      jac_lin_coord!(nlp, x, vals)
    else
      lin_ind = 1:(get_lin_nnzj(nlp.meta))
      jac_lin_coord!(nlp, x, view(vals, lin_ind))
    end
  end
  if get_nnln(nlp.meta) > 0
    if get_nlin(nlp.meta) == 0
      jac_nln_coord!(nlp, x, vals)
    else
      nln_ind = (get_lin_nnzj(nlp.meta) + 1):(get_lin_nnzj(nlp.meta) + get_nln_nnzj(nlp.meta))
      jac_nln_coord!(nlp, x, view(vals, nln_ind))
    end
  end
  return vals
end

"""
    vals = jac_coord(nlp, x)

Evaluate ``J(x)``, the constraints Jacobian at `x` in sparse coordinate format.
This function is only available when both `nlp.meta.jac_available` and `nlp.meta.sparse_jacobian` are set to `true`.
"""
function jac_coord(nlp::AbstractNLPModel{T, S}, x::AbstractVector) where {T, S}
  @lencheck get_nvar(nlp.meta) x
  vals = S(undef, get_nnzj(nlp.meta))
  return jac_coord!(nlp, x, vals)
end

"""
    Jx = jac_dense!(nlp, x, Jx)

Evaluate ``J(x)``, the constraints Jacobian at `x` in dense format, overwriting `Jx`.
This function is only available when `nlp.meta.jac_available` is set to `true` and `nlp.meta.sparse_jacobian` is set to `false`.
"""
function jac_dense! end

"""
    Jx = jac(nlp, x)

Evaluate ``J(x)``, the constraints Jacobian at `x` as a sparse matrix.
This function is only available when both `nlp.meta.jac_available` and `nlp.meta.sparse_jacobian` are set to `true`.
"""
function jac(nlp::AbstractNLPModel, x::AbstractVector)
  @lencheck get_nvar(nlp.meta) x
  rows, cols = jac_structure(nlp)
  vals = jac_coord(nlp, x)
  sparse(rows, cols, vals, get_ncon(nlp.meta), get_nvar(nlp.meta))
end

"""
    vals = jac_lin_coord!(nlp, x, vals)

Evaluate ``J(x)``, the linear constraints Jacobian at `x` in sparse coordinate format, overwriting `vals`.
This function is only available when both `nlp.meta.jac_available` and `nlp.meta.sparse_jacobian` are set to `true`.
"""
function jac_lin_coord! end

"""
    vals = jac_lin_coord(nlp, x)

Evaluate ``J(x)``, the linear constraints Jacobian at `x` in sparse coordinate format.
This function is only available when both `nlp.meta.jac_available` and `nlp.meta.sparse_jacobian` are set to `true`.
"""
function jac_lin_coord(nlp::AbstractNLPModel{T, S}, x::AbstractVector) where {T, S}
  @lencheck get_nvar(nlp.meta) x
  vals = S(undef, get_lin_nnzj(nlp.meta))
  return jac_lin_coord!(nlp, x, vals)
end

"""
    Jx = jac_lin(nlp, x)

Evaluate ``J(x)``, the linear constraints Jacobian at `x` as a sparse matrix.
This function is only available when both `nlp.meta.jac_available` and `nlp.meta.sparse_jacobian` are set to `true`.
"""
function jac_lin(nlp::AbstractNLPModel, x::AbstractVector)
  @lencheck get_nvar(nlp.meta) x
  rows, cols = jac_lin_structure(nlp)
  vals = jac_lin_coord(nlp, x)
  sparse(rows, cols, vals, get_nlin(nlp.meta), get_nvar(nlp.meta))
end

"""
    vals = jac_nln_coord!(nlp, x, vals)

Evaluate ``J(x)``, the nonlinear constraints Jacobian at `x` in sparse coordinate format, overwriting `vals`.
This function is only available when both `nlp.meta.jac_available` and `nlp.meta.sparse_jacobian` are set to `true`.
"""
function jac_nln_coord! end

"""
    vals = jac_nln_coord(nlp, x)

Evaluate ``J(x)``, the nonlinear constraints Jacobian at `x` in sparse coordinate format.
This function is only available when both `nlp.meta.jac_available` and `nlp.meta.sparse_jacobian` are set to `true`.
"""
function jac_nln_coord(nlp::AbstractNLPModel{T, S}, x::AbstractVector) where {T, S}
  @lencheck get_nvar(nlp.meta) x
  vals = S(undef, get_nln_nnzj(nlp.meta))
  return jac_nln_coord!(nlp, x, vals)
end

"""
    Jx = jac_nln(nlp, x)

Evaluate ``J(x)``, the nonlinear constraints Jacobian at `x` as a sparse matrix.
This function is only available when both `nlp.meta.jac_available` and `nlp.meta.sparse_jacobian` are set to `true`.
"""
function jac_nln(nlp::AbstractNLPModel, x::AbstractVector)
  @lencheck get_nvar(nlp.meta) x
  rows, cols = jac_nln_structure(nlp)
  vals = jac_nln_coord(nlp, x)
  sparse(rows, cols, vals, get_nnln(nlp.meta), get_nvar(nlp.meta))
end

"""
    Jv = jprod(nlp, x, v)

Evaluate ``J(x)v``, the Jacobian-vector product at `x`.
This function is only available if `nlp.meta.jprod_available` is set to `true`.
"""
function jprod(nlp::AbstractNLPModel{T, S}, x::AbstractVector, v::AbstractVector) where {T, S}
  @lencheck get_nvar(nlp.meta) x v
  Jv = S(undef, get_ncon(nlp.meta))
  return jprod!(nlp, x, v, Jv)
end

"""
    Jv = jprod!(nlp, x, v, Jv)

Evaluate ``J(x)v``, the Jacobian-vector product at `x` in place.
This function is only available if `nlp.meta.jprod_available` is set to `true`.
"""
function jprod!(nlp::AbstractNLPModel, x::AbstractVector, v::AbstractVector, Jv::AbstractVector)
  @lencheck get_nvar(nlp.meta) x v
  @lencheck get_ncon(nlp.meta) Jv
  increment!(nlp, :neval_jprod)
  if get_nlin(nlp.meta) > 0
    if get_nnln(nlp.meta) == 0
      jprod_lin!(nlp, x, v, Jv)
    else
      jprod_lin!(nlp, x, v, view(Jv, get_lin(nlp.meta)))
    end
  end
  if get_nnln(nlp.meta) > 0
    if get_nlin(nlp.meta) == 0
      jprod_nln!(nlp, x, v, Jv)
    else
      jprod_nln!(nlp, x, v, view(Jv, get_nln(nlp.meta)))
    end
  end
  return Jv
end

"""
    Jv = jprod!(nlp, rows, cols, vals, v, Jv)

Evaluate ``J(x)v``, the Jacobian-vector product, where the Jacobian is given by `(rows, cols, vals)` in triplet format.
This function is only available if `nlp.meta.jprod_available` is set to `true`.
"""
function jprod!(
  nlp::AbstractNLPModel,
  rows::AbstractVector{<:Integer},
  cols::AbstractVector{<:Integer},
  vals::AbstractVector,
  v::AbstractVector,
  Jv::AbstractVector,
)
  @lencheck get_nnzj(nlp.meta) rows cols vals
  @lencheck get_nvar(nlp.meta) v
  @lencheck get_ncon(nlp.meta) Jv
  increment!(nlp, :neval_jprod)
  coo_prod!(rows, cols, vals, v, Jv)
end

"""
    Jv = jprod_lin(nlp, x, v)

Evaluate ``J(x)v``, the linear Jacobian-vector product at `x`.
This function is only available if `nlp.meta.jprod_available` is set to `true`.
"""
function jprod_lin(nlp::AbstractNLPModel{T, S}, x::AbstractVector, v::AbstractVector) where {T, S}
  @lencheck get_nvar(nlp.meta) x v
  Jv = S(undef, get_nlin(nlp.meta))
  return jprod_lin!(nlp, x, v, Jv)
end

"""
    Jv = jprod_lin!(nlp, x, v, Jv)

Evaluate ``J(x)v``, the linear Jacobian-vector product at `x` in place.
This function is only available if `nlp.meta.jprod_available` is set to `true`.
"""
function jprod_lin! end

"""
    Jv = jprod_lin!(nlp, rows, cols, vals, v, Jv)

Evaluate ``J(x)v``, the linear Jacobian-vector product, where the Jacobian is given by `(rows, cols, vals)` in triplet format.
This function is only available if `nlp.meta.jprod_available` is set to `true`.
"""
function jprod_lin!(
  nlp::AbstractNLPModel,
  rows::AbstractVector{<:Integer},
  cols::AbstractVector{<:Integer},
  vals::AbstractVector,
  v::AbstractVector,
  Jv::AbstractVector,
)
  @lencheck get_lin_nnzj(nlp.meta) rows cols vals
  @lencheck get_nvar(nlp.meta) v
  @lencheck get_nlin(nlp.meta) Jv
  increment!(nlp, :neval_jprod_lin)
  coo_prod!(rows, cols, vals, v, Jv)
end

"""
    Jv = jprod_nln(nlp, x, v)

Evaluate ``J(x)v``, the nonlinear Jacobian-vector product at `x`.
This function is only available if `nlp.meta.jprod_available` is set to `true`.
"""
function jprod_nln(nlp::AbstractNLPModel{T, S}, x::AbstractVector, v::AbstractVector) where {T, S}
  @lencheck get_nvar(nlp.meta) x v
  Jv = S(undef, get_nnln(nlp.meta))
  return jprod_nln!(nlp, x, v, Jv)
end

"""
    Jv = jprod_nln!(nlp, x, v, Jv)

Evaluate ``J(x)v``, the nonlinear Jacobian-vector product at `x` in place.
This function is only available if `nlp.meta.jprod_available` is set to `true`.
"""
function jprod_nln! end

"""
    Jv = jprod_nln!(nlp, rows, cols, vals, v, Jv)

Evaluate ``J(x)v``, the nonlinear Jacobian-vector product, where the Jacobian is given by `(rows, cols, vals)` in triplet format.
This function is only available if `nlp.meta.jprod_available` is set to `true`.
"""
function jprod_nln!(
  nlp::AbstractNLPModel,
  rows::AbstractVector{<:Integer},
  cols::AbstractVector{<:Integer},
  vals::AbstractVector,
  v::AbstractVector,
  Jv::AbstractVector,
)
  @lencheck get_nln_nnzj(nlp.meta) rows cols vals
  @lencheck get_nvar(nlp.meta) v
  @lencheck get_nnln(nlp.meta) Jv
  increment!(nlp, :neval_jprod_nln)
  coo_prod!(rows, cols, vals, v, Jv)
end

"""
    Jtv = jtprod(nlp, x, v)

Evaluate ``J(x)^Tv``, the transposed-Jacobian-vector product at `x`.
This function is only available if `nlp.meta.jtprod_available` is set to `true`.
"""
function jtprod(nlp::AbstractNLPModel{T, S}, x::AbstractVector, v::AbstractVector) where {T, S}
  @lencheck get_nvar(nlp.meta) x
  @lencheck get_ncon(nlp.meta) v
  Jtv = S(undef, get_nvar(nlp.meta))
  return jtprod!(nlp, x, v, Jtv)
end

"""
    Jtv = jtprod!(nlp, x, v, Jtv)

Evaluate ``J(x)^Tv``, the transposed-Jacobian-vector product at `x` in place.
If the problem has linear and nonlinear constraints, this function allocates.
This function is only available if `nlp.meta.jtprod_available` is set to `true`.
"""
function jtprod!(nlp::AbstractNLPModel, x::AbstractVector, v::AbstractVector, Jtv::AbstractVector)
  @lencheck get_nvar(nlp.meta) x Jtv
  @lencheck get_ncon(nlp.meta) v
  increment!(nlp, :neval_jtprod)
  if get_nnln(nlp.meta) == 0
    (get_nlin(nlp.meta) > 0) && jtprod_lin!(nlp, x, v, Jtv)
  elseif get_nlin(nlp.meta) == 0
    (get_nnln(nlp.meta) > 0) && jtprod_nln!(nlp, x, v, Jtv)
  elseif get_nlin(nlp.meta) >= get_nnln(nlp.meta)
    jtprod_lin!(nlp, x, view(v, get_lin(nlp.meta)), Jtv)
    if get_nnln(nlp.meta) > 0
      Jtv .+= jtprod_nln(nlp, x, view(v, get_nln(nlp.meta)))
    end
  else
    jtprod_nln!(nlp, x, view(v, get_nln(nlp.meta)), Jtv)
    if get_nlin(nlp.meta) > 0
      Jtv .+= jtprod_lin(nlp, x, view(v, get_lin(nlp.meta)))
    end
  end
  return Jtv
end

"""
    Jtv = jtprod!(nlp, rows, cols, vals, v, Jtv)

Evaluate ``J(x)^Tv``, the transposed-Jacobian-vector product, where the
Jacobian is given by `(rows, cols, vals)` in triplet format.
This function is only available if `nlp.meta.jtprod_available` is set to `true`.
"""
function jtprod!(
  nlp::AbstractNLPModel,
  rows::AbstractVector{<:Integer},
  cols::AbstractVector{<:Integer},
  vals::AbstractVector,
  v::AbstractVector,
  Jtv::AbstractVector,
)
  @lencheck get_nnzj(nlp.meta) rows cols vals
  @lencheck get_ncon(nlp.meta) v
  @lencheck get_nvar(nlp.meta) Jtv
  increment!(nlp, :neval_jtprod)
  coo_prod!(cols, rows, vals, v, Jtv)
end

"""
    Jtv = jtprod_lin(nlp, x, v)

Evaluate ``J(x)^Tv``, the linear transposed-Jacobian-vector product at `x`.
This function is only available if `nlp.meta.jtprod_available` is set to `true`.
"""
function jtprod_lin(nlp::AbstractNLPModel{T, S}, x::AbstractVector, v::AbstractVector) where {T, S}
  @lencheck get_nvar(nlp.meta) x
  @lencheck get_nlin(nlp.meta) v
  Jtv = S(undef, get_nvar(nlp.meta))
  return jtprod_lin!(nlp, x, v, Jtv)
end

"""
    Jtv = jtprod_lin!(nlp, x, v, Jtv)

Evaluate ``J(x)^Tv``, the linear transposed-Jacobian-vector product at `x` in place.
This function is only available if `nlp.meta.jtprod_available` is set to `true`.
"""
function jtprod_lin! end

"""
    Jtv = jtprod_lin!(nlp, rows, cols, vals, v, Jtv)

Evaluate ``J(x)^Tv``, the linear transposed-Jacobian-vector product, where the
Jacobian is given by `(rows, cols, vals)` in triplet format.
This function is only available if `nlp.meta.jtprod_available` is set to `true`.
"""
function jtprod_lin!(
  nlp::AbstractNLPModel,
  rows::AbstractVector{<:Integer},
  cols::AbstractVector{<:Integer},
  vals::AbstractVector,
  v::AbstractVector,
  Jtv::AbstractVector,
)
  @lencheck get_lin_nnzj(nlp.meta) rows cols vals
  @lencheck get_nlin(nlp.meta) v
  @lencheck get_nvar(nlp.meta) Jtv
  increment!(nlp, :neval_jtprod_lin)
  coo_prod!(cols, rows, vals, v, Jtv)
end

"""
    Jtv = jtprod_nln(nlp, x, v)

Evaluate ``J(x)^Tv``, the nonlinear transposed-Jacobian-vector product at `x`.
This function is only available if `nlp.meta.jtprod_available` is set to `true`.
"""
function jtprod_nln(nlp::AbstractNLPModel{T, S}, x::AbstractVector, v::AbstractVector) where {T, S}
  @lencheck get_nvar(nlp.meta) x
  @lencheck get_nnln(nlp.meta) v
  Jtv = S(undef, get_nvar(nlp.meta))
  return jtprod_nln!(nlp, x, v, Jtv)
end

"""
    Jtv = jtprod_nln!(nlp, x, v, Jtv)

Evaluate ``J(x)^Tv``, the nonlinear transposed-Jacobian-vector product at `x` in place.
This function is only available if `nlp.meta.jtprod_available` is set to `true`.
"""
function jtprod_nln! end

"""
    Jtv = jtprod_nln!(nlp, rows, cols, vals, v, Jtv)

Evaluate ``J(x)^Tv``, the nonlinear transposed-Jacobian-vector product, where the
Jacobian is given by `(rows, cols, vals)` in triplet format.
This function is only available if `nlp.meta.jtprod_available` is set to `true`.
"""
function jtprod_nln!(
  nlp::AbstractNLPModel,
  rows::AbstractVector{<:Integer},
  cols::AbstractVector{<:Integer},
  vals::AbstractVector,
  v::AbstractVector,
  Jtv::AbstractVector,
)
  @lencheck get_nln_nnzj(nlp.meta) rows cols vals
  @lencheck get_nnln(nlp.meta) v
  @lencheck get_nvar(nlp.meta) Jtv
  increment!(nlp, :neval_jtprod_nln)
  coo_prod!(cols, rows, vals, v, Jtv)
end

"""
    J = jac_op(nlp, x)

Return the Jacobian at `x` as a linear operator.
The resulting object may be used as if it were a matrix, e.g., `J * v` or  `J' * v`.
This function is only available if both `nlp.meta.jprod_available` and `nlp.meta.jtprod_available` are set to `true`.
"""
function jac_op(nlp::AbstractNLPModel{T, S}, x::AbstractVector) where {T, S}
  @lencheck get_nvar(nlp.meta) x
  Jv = S(undef, get_ncon(nlp.meta))
  Jtv = S(undef, get_nvar(nlp.meta))
  return jac_op!(nlp, x, Jv, Jtv)
end

"""
    J = jac_op!(nlp, x, Jv, Jtv)

Return the Jacobian at `x` as a linear operator.
The resulting object may be used as if it were a matrix, e.g., `J * v` or `J' * v`.
The values `Jv` and `Jtv` are used as preallocated storage for the operations.
This function is only available if both `nlp.meta.jprod_available` and `nlp.meta.jtprod_available` are set to `true`.
"""
function jac_op!(
  nlp::AbstractNLPModel{T, S},
  x::AbstractVector{T},
  Jv::AbstractVector,
  Jtv::AbstractVector,
) where {T, S}
  @lencheck get_nvar(nlp.meta) x Jtv
  @lencheck get_ncon(nlp.meta) Jv
  prod! = @closure (res, v, α, β) -> begin # res = α * J * v + β * res
    jprod!(nlp, x, v, Jv)
    if β == 0
      res .= α .* Jv
    else
      res .= α .* Jv .+ β .* res
    end
    return res
  end
  ctprod! = @closure (res, v, α, β) -> begin
    jtprod!(nlp, x, v, Jtv)
    if β == 0
      res .= α .* Jtv
    else
      res .= α .* Jtv .+ β .* res
    end
    return res
  end
  return LinearOperator{T, S}(
    get_ncon(nlp.meta),
    get_nvar(nlp.meta),
    false,
    false,
    prod!,
    ctprod!,
    ctprod!,
  )
end

"""
    J = jac_op!(nlp, rows, cols, vals, Jv, Jtv)

Return the Jacobian given by `(rows, cols, vals)` as a linear operator.
The resulting object may be used as if it were a matrix, e.g., `J * v` or `J' * v`.
The values `Jv` and `Jtv` are used as preallocated storage for the operations.
This function is only available if both `nlp.meta.jprod_available` and `nlp.meta.jtprod_available` are set to `true`.
"""
function jac_op!(
  nlp::AbstractNLPModel{T, S},
  rows::AbstractVector{<:Integer},
  cols::AbstractVector{<:Integer},
  vals::AbstractVector{T},
  Jv::AbstractVector,
  Jtv::AbstractVector,
) where {T, S}
  @lencheck get_nnzj(nlp.meta) rows cols vals
  @lencheck get_ncon(nlp.meta) Jv
  @lencheck get_nvar(nlp.meta) Jtv
  prod! = @closure (res, v, α, β) -> begin # res = α * J * v + β * res
    jprod!(nlp, rows, cols, vals, v, Jv)
    if β == 0
      res .= α .* Jv
    else
      res .= α .* Jv .+ β .* res
    end
    return res
  end
  ctprod! = @closure (res, v, α, β) -> begin
    jtprod!(nlp, rows, cols, vals, v, Jtv)
    if β == 0
      res .= α .* Jtv
    else
      res .= α .* Jtv .+ β .* res
    end
    return res
  end
  return LinearOperator{T, S}(
    get_ncon(nlp.meta),
    get_nvar(nlp.meta),
    false,
    false,
    prod!,
    ctprod!,
    ctprod!,
  )
end

"""
    J = jac_lin_op(nlp, x)

Return the linear Jacobian at `x` as a linear operator.
The resulting object may be used as if it were a matrix, e.g., `J * v` or `J' * v`.
This function is only available if both `nlp.meta.jprod_available` and `nlp.meta.jtprod_available` are set to `true`.
"""
function jac_lin_op(nlp::AbstractNLPModel{T, S}, x::AbstractVector) where {T, S}
  @lencheck get_nvar(nlp.meta) x
  Jv = S(undef, get_nlin(nlp.meta))
  Jtv = S(undef, get_nvar(nlp.meta))
  return jac_lin_op!(nlp, x, Jv, Jtv)
end

"""
    J = jac_lin_op!(nlp, x, Jv, Jtv)

Return the linear Jacobian at `x` as a linear operator.
The resulting object may be used as if it were a matrix, e.g., `J * v` or `J' * v`.
The values `Jv` and `Jtv` are used as preallocated storage for the operations.
This function is only available if both `nlp.meta.jprod_available` and `nlp.meta.jtprod_available` are set to `true`.
"""
function jac_lin_op!(
  nlp::AbstractNLPModel{T, S},
  x::AbstractVector{T},
  Jv::AbstractVector,
  Jtv::AbstractVector,
) where {T, S}
  @lencheck get_nvar(nlp.meta) x Jtv
  @lencheck get_nlin(nlp.meta) Jv
  prod! = @closure (res, v, α, β) -> begin # res = α * J * v + β * res
    jprod_lin!(nlp, x, v, Jv)
    if β == 0
      res .= α .* Jv
    else
      res .= α .* Jv .+ β .* res
    end
    return res
  end
  ctprod! = @closure (res, v, α, β) -> begin
    jtprod_lin!(nlp, x, v, Jtv)
    if β == 0
      res .= α .* Jtv
    else
      res .= α .* Jtv .+ β .* res
    end
    return res
  end
  return LinearOperator{T, S}(
    get_nlin(nlp.meta),
    get_nvar(nlp.meta),
    false,
    false,
    prod!,
    ctprod!,
    ctprod!,
  )
end

"""
    J = jac_lin_op!(nlp, rows, cols, vals, Jv, Jtv)

Return the linear Jacobian given by `(rows, cols, vals)` as a linear operator.
The resulting object may be used as if it were a matrix, e.g., `J * v` or `J' * v`.
The values `Jv` and `Jtv` are used as preallocated storage for the operations.
This function is only available if both `nlp.meta.jprod_available` and `nlp.meta.jtprod_available` are set to `true`.
"""
function jac_lin_op!(
  nlp::AbstractNLPModel{T, S},
  rows::AbstractVector{<:Integer},
  cols::AbstractVector{<:Integer},
  vals::AbstractVector{T},
  Jv::AbstractVector,
  Jtv::AbstractVector,
) where {T, S}
  @lencheck get_lin_nnzj(nlp.meta) rows cols vals
  @lencheck get_nlin(nlp.meta) Jv
  @lencheck get_nvar(nlp.meta) Jtv
  prod! = @closure (res, v, α, β) -> begin # res = α * J * v + β * res
    jprod_lin!(nlp, rows, cols, vals, v, Jv)
    if β == 0
      res .= α .* Jv
    else
      res .= α .* Jv .+ β .* res
    end
    return res
  end
  ctprod! = @closure (res, v, α, β) -> begin
    jtprod_lin!(nlp, rows, cols, vals, v, Jtv)
    if β == 0
      res .= α .* Jtv
    else
      res .= α .* Jtv .+ β .* res
    end
    return res
  end
  return LinearOperator{T, S}(
    get_nlin(nlp.meta),
    get_nvar(nlp.meta),
    false,
    false,
    prod!,
    ctprod!,
    ctprod!,
  )
end

"""
    J = jac_nln_op(nlp, x)

Return the nonlinear Jacobian at `x` as a linear operator.
The resulting object may be used as if it were a matrix, e.g., `J * v` or `J' * v`.
This function is only available if both `nlp.meta.jprod_available` and `nlp.meta.jtprod_available` are set to `true`.
"""
function jac_nln_op(nlp::AbstractNLPModel{T, S}, x::AbstractVector) where {T, S}
  @lencheck get_nvar(nlp.meta) x
  Jv = S(undef, get_nnln(nlp.meta))
  Jtv = S(undef, get_nvar(nlp.meta))
  return jac_nln_op!(nlp, x, Jv, Jtv)
end

"""
    J = jac_nln_op!(nlp, x, Jv, Jtv)

Return the nonlinear Jacobian at `x` as a linear operator.
The resulting object may be used as if it were a matrix, e.g., `J * v` or `J' * v`.
The values `Jv` and `Jtv` are used as preallocated storage for the operations.
This function is only available if both `nlp.meta.jprod_available` and `nlp.meta.jtprod_available` are set to `true`.
"""
function jac_nln_op!(
  nlp::AbstractNLPModel{T, S},
  x::AbstractVector{T},
  Jv::AbstractVector,
  Jtv::AbstractVector,
) where {T, S}
  @lencheck get_nvar(nlp.meta) x Jtv
  @lencheck get_nnln(nlp.meta) Jv
  prod! = @closure (res, v, α, β) -> begin # res = α * J * v + β * res
    jprod_nln!(nlp, x, v, Jv)
    if β == 0
      res .= α .* Jv
    else
      res .= α .* Jv .+ β .* res
    end
    return res
  end
  ctprod! = @closure (res, v, α, β) -> begin
    jtprod_nln!(nlp, x, v, Jtv)
    if β == 0
      res .= α .* Jtv
    else
      res .= α .* Jtv .+ β .* res
    end
    return res
  end
  return LinearOperator{T, S}(
    get_nnln(nlp.meta),
    get_nvar(nlp.meta),
    false,
    false,
    prod!,
    ctprod!,
    ctprod!,
  )
end

"""
    J = jac_nln_op!(nlp, rows, cols, vals, Jv, Jtv)

Return the nonlinear Jacobian given by `(rows, cols, vals)` as a linear operator.
The resulting object may be used as if it were a matrix, e.g., `J * v` or `J' * v`.
The values `Jv` and `Jtv` are used as preallocated storage for the operations.
This function is only available if both `nlp.meta.jprod_available` and `nlp.meta.jtprod_available` are set to `true`.
"""
function jac_nln_op!(
  nlp::AbstractNLPModel{T, S},
  rows::AbstractVector{<:Integer},
  cols::AbstractVector{<:Integer},
  vals::AbstractVector{T},
  Jv::AbstractVector,
  Jtv::AbstractVector,
) where {T, S}
  @lencheck get_nln_nnzj(nlp.meta) rows cols vals
  @lencheck get_nnln(nlp.meta) Jv
  @lencheck get_nvar(nlp.meta) Jtv
  prod! = @closure (res, v, α, β) -> begin # res = α * J * v + β * res
    jprod_nln!(nlp, rows, cols, vals, v, Jv)
    if β == 0
      res .= α .* Jv
    else
      res .= α .* Jv .+ β .* res
    end
    return res
  end
  ctprod! = @closure (res, v, α, β) -> begin
    jtprod_nln!(nlp, rows, cols, vals, v, Jtv)
    if β == 0
      res .= α .* Jtv
    else
      res .= α .* Jtv .+ β .* res
    end
    return res
  end
  return LinearOperator{T, S}(
    get_nnln(nlp.meta),
    get_nvar(nlp.meta),
    false,
    false,
    prod!,
    ctprod!,
    ctprod!,
  )
end

"""
    vals = jth_hess_coord(nlp, x, j)

Evaluate the Hessian of j-th constraint at `x` in sparse coordinate format.
Only the lower triangle is returned.
This function is only available when `nlp.meta.sparse_hessian` is set to `true`.
"""
function jth_hess_coord(nlp::AbstractNLPModel{T, S}, x::AbstractVector, j::Integer) where {T, S}
  @lencheck get_nvar(nlp.meta) x
  @rangecheck 1 get_ncon(nlp.meta) j
  vals = S(undef, get_nnzh(nlp.meta))
  return jth_hess_coord!(nlp, x, j, vals)
end

"""
    vals = jth_hess_coord!(nlp, x, j, vals)

Evaluate the Hessian of j-th constraint at `x` in sparse coordinate format, with `vals` of length `nlp.meta.nnzh`, in place.
Only the lower triangle is returned.
This function is only available when `nlp.meta.sparse_hessian` is set to `true`.
"""
function jth_hess_coord! end

"""
    Hx = jth_hess(nlp, x, j)

Evaluate the Hessian of j-th constraint at `x` as a sparse matrix with
the same sparsity pattern as the Lagrangian Hessian.
A `Symmetric` object wrapping the lower triangle is returned.
This function is only available when `nlp.meta.sparse_hessian` is set to `true`.
"""
function jth_hess(nlp::AbstractNLPModel, x::AbstractVector, j::Integer)
  @lencheck get_nvar(nlp.meta) x
  @rangecheck 1 get_ncon(nlp.meta) j
  rows, cols = hess_structure(nlp)
  vals = jth_hess_coord(nlp, x, j)
  return Symmetric(sparse(rows, cols, vals, get_nvar(nlp.meta), get_nvar(nlp.meta)), :L)
end

"""
    Hv = jth_hprod(nlp, x, v, j)

Evaluate the product of the Hessian of j-th constraint at `x` with the vector `v`.
"""
function jth_hprod(
  nlp::AbstractNLPModel{T, S},
  x::AbstractVector,
  v::AbstractVector,
  j::Integer,
) where {T, S}
  @lencheck get_nvar(nlp.meta) x v
  @rangecheck 1 get_ncon(nlp.meta) j
  Hv = S(undef, get_nvar(nlp.meta))
  return jth_hprod!(nlp, x, v, j, Hv)
end

"""
    Hv = jth_hprod!(nlp, x, v, j, Hv)

Evaluate the product of the Hessian of j-th constraint at `x` with the vector `v`
in place.
"""
function jth_hprod! end

"""
    gHv = ghjvprod(nlp, x, g, v)

Return the vector whose i-th component is gᵀ ∇²cᵢ(x) v.
"""
function ghjvprod(
  nlp::AbstractNLPModel{T, S},
  x::AbstractVector,
  g::AbstractVector,
  v::AbstractVector,
) where {T, S}
  @lencheck get_nvar(nlp.meta) x g v
  gHv = S(undef, get_ncon(nlp.meta))
  return ghjvprod!(nlp, x, g, v, gHv)
end

"""
    ghjvprod!(nlp, x, g, v, gHv)

Return the vector whose i-th component is gᵀ ∇²cᵢ(x) v in place.
"""
function ghjvprod! end

"""
    (rows,cols) = hess_structure(nlp.meta)

Return the structure of the Lagrangian Hessian in sparse coordinate format.
This function is only available when both `nlp.meta.hess_available` and `nlp.meta.sparse_hessian` are set to `true`.
"""
function hess_structure(nlp::AbstractNLPModel)
  rows = Vector{Int}(undef, get_nnzh(nlp.meta))
  cols = Vector{Int}(undef, get_nnzh(nlp.meta))
  hess_structure!(nlp, rows, cols)
end

"""
    hess_structure!(nlp, rows, cols)

Return the structure of the Lagrangian Hessian in sparse coordinate format in place.
This function is only available when both `nlp.meta.hess_available` and `nlp.meta.sparse_hessian` are set to `true`.
"""
function hess_structure! end

"""
    vals = hess_coord!(nlp, x, vals; obj_weight=1.0)

Evaluate the objective Hessian at `x` in sparse coordinate format,
with objective function scaled by `obj_weight`, i.e.,
$(OBJECTIVE_HESSIAN), overwriting `vals`.
Only the lower triangle is returned.
This function is only available when both `nlp.meta.hess_available` and `nlp.meta.sparse_hessian` are set to `true`.
"""
function hess_coord!(
  nlp::AbstractNLPModel{T, S},
  x::AbstractVector{T},
  vals::AbstractVector;
  obj_weight::Real = one(T),
) where {T, S}
  @lencheck get_nvar(nlp.meta) x
  @lencheck get_nnzh(nlp.meta) vals
  y = fill!(S(undef, get_ncon(nlp.meta)), 0)
  hess_coord!(nlp, x, y, vals, obj_weight = obj_weight)
end

"""
    vals = hess_coord!(nlp, x, y, vals; obj_weight=1.0)

Evaluate the Lagrangian Hessian at `(x,y)` in sparse coordinate format,
with objective function scaled by `obj_weight`, i.e.,
$(LAGRANGIAN_HESSIAN), overwriting `vals`.
Only the lower triangle is returned.
This function is only available when both `nlp.meta.hess_available` and `nlp.meta.sparse_hessian` are set to `true`.
"""
function hess_coord! end

"""
    vals = hess_coord(nlp, x; obj_weight=1.0)

Evaluate the objective Hessian at `x` in sparse coordinate format,
with objective function scaled by `obj_weight`, i.e.,
$(OBJECTIVE_HESSIAN).
Only the lower triangle is returned.
This function is only available when both `nlp.meta.hess_available` and `nlp.meta.sparse_hessian` are set to `true`.
"""
function hess_coord(
  nlp::AbstractNLPModel{T, S},
  x::AbstractVector;
  obj_weight::Real = one(T),
) where {T, S}
  @lencheck get_nvar(nlp.meta) x
  vals = S(undef, get_nnzh(nlp.meta))
  return hess_coord!(nlp, x, vals; obj_weight = obj_weight)
end

"""
    vals = hess_coord(nlp, x, y; obj_weight=1.0)

Evaluate the Lagrangian Hessian at `(x,y)` in sparse coordinate format,
with objective function scaled by `obj_weight`, i.e.,
$(LAGRANGIAN_HESSIAN).
Only the lower triangle is returned.
This function is only available when both `nlp.meta.hess_available` and `nlp.meta.sparse_hessian` are set to `true`.
"""
function hess_coord(
  nlp::AbstractNLPModel{T, S},
  x::AbstractVector,
  y::AbstractVector;
  obj_weight::Real = one(T),
) where {T, S}
  @lencheck get_nvar(nlp.meta) x
  @lencheck get_ncon(nlp.meta) y
  vals = S(undef, get_nnzh(nlp.meta))
  return hess_coord!(nlp, x, y, vals; obj_weight = obj_weight)
end

"""
    Hx = hess(nlp, x; obj_weight=1.0)

Evaluate the objective Hessian at `x` as a sparse matrix,
with objective function scaled by `obj_weight`, i.e.,
$(OBJECTIVE_HESSIAN).
A `Symmetric` object wrapping the lower triangle is returned.
This function is only available when both `nlp.meta.hess_available` and `nlp.meta.sparse_hessian` are set to `true`.
"""
function hess(
  nlp::AbstractNLPModel{T, S},
  x::AbstractVector;
  obj_weight::Real = one(T),
) where {T, S}
  @lencheck get_nvar(nlp.meta) x
  rows, cols = hess_structure(nlp)
  vals = hess_coord(nlp, x, obj_weight = obj_weight)
  Symmetric(sparse(rows, cols, vals, get_nvar(nlp.meta), get_nvar(nlp.meta)), :L)
end

"""
    Hx = hess_dense!(nlp, x, Hx; obj_weight=1.0)
    Hx = hess_dense!(nlp, x, y, Hx; obj_weight=1.0)

The first method evaluates ``H(x)``, the Hessian of the objective at `x` in dense format, overwriting `Hx`.
The second method evaluates ``H(x,y)``, the Hessian of the Lagrangian at `(x,y)` in dense format, overwriting `Hx`.
Only the lower triangular part of `Hx` needs to be filled.
This function is only available when `nlp.meta.hess_available` is set to `true` and `nlp.meta.sparse_hessian` is set to `false`.
"""
function hess_dense! end

"""
    Hx = hess(nlp, x, y; obj_weight=1.0)

Evaluate the Lagrangian Hessian at `(x,y)` as a sparse matrix,
with objective function scaled by `obj_weight`, i.e.,
$(LAGRANGIAN_HESSIAN).
A `Symmetric` object wrapping the lower triangle is returned.
This function is only available when both `nlp.meta.hess_available` and `nlp.meta.sparse_hessian` are set to `true`.
"""
function hess(
  nlp::AbstractNLPModel{T, S},
  x::AbstractVector,
  y::AbstractVector;
  obj_weight::Real = one(T),
) where {T, S}
  @lencheck get_nvar(nlp.meta) x
  @lencheck get_ncon(nlp.meta) y
  rows, cols = hess_structure(nlp)
  vals = hess_coord(nlp, x, y, obj_weight = obj_weight)
  Symmetric(sparse(rows, cols, vals, get_nvar(nlp.meta), get_nvar(nlp.meta)), :L)
end

"""
    Hv = hprod(nlp, x, v; obj_weight=1.0)

Evaluate the product of the objective Hessian at `x` with the vector `v`,
with objective function scaled by `obj_weight`, where the objective Hessian is
$(OBJECTIVE_HESSIAN).
This function is only available if `nlp.meta.hprod_available` is set to `true`.
"""
function hprod(
  nlp::AbstractNLPModel{T, S},
  x::AbstractVector,
  v::AbstractVector;
  obj_weight::Real = one(T),
) where {T, S}
  @lencheck get_nvar(nlp.meta) x v
  Hv = S(undef, get_nvar(nlp.meta))
  return hprod!(nlp, x, v, Hv; obj_weight = obj_weight)
end

"""
    Hv = hprod(nlp, x, y, v; obj_weight=1.0)

Evaluate the product of the Lagrangian Hessian at `(x,y)` with the vector `v`,
with objective function scaled by `obj_weight`, where the Lagrangian Hessian is
$(LAGRANGIAN_HESSIAN).
This function is only available if `nlp.meta.hprod_available` is set to `true`.
"""
function hprod(
  nlp::AbstractNLPModel{T, S},
  x::AbstractVector,
  y::AbstractVector,
  v::AbstractVector;
  obj_weight::Real = one(T),
) where {T, S}
  @lencheck get_nvar(nlp.meta) x v
  @lencheck get_ncon(nlp.meta) y
  Hv = S(undef, get_nvar(nlp.meta))
  return hprod!(nlp, x, y, v, Hv; obj_weight = obj_weight)
end

"""
    Hv = hprod!(nlp, x, v, Hv; obj_weight=1.0)

Evaluate the product of the objective Hessian at `x` with the vector `v` in
place, with objective function scaled by `obj_weight`, where the objective Hessian is
$(OBJECTIVE_HESSIAN).
This function is only available if `nlp.meta.hprod_available` is set to `true`.
"""
function hprod!(
  nlp::AbstractNLPModel{T, S},
  x::AbstractVector,
  v::AbstractVector,
  Hv::AbstractVector;
  obj_weight::Real = one(T),
) where {T, S}
  @lencheck get_nvar(nlp.meta) x v Hv
  y = fill!(S(undef, get_ncon(nlp.meta)), 0)
  hprod!(nlp, x, y, v, Hv, obj_weight = obj_weight)
end

"""
    Hv = hprod!(nlp, rows, cols, vals, v, Hv)

Evaluate the product of the objective or Lagrangian Hessian given by `(rows, cols, vals)` in
triplet format with the vector `v` in place. Only one triangle of the Hessian should be given.
This function is only available if `nlp.meta.hprod_available` is set to `true`.
"""
function hprod!(
  nlp::AbstractNLPModel,
  rows::AbstractVector{<:Integer},
  cols::AbstractVector{<:Integer},
  vals::AbstractVector,
  v::AbstractVector,
  Hv::AbstractVector,
)
  @lencheck get_nnzh(nlp.meta) rows cols vals
  @lencheck get_nvar(nlp.meta) v Hv
  increment!(nlp, :neval_hprod)
  coo_sym_prod!(cols, rows, vals, v, Hv)
end

"""
    Hv = hprod!(nlp, x, y, v, Hv; obj_weight=1.0)

Evaluate the product of the Lagrangian Hessian at `(x,y)` with the vector `v` in
place, with objective function scaled by `obj_weight`, where the Lagrangian Hessian is
$(LAGRANGIAN_HESSIAN).
This function is only available if `nlp.meta.hprod_available` is set to `true`.
"""
function hprod! end

"""
    H = hess_op(nlp, x; obj_weight=1.0)

Return the objective Hessian at `x` with objective function scaled by
`obj_weight` as a linear operator. The resulting object may be used as if it were a
matrix, e.g., `H * v`. The linear operator H represents
$(OBJECTIVE_HESSIAN).
This function is only available if `nlp.meta.hprod_available` is set to `true`.
"""
function hess_op(
  nlp::AbstractNLPModel{T, S},
  x::AbstractVector;
  obj_weight::Real = one(T),
) where {T, S}
  @lencheck get_nvar(nlp.meta) x
  Hv = S(undef, get_nvar(nlp.meta))
  return hess_op!(nlp, x, Hv, obj_weight = obj_weight)
end

"""
    H = hess_op(nlp, x, y; obj_weight=1.0)

Return the Lagrangian Hessian at `(x,y)` with objective function scaled by
`obj_weight` as a linear operator. The resulting object may be used as if it were a
matrix, e.g., `H * v`. The linear operator H represents
$(LAGRANGIAN_HESSIAN).
This function is only available if `nlp.meta.hprod_available` is set to `true`.
"""
function hess_op(
  nlp::AbstractNLPModel{T, S},
  x::AbstractVector,
  y::AbstractVector;
  obj_weight::Real = one(T),
) where {T, S}
  @lencheck get_nvar(nlp.meta) x
  @lencheck get_ncon(nlp.meta) y
  Hv = S(undef, get_nvar(nlp.meta))
  return hess_op!(nlp, x, y, Hv, obj_weight = obj_weight)
end

"""
    H = hess_op!(nlp, x, Hv; obj_weight=1.0)

Return the objective Hessian at `x` with objective function scaled by
`obj_weight` as a linear operator, and storing the result on `Hv`. The resulting
object may be used as if it were a matrix, e.g., `w = H * v`. The vector `Hv` is
used as preallocated storage for the operation.  The linear operator H
represents
$(OBJECTIVE_HESSIAN).
This function is only available if `nlp.meta.hprod_available` is set to `true`.
"""
function hess_op!(
  nlp::AbstractNLPModel{T, S},
  x::AbstractVector,
  Hv::AbstractVector;
  obj_weight::Real = one(T),
) where {T, S}
  @lencheck get_nvar(nlp.meta) x Hv
  prod! = @closure (res, v, α, β) -> begin
    hprod!(nlp, x, v, Hv; obj_weight = obj_weight)
    if β == 0
      res .= α .* Hv
    else
      res .= α .* Hv .+ β .* res
    end
    return res
  end
  return LinearOperator{T, S}(
    get_nvar(nlp.meta),
    get_nvar(nlp.meta),
    true,
    true,
    prod!,
    prod!,
    prod!,
  )
end

"""
    H = hess_op!(nlp, rows, cols, vals, Hv)

Return the Hessian given by `(rows, cols, vals)` as a linear operator,
and storing the result on `Hv`. The resulting
object may be used as if it were a matrix, e.g., `w = H * v`.
The vector `Hv` is used as preallocated storage for the operation.
The linear operator H represents
$(OBJECTIVE_HESSIAN).
This function is only available if `nlp.meta.hprod_available` is set to `true`.
"""
function hess_op!(
  nlp::AbstractNLPModel{T, S},
  rows::AbstractVector{<:Integer},
  cols::AbstractVector{<:Integer},
  vals::AbstractVector,
  Hv::AbstractVector,
) where {T, S}
  @lencheck get_nnzh(nlp.meta) rows cols vals
  @lencheck get_nvar(nlp.meta) Hv
  prod! = @closure (res, v, α, β) -> begin
    hprod!(nlp, rows, cols, vals, v, Hv)
    if β == 0
      res .= α .* Hv
    else
      res .= α .* Hv .+ β .* res
    end
    return res
  end
  return LinearOperator{T, S}(
    get_nvar(nlp.meta),
    get_nvar(nlp.meta),
    true,
    true,
    prod!,
    prod!,
    prod!,
  )
end

"""
    H = hess_op!(nlp, x, y, Hv; obj_weight=1.0)

Return the Lagrangian Hessian at `(x,y)` with objective function scaled by
`obj_weight` as a linear operator, and storing the result on `Hv`. The resulting
object may be used as if it were a matrix, e.g., `w = H * v`. The vector `Hv` is
used as preallocated storage for the operation.  The linear operator H
represents
$(LAGRANGIAN_HESSIAN).
This function is only available if `nlp.meta.hprod_available` is set to `true`.
"""
function hess_op!(
  nlp::AbstractNLPModel{T, S},
  x::AbstractVector,
  y::AbstractVector,
  Hv::AbstractVector;
  obj_weight::Real = one(T),
) where {T, S}
  @lencheck get_nvar(nlp.meta) x Hv
  @lencheck get_ncon(nlp.meta) y
  prod! = @closure (res, v, α, β) -> begin
    hprod!(nlp, x, y, v, Hv; obj_weight = obj_weight)
    if β == 0
      res .= α .* Hv
    else
      res .= α .* Hv .+ β .* res
    end
    return res
  end
  return LinearOperator{T, S}(
    get_nvar(nlp.meta),
    get_nvar(nlp.meta),
    true,
    true,
    prod!,
    prod!,
    prod!,
  )
end

"""
    varscale(model::AbstractNLPModel)

Return a vector containing the scaling factors for each variable in the model.
This is typically used to normalize variables for numerical stability in solvers.

By default, the scaling is model-dependent. If not overridden by the model, a vector of ones 
is returned. Inspired by the AMPL scaling conventions.
"""
function varscale end

"""
    lagscale(model::AbstractNLPModel)

Return a vector of scaling factors for the Lagrange multipliers associated with constraints.
This can be used to improve numerical stability or condition number when solving KKT systems.
"""
function lagscale end

"""
    conscale(model::AbstractNLPModel)

Return a vector of constraint scaling factors for the model.
These are typically used to normalize constraints to have similar magnitudes and improve 
convergence behavior in nonlinear solvers.
"""
function conscale end

# [Tools](@id tools-section)

## Functions evaluations

After calling one the [API](@ref) functions to get a function value, the
number of times that function was called is stored inside the
`NLPModel`. For instance

```julia
using ADNLPModels, LinearAlgebra, NLPModels
nlp = ADNLPModel(x -> dot(x, x), zeros(2))
for i = 1:100
   obj(nlp, rand(2))
end
neval_obj(nlp)
```

Some counters are available for all models, some are specific. In
particular, there are additional specific counters for the nonlinear
least squares models (the ones with `residual` below).

| Counter | Description |
|---|---|
| [`neval_obj`](@ref)             | Objective |
| [`neval_grad`](@ref)            | Gradient |
| [`neval_cons`](@ref)            | Constraints |
| [`neval_cons_lin`](@ref)        | Linear constraints |
| [`neval_cons_nln`](@ref)        | Nonlinear constraints |
| [`neval_jcon`](@ref)            | One constraint - unused |
| [`neval_jgrad`](@ref)           | Gradient of one constraints - unused |
| [`neval_jac`](@ref)             | Jacobian |
| [`neval_jac_lin`](@ref)         | Linear constraints Jacobian |
| [`neval_jac_nln`](@ref)         | Nonlinear constraints Jacobian |
| [`neval_jprod`](@ref)           | Product of Jacobian and vector |
| [`neval_jprod_lin`](@ref)       | Product of linear constraints Jacobian and vector |
| [`neval_jprod_nln`](@ref)       | Product of nonlinear constraints Jacobian and vector |
| [`neval_jtprod`](@ref)          | Product of transposed Jacobian and vector |
| [`neval_jtprod_lin`](@ref)      | Product of transposed linear constraints Jacobian and vector |
| [`neval_jtprod_nln`](@ref)      | Product of transposed nonlinear constraints Jacobian and vector |
| [`neval_hess`](@ref)            | Hessian |
| [`neval_hprod`](@ref)           | Product of Hessian and vector |
| [`neval_jhess`](@ref)           | Individual Lagrangian Hessian evaluations |
| [`neval_jhprod`](@ref)          | Product of Hessian of j-th function and vector |
| [`neval_residual`](@ref)        | Residual function of nonlinear least squares model |
| [`neval_jac_residual`](@ref)    | Jacobian of the residual |
| [`neval_jprod_residual`](@ref)  | Product of Jacobian of residual and vector |
| [`neval_jtprod_residual`](@ref) | Product of transposed Jacobian of residual and vector |
| [`neval_hess_residual`](@ref)   | Sum of Hessians of residuals |
| [`neval_jhess_residual`](@ref)  | Hessian of a residual component |
| [`neval_hprod_residual`](@ref)  | Product of Hessian of a residual component and vector |

To get the sum of all counters except `cons`, `jac`, `jprod` and `jtprod` called for a problem, use
[`sum_counters`](@ref).

```julia
using ADNLPModels, LinearAlgebra, NLPModels
nlp = ADNLPModel(x -> dot(x, x), zeros(2))
obj(nlp, rand(2))
grad(nlp, rand(2))
sum_counters(nlp)
```

## Querying problem type

There are some utility functions for querying the problem type:

- [`has_bounds`](@ref): True when not all variables are free.
- [`bound_constrained`](@ref): True for problems with bounded variables
  and no other constraints.
- [`equality_constrained`](@ref): True when problem is constrained only
  by equalities.
- [`has_equalities`](@ref): True when problem has at least one equality constraint.
- [`inequality_constrained`](@ref): True when problem is constrained
  by inequalities.
- [`has_inequalities`](@ref): True when problem has at least one inequality constraint that isn't a bound.
- [`linearly_constrained`](@ref): True when problem is constrained by
  equalities or inequalities known to be linear.
- [`unconstrained`](@ref): True when problem is not constrained.

# Internal functions

These functions may or may not be exported.
They are used internally.

- [`@default_counters`](@ref)
- [`@default_nlscounters`](@ref)
- [`@lencheck`](@ref)
- [`@rangecheck`](@ref)
- [`coo_prod!`](@ref)
- [`coo_sym_prod!`](@ref)
- [`decrement!`](@ref)
- [`DimensionError`](@ref)
- [`NLPModels.histline`](@ref)
- [`increment!`](@ref)
- [`NLPModels.lines_of_description`](@ref)
- [`NLPModels.lines_of_hist`](@ref)
- [`NLPModels.show_counters`](@ref)
- [`show_header`](@ref)
- [`NLPModels.sparsityline`](@ref)

# [Guidelines for creating models](@id Guidelines)

These are guidelines for the creation of models using NLPModels to help keeping the models uniform, and for future reference in the creation of solvers.

Table of contents:

- [Bare minimum](@ref bare-minimum)
- [Expected behaviour](@ref expected-behaviour)
- [Advanced counters](@ref advanced-counters)
- [Advanced tests](@ref advanced-tests)

## [Bare minimum](@id bare-minimum)

Your model should derive from `AbstractNLPModel` or some other abstract class derived from it.
It is mandatory that it have a `meta :: NLPModelMeta` field, storing all the relevant problem information.
The model also needs to provide `Counters` information. The easiest way is to define `counters :: Counters`.
For instance:

```julia
mutable struct MyModel{T, S} <: AbstractNLPModel{T, S}
  meta :: NLPModelMeta{T, S}
  counters :: Counters
end
```

For alternatives to storing `Counters` in the model, check [advanced counters](@ref advanced-counters).
The minimum information that should be set for your model through `NLPModelMeta` is `nvar`, the number of variables.
The following is a valid constructor for `MyModel`:

```julia
function MyModel()
  return MyModel(NLPModelMeta(5), Counters())
end
```

More information can be passed to `NLPModelMeta`.
See the full list [here](https://github.com/JuliaSmoothOptimizers/NLPModels.jl/blob/main/src/nlp/meta.jl#L32).
The essential fields are

- `x0`: Starting point (defaults to `zeros`)
- `lvar`, `uvar`: Bounds on the variables (default to `(-∞,∞)`)
- `ncon`: Number of constraints (defaults to `0`)
- `lcon`, `ucon`: Bounds on the constraints (default to `(-∞,∞)`)
- `nnzh`: The length of the vectors used to store a triangle of the Hessian in triplet format (defaults to `nvar * (nvar + 1) / 2`
- `nnzj`: The length of the vectors used to store the Jacobian in triplet format (default to `nvar * ncon`)

There are about 30 functions in the NLPModels API, and a few with more than one signature.
Luckily, many have a default implementation.
We collect here the list of functions that should be implemented for a complete API.

Here, the following notation applies:

- `nlp` is your instance of `MyModel <: AbstractNLPModel`
- `x` is the point where the function is evaluated
- `y` is the vector of Lagrange multipliers (for constrained problems only)
- `g` is the gradient vector
- `H` is the Hessian of the objective or Lagrangian
- `hrows`, `hcols`, and `hvals` are vectors storing the triplet form of the Hessian
- `c` is the vector of constraints
- `J` is the Jacobian of the constraints
- `jrows`, `jcols`, and `jvals` are vectors storing the triplet form of the Jacobian
- `v` is a vector of appropriate dimensions, generally used for operator-vector products
- `Jv`, `Jtv`, `Hv` are vectors of appropriate dimensions, storing the result of operator-vector products

The following functions should be defined:

- Objective (unconstrained models only need to worry about these)
  - `obj(nlp, x)`
  - `grad!(nlp, x, g)`
  - `hess_structure!(nlp, hrows, hcols)` (sparse Hessian)
  - `hess_coord!(nlp, x, hvals; obj_weight=1)` (sparse Hessian)
  - `hess_dense!(nlp, x, Hx; obj_weight=1)` (dense Hessian)
  - `hprod!(nlp, x, v, Hv; obj_weight=1)` (actually defaults to calling the constrained case)
- Constraints (constrained models need to worry about these and the ones above)
  - `cons_lin!(nlp, x, c)`
  - `cons_nln!(nlp, x, c)`
  - `jac_lin_structure!(nlp, jrows, jcols)` (sparse Jacobian)
  - `jac_nln_structure!(nlp, jrows, jcols)` (sparse Jacobian)
  - `jac_lin_coord!(nlp, x, jvals)` (sparse Jacobian)
  - `jac_nln_coord!(nlp, x, jvals)` (sparse Jacobian)
  - `jac_dense!(nlp, x, Jx)` (dense Jacobian)
  - `jprod_lin!(nlp, x, v, Jv)`
  - `jprod_nln!(nlp, x, v, Jv)`
  - `jtprod_lin!(nlp, x, v, Jtv)`
  - `jtprod_nln!(nlp, x, v, Jtv)`
  - `hess_coord!(nlp, x, y, hvals; obj_weight=1)` (sparse Hessian)
  - `hess_dense!(nlp, x, y, Hx; obj_weight=1)` (dense Hessian)
  - `hprod!(nlp, x, y, v, Hv; obj_weight=1)`

The linear constraints are specified at the initialization of the `NLPModelMeta` using the keyword arguement `lin`.
The indices of linear and nonlinear constraints are respectively available in `nlp.meta.lin` and `nlp.meta.nln`.
If your model uses only linear (resp. nonlinear) constraints, then it suffices to implement the `*_lin` (resp. `*_nln`) functions.
Alternatively, one could implement only the functions without the suffixes `_nln!` (e.g., only `cons!`), but this might run into errors with tools differentiating linear and nonlinear constraints.

If the Jacobian or the Hessian of the Lagrangian is dense, there is no need to implement the corresponding `*_structure!` and `*_coord!` methods.
Only the corresponding `*_dense!` methods need to be implemented.
This is specified at the initialization of [`NLPModelMeta`](@ref) through the keyword arguments `sparse_jacobian` and `sparse_hessian`.
In the dense case, linear and nonlinear constraints are handled together.
Only an in-place API is available for dense Jacobians and Hessians (`jac_dense!` and `hess_dense!`).

## [Availability of the API](@id availability-api)

If only a subset of the functions listed above is implemented, you can indicate which ones are not available when creating the [`NLPModelMeta`](@ref), using the keyword arguments
`grad_available`, `jac_available`, `hess_available`, `jprod_available`, `jtprod_available`, and `hprod_available`.

By default, `grad_available`, `hess_available`, and `hprod_available` are set to `true`.
For constrained problems (`ncon > 0`), the fields `jac_available`, `jprod_available`, and `jtprod_available` are also set to `true`.
For unconstrained problems (`ncon == 0`), they default to `false`.

## [Expected behaviour](@id expected-behaviour)

The following is a non-exhaustive list of expected behaviour for methods.

- All in place methods should also return the modified vectors.
- Vector inputs should have the correct size. If necessary, the user should pass them using views or slices.
- The triplet format does not assume order nor uniqueness.

## [Show](@id show)

To further specialize your model, you can also define `show_header` and possibly `show`.
The default `show_header` simply prints the `typeof` the NLPModel, so it should be specialized with the specific information that you prefer. For instance, `SlackModel` defines

```julia
show_header(io :: IO, nlp :: SlackModel) = println(io, "SlackModel - Model with slack variables")
```

Furthermore, we define a general `show` that calls `show_header` and specific `show` functions for the `meta` and the `counters`. If your model does not have `counters` in the default location, you must define `get_counters` for them as well. Alternatively, you may desire to change the behaviour of show. The default behaviour is

```julia
function show(io :: IO, nlp :: AbstractNLPModel)
  show_header(io, nlp)
  show(io, nlp.meta)
  show(io, get_counters(nlp.model))
end
```

## [Advanced counters](@id advanced-counters)

If a model does not implement `counters`, then it needs to define

- `get_counters(nlp)` - get the `Counters` object associated with `nlp`
- `neval_xxx(nlp)` - get field `xxx` of `Counters`
- `reset!(nlp)` - resetting all counters
- `increment!(nlp, s)` - increment counter `s`

For instance

```julia
for counter in fieldnames(Counters)
  @eval begin
    $counter(nlp :: MyModel) = SOMETHING
  end
end
function reset!(nlp :: MyModel)
  RESET COUNTERS
end
function increment!(nlp :: MyModel, s :: Symbol)
  INCREMENT COUNTER s
end
```

One example of such model is the `SlackModel`, which stores an internal `model :: AbstractNLPModel`, thus defining

```julia
$counter(nlp :: SlackModel) = $counter(nlp.model)
reset!(nlp :: SlackModel) = reset!(nlp.model)
increment!(nlp :: SlackModel, s :: Symbol) = increment!(nlp.model, s)
```

This construction can be replicated calling the macro `@default_counters Model inner`.
In the case of SlackModel, the equivalent call is

```julia
@default_counters SlackModel model
```

Furthermore, the `show` method may have to be updated with the correct direction of `counter`. See [show](@ref show) for more information.

## [Advanced tests](@id advanced-tests)

We have created the package [NLPModelsTest.jl](https://github.com/JuliaSmoothOptimizers/NLPModelsTest.jl) which defines test functions and problems.
To make sure that your model is robust, we recommend using it in the test suite of your package.

# Batch API

This section documents the batch API of `NLPModels.jl`.  
The batch API reuses the same symbols as the standard (non-batch) API.  
The only new in-place function is `obj!`, which returns a vector of all objectives.

---

## Abstract types

- [`AbstractBatchNLPModel`](@ref)
- [`AbstractBatchNLPModelMeta`](@ref)

---

## Batch metadata

- [`BatchNLPModelMeta`](@ref)

---

## Objectives

| Function | Signature |
|:--------:|:---------:|
| `obj`  | `obj(bnlp::AbstractBatchNLPModel, bx::AbstractMatrix)` |
| `obj!` | `obj!(bnlp::AbstractBatchNLPModel, bx::AbstractMatrix, bf::AbstractVector)` |

---

## Gradients

| Function | Signature |
|:--------:|:---------:|
| `grad`  | `grad(bnlp::AbstractBatchNLPModel, bx::AbstractMatrix)` |
| `grad!` | `grad!(bnlp::AbstractBatchNLPModel, bx::AbstractMatrix, bg::AbstractMatrix)` |

---

## Constraints

| Function | Signature |
|:--------:|:---------:|
| `cons`  | `cons(bnlp::AbstractBatchNLPModel, bx::AbstractMatrix)` |
| `cons!` | `cons!(bnlp::AbstractBatchNLPModel, bx::AbstractMatrix, bc::AbstractMatrix)` |

---

## Sparse jacobians

| Function | Signature |
|:--------:|:---------:|
| `jac_structure`  | `(jrows, jcols) = jac_structure(bnlp::AbstractBatchNLPModel)` |
| `jac_structure!` | `(jrows, jcols) = jac_structure!(bnlp::AbstractBatchNLPModel, jrows::AbstractVector, jcols::AbstractVector)` |
| `jac_coord`  | `bjvals = jac_coord(bnlp::AbstractBatchNLPModel, bx::AbstractMatrix)` |
| `jac_coord!` | `bjvals = jac_coord!(bnlp::AbstractBatchNLPModel, bx::AbstractMatrix, bjvals::AbstractMatrix)` |

---

## Dense Jacobians

| Function | Signature |
|:--------:|:---------:|
| `jac_dense!` | `bJx = jac_dense!(bnlp::AbstractBatchNLPModel, bx::AbstractMatrix, bJx::AbstractArray)` |

---

## Jacobian-vector products

| Function | Signature |
|:--------:|:---------:|
| `jprod`  | `bJv = jprod(bnlp::AbstractBatchNLPModel, bx::AbstractMatrix, bv::AbstractMatrix)` |
| `jprod!` | `bJv = jprod!(bnlp::AbstractBatchNLPModel, bx::AbstractMatrix, bv::AbstractMatrix, bJv::AbstractMatrix)` |
| `jtprod`  | `bJtv = jtprod(bnlp::AbstractBatchNLPModel, bx::AbstractMatrix, bv::AbstractMatrix)` |
| `jtprod!` | `bJtv = jtprod!(bnlp::AbstractBatchNLPModel, bx::AbstractMatrix, bv::AbstractMatrix, bJtv::AbstractMatrix)` |

---

## Sparse Hessians of the Lagrangian

| Function | Signature |
|:--------:|:---------:|
| `hess_structure`  | `(hrows, hcols) = hess_structure(bnlp::AbstractBatchNLPModel)` |
| `hess_structure!` | `(hrows, hcols) = hess_structure!(bnlp::AbstractBatchNLPModel, hrows::AbstractVector, hcols::AbstractVector)` |
| `hess_coord`  | `bhvals = hess_coord(bnlp::AbstractBatchNLPModel, bx::AbstractMatrix, by::AbstractMatrix, bobj_weight::AbstractVector)` |
| `hess_coord!` | `bhvals = hess_coord!(bnlp::AbstractBatchNLPModel, bx::AbstractMatrix, by::AbstractMatrix, bobj_weight::AbstractVector, bhvals::AbstractMatrix)` |

---

## Dense Hessians of the Lagrangian

| Function | Signature |
|:--------:|:---------:|
| `hess_dense!` | `bHx = hess_dense!(bnlp::AbstractBatchNLPModel, bx::AbstractMatrix, by::AbstractMatrix, bobj_weight::AbstractVector, bHx::AbstractArray)` |

---

## Hessian-vector products

| Function | Signature |
|:--------:|:---------:|
| `hprod`  | `bHv = hprod(bnlp::AbstractBatchNLPModel, bx::AbstractMatrix, by::AbstractMatrix, bv::AbstractMatrix, bobj_weight::AbstractVector)` |
| `hprod!` | `bHv = hprod!(bnlp::AbstractBatchNLPModel, bx::AbstractMatrix, by::AbstractMatrix, bv::AbstractMatrix, bobj_weight::AbstractVector, bHv::AbstractMatrix)` |

# Models

The following is a list of packages implementing the NLPModels API.

If you want your package listed here, open a Pull Request.

If you want to create your own interface, check these [Guidelines](@ref).
## Packages

- [NLPModelsModifiers.jl](https://github.com/JuliaSmoothOptimizers/NLPModelsModifiers.jl):
  Models that modify existing models.
  For instance, creating slack variables, or moving constraints into the objective functions, or using Quasi-Newton LBFGS approximations to the Hessian.
- [ADNLPModels.jl](https://github.com/JuliaSmoothOptimizers/ADNLPModels.jl):
  Models with automatic differentiation.
- [CUTEst.jl](https://github.com/JuliaSmoothOptimizers/CUTEst.jl):
  For problems from [CUTEst](https://github.com/ralna/CUTEst/wiki).
- [AmplNLReader.jl](https://github.com/JuliaSmoothOptimizers/AmplNLReader.jl):
  For problems modeled using [AMPL](https://ampl.com)
- [NLPModelsJuMP.jl](https://github.com/JuliaSmoothOptimizers/NLPModelsJuMP.jl):
  For problems modeled using [JuMP.jl](https://github.com/jump-dev/JuMP.jl).
- [QuadraticModels.jl](https://github.com/JuliaSmoothOptimizers/QuadraticModels.jl):
  For problems with linear constraints and a quadratic objective (LCQP).
- [LLSModels.jl](https://github.com/JuliaSmoothOptimizers/LLSModels.jl):
  Creates a linear least squares model.
- [PDENLPModels.jl](https://github.com/JuliaSmoothOptimizers/PDENLPModels.jl):
  For PDE-constrained problems.
- [BlockNLPModels.jl](https://github.com/exanauts/BlockNLPModels.jl): For modeling block structured nonlinear optimization problems.

## Model internals

- [`AbstractNLPModel`](@ref)
- [`AbstractNLSModel`](@ref)
- [`AbstractNLPModelMeta`](@ref)
- [`NLPModelMeta`](@ref)
- [`NLSMeta`](@ref)
- [`nls_meta`](@ref)

# [NLPModels.jl documentation](@id Home)

This package provides general guidelines to represent non-linear programming (NLP)
problems in Julia and a standardized API to evaluate the functions and
their derivatives. The main objective is to be able to rely on that [API](@ref) when
designing optimization solvers in Julia.

## Introduction

The general form of the optimization problem is
```math
\begin{aligned}
\min \quad & f(x) \\
& c_i(x) = c_{E_i}, \quad i \in {\cal E}, \\
& c_{L_i} \leq c_i(x) \leq c_{U_i}, \quad i \in {\cal I}, \\
& \ell \leq x \leq u,
\end{aligned}
```
where ``f:\mathbb{R}^n\rightarrow\mathbb{R}``,
``c:\mathbb{R}^n\rightarrow\mathbb{R}^m``,
``{\cal E}\cup {\cal I} = \{1,2,\dots,m\}``, ``{\cal E}\cap {\cal I} = \emptyset``,
and
``c_{E_i}, c_{L_i}, c_{U_i}, \ell_j, u_j \in \mathbb{R}\cup\{\pm\infty\}``
for ``i = 1,\dots,m`` and ``j = 1,\dots,n``.

For computational reasons, we write
```math
\begin{aligned}
\min \quad & f(x) \\
& c_L \leq c(x) \leq c_U \\
& \ell \leq x \leq u,
\end{aligned}
```
defining ``c_{L_i} = c_{U_i} = c_{E_i}`` for all ``i \in {\cal E}``.
The Lagrangian of this problem is defined as
```math
L(x,y,z^L,z^U;\sigma) = \sigma f(x) + c(x)^T y  + \sum_{i=1}^n z_{L_i}(x_i-l_i) + \sum_{i=1}^n z_{U_i}(u_i-x_i),
```
where ``\sigma`` is a scaling parameter included for computational reasons.
Since the final two sums are linear in ``x``, the variables ``z_L`` and ``z_U`` do not appear in the Hessian ``\nabla^2 L(x,y)``.

Optimization problems are represented by an instance/subtype of `AbstractNLPModel`.
Such instances are composed of

- an instance of [`NLPModelMeta`](@ref Attributes), which provides information about the problem,
  including the number of variables, constraints, bounds on the variables, etc.
- other data specific to the provenance of the problem.

## Nonlinear Least Squares

A special subtype of `AbstractNLPModel` is `AbstractNLSModel`, i.e., Nonlinear Least
Squares models. In these problems, the function ``f(x)`` is given by
``\tfrac{1}{2}\Vert F(x)\Vert^2``, where ``F`` is referred as the residual function.
The individual value of ``F``, as well as of its derivatives, is also
available.

## Tools

There are a few tools to use on `NLPModels`, for instance to query
whether the problem is constrained or not, and to get the number of
function evaluations. See [Tools](@ref tools-section).

## Install

Install NLPModels.jl with the following command.
```julia
pkg> add NLPModels
```

This will enable the use of the API and the tools described here, and it allows the creation of a manually written model.
Look into [Models](@ref) for more information on that subject, and on a list of packages implementing ready-to-use models.

## Usage

See the [Models](@ref), the [Tools](@ref tools-section), or the [API](@ref).


## Attributes

`NLPModelMeta` objects have the following attributes (with `S <: AbstractVector`):

Attribute          | Type          | Notes
-------------------|---------------|------------------------------------
`nvar`             | `Int`         | number of variables
`x0  `             | `S`           | initial guess
`lvar`             | `S`           | vector of lower bounds
`uvar`             | `S`           | vector of upper bounds
`ifix`             | `Vector{Int}` | indices of fixed variables
`ilow`             | `Vector{Int}` | indices of variables with lower bound only
`iupp`             | `Vector{Int}` | indices of variables with upper bound only
`irng`             | `Vector{Int}` | indices of variables with lower and upper bound (range)
`ifree`            | `Vector{Int}` | indices of free variables
`iinf`             | `Vector{Int}` | indices of visibly infeasible bounds
`ncon`             | `Int`         | total number of general constraints
`nlin `            | `Int`         | number of linear constraints
`nnln`             | `Int`         | number of nonlinear general constraints
`y0  `             | `S`           | initial Lagrange multipliers
`lcon`             | `S`           | vector of constraint lower bounds
`ucon`             | `S`           | vector of constraint upper bounds
`lin `             | `Vector{Int}` | indices of linear constraints
`nln`              | `Vector{Int}` | indices of nonlinear constraints
`jfix`             | `Vector{Int}` | indices of equality constraints
`jlow`             | `Vector{Int}` | indices of constraints of the form c(x) ≥ cl
`jupp`             | `Vector{Int}` | indices of constraints of the form c(x) ≤ cu
`jrng`             | `Vector{Int}` | indices of constraints of the form cl ≤ c(x) ≤ cu
`jfree`            | `Vector{Int}` | indices of "free" constraints (there shouldn't be any)
`jinf`             | `Vector{Int}` | indices of the visibly infeasible constraints
`nnzo`             | `Int`         | number of nonzeros in the gradient
`nnzj`             | `Int`         | number of nonzeros in the Jacobian
`lin_nnzj`         | `Int`         | number of nonzeros in the linear constraints Jacobian
`nln_nnzj`         | `Int`         | number of nonzeros in the nonlinear constraints Jacobian
`nnzh`             | `Int`         | number of nonzeros in the lower triangular part of the Hessian of the Lagrangian
`minimize`         | `Bool`        | true if `optimize == minimize`
`islp`             | `Bool`        | true if the problem is a linear program
`name`             | `String`      | problem name
`variable_bounds_analysis` | `Bool` | true if the partition of variables into fixed, lower-bounded, upper-bounded, range-bounded, free, and trivially infeasible sets is computed
`constraint_bounds_analysis`| `Bool` | true if the partition of constraints into equality, lower-bounded, upper-bounded, range-bounded, free, and trivially infeasible sets is computed
`sparse_jacobian`  | `Bool`        | true if the Jacobian of the constraints is sparse
`sparse_hessian`   | `Bool`        | true if the Hessian of the Lagrangian is sparse
`grad_available`   | `Bool`        | true if the gradient of the objective is available
`jac_available`    | `Bool`        | true if the Jacobian of the constraints is available
`hess_available`   | `Bool`        | true if the Hessian of the Lagrangian is available
`jprod_available`  | `Bool`        | true if the Jacobian-vector product `J * v` is available
`jtprod_available` | `Bool`        | true if the transpose Jacobian-vector product `J' * v` is available
`hprod_available`  | `Bool`        | true if the Hessian-vector product of the Lagrangian `H * v` is available

## License

This content is released under the [MPL2.0](https://www.mozilla.org/en-US/MPL/2.0/) License.

# Bug reports and discussions

If you think you found a bug, feel free to open an [issue](https://github.com/JuliaSmoothOptimizers/NLPModels.jl/issues).
Focused suggestions and requests can also be opened as issues. Before opening a pull request, start an issue or a discussion on the topic, please.

If you want to ask a question not suited for a bug report, feel free to start a discussion [here](https://github.com/JuliaSmoothOptimizers/Organization/discussions). This forum is for general discussion about this repository and the [JuliaSmoothOptimizers](https://github.com/JuliaSmoothOptimizers), so questions about any of our packages are welcome.

## Contents

```@contents
```

# API

As stated in the [Home](@ref) page, we consider the nonlinear optimization
problem in the following format:
```math
\begin{aligned}
\min \quad & f(x) \\
& c_L \leq c(x) \leq c_U \\
& \ell \leq x \leq u.
\end{aligned}
```
To develop an optimization algorithm, we are usually worried not only with
``f(x)`` and ``c(x)``, but also with their derivatives.
Namely,

- ``\nabla f(x)``, the gradient of ``f`` at the point ``x``;
- ``\nabla^2 f(x)``, the Hessian of ``f`` at the point ``x``;
- ``J(x) = \nabla c(x)^T``, the Jacobian of ``c`` at the point ``x``;
- ``\nabla^2 f(x) + \sum_{i=1}^m y_i \nabla^2 c_i(x)``,
  the Hessian of the Lagrangian function at the point ``(x,y)``.

There are many ways to access some of these values, so here is a little
reference guide.

## Reference guide

The following naming should be easy enough to follow.
If not, click on the link and go to the description.

- `!` means inplace;
- `_coord` means coordinate format;
- `_dense` means dense format;
- `prod` means matrix-vector product;
- `_op` means operator (as in [LinearOperators.jl](https://github.com/JuliaSmoothOptimizers/LinearOperators.jl));
- `_lin` and `_nln` respectively refer to linear and nonlinear constraints.

Feel free to open an issue to suggest other methods that should apply to all
NLPModels instances.

| Function          | NLPModels function                                                                                                                                                                                   |
|-------------------|-------------------------------------------|
| ``f(x)``            | [`obj`](@ref), [`objgrad`](@ref), [`objgrad!`](@ref), [`objcons`](@ref), [`objcons!`](@ref) |
| ``\nabla f(x)``     | [`grad`](@ref), [`grad!`](@ref), [`objgrad`](@ref), [`objgrad!`](@ref) |
| ``\nabla^2 f(x)``   | [`hess`](@ref), [`hess_op`](@ref), [`hess_op!`](@ref), [`hess_coord`](@ref), [`hess_coord!`](@ref), [`hess_dense!`](@ref), [`hess_structure`](@ref), [`hess_structure!`](@ref), [`hprod`](@ref), [`hprod!`](@ref) |
| ``c(x)``            | [`cons_lin`](@ref), [`cons_lin!`](@ref), [`cons_nln`](@ref), [`cons_nln!`](@ref), [`cons`](@ref), [`cons!`](@ref), [`objcons`](@ref), [`objcons!`](@ref) |
| ``J(x)``            | [`jac_lin`](@ref), [`jac_nln`](@ref), [`jac`](@ref), [`jac_lin_op`](@ref), [`jac_lin_op!`](@ref), [`jac_nln_op`](@ref), [`jac_nln_op!`](@ref),[`jac_op`](@ref), [`jac_op!`](@ref), [`jac_lin_coord`](@ref), [`jac_lin_coord!`](@ref), [`jac_nln_coord`](@ref), [`jac_nln_coord!`](@ref), [`jac_coord`](@ref), [`jac_coord!`](@ref), [`jac_dense!`](@ref), [`jac_lin_structure`](@ref), [`jac_lin_structure!`](@ref), [`jac_nln_structure`](@ref), [`jac_nln_structure!`](@ref), [`jac_structure`](@ref), [`jprod_lin`](@ref), [`jprod_lin!`](@ref), [`jprod_nln`](@ref), [`jprod_nln!`](@ref), [`jprod`](@ref), [`jprod!`](@ref), [`jtprod_lin`](@ref), [`jtprod_lin!`](@ref), [`jtprod_nln`](@ref), [`jtprod_nln!`](@ref), [`jtprod`](@ref), [`jtprod!`](@ref) |
| ``\nabla^2 L(x,y)`` | [`hess`](@ref), [`hess_op`](@ref), [`hess_coord`](@ref), [`hess_coord!`](@ref), [`hess_dense!`](@ref), [`hess_structure`](@ref), [`hess_structure!`](@ref), [`hprod`](@ref), [`hprod!`](@ref), [`jth_hprod`](@ref), [`jth_hprod!`](@ref), [`jth_hess`](@ref), [`jth_hess_coord`](@ref), [`jth_hess_coord!`](@ref), [`ghjvprod`](@ref), [`ghjvprod!`](@ref)  |

If only a subset of the functions listed above is implemented, you can indicate which ones are not available when creating the [`NLPModelMeta`](@ref), using the keyword arguments
`grad_available`, `jac_available`, `hess_available`, `jprod_available`, `jtprod_available`, and `hprod_available`.
You can also specify whether the Jacobian of the constraints and the Hessian of the objective or Lagrangian are sparse using the keyword arguments `sparse_jacobian` and `sparse_hessian`.

## [API for NLSModels](@id nls-api)

For the Nonlinear Least Squares models, ``f(x) = \tfrac{1}{2} \Vert F(x)\Vert^2``,
and these models have additional function to access the residual value
and its derivatives. Namely,

- ``J_F(x) = \nabla F(x)^T``
- ``\nabla^2 F_i(x)``

| Function            | function |
|---------------------|---|
| ``F(x)``            | [`residual`](@ref), [`residual!`](@ref) |
| ``J_F(x)``          | [`jac_residual`](@ref), [`jac_coord_residual`](@ref), [`jac_coord_residual!`](@ref), [`jac_structure_residual`](@ref), [`jac_structure_residual!`](@ref), [`jprod_residual`](@ref), [`jprod_residual!`](@ref), [`jtprod_residual`](@ref), [`jtprod_residual!`](@ref), [`jac_op_residual`](@ref), [`jac_op_residual!`](@ref) |
| ``\nabla^2 F_i(x)`` | [`hess_residual`](@ref), [`hess_coord_residual`](@ref), [`hess_coord_residual!`](@ref), [`hess_structure_residual`](@ref), [`hess_structure_residual!`](@ref), [`jth_hess_residual`](@ref), [`jth_hess_residual_coord`](@ref), [`jth_hess_residual_coord!`](@ref), [`hprod_residual`](@ref), [`hprod_residual!`](@ref), [`hess_op_residual`](@ref), [`hess_op_residual!`](@ref) |

If only a subset of the functions listed above is implemented, you can indicate which ones are not available when creating the [`NLSMeta`](@ref), using the keyword arguments `jac_residual_available`, `hess_residual_available`, `jprod_residual_available`, `jtprod_residual_available`, and `hprod_residual_available`.
